import * as i0 from '@angular/core';
import { Component, ContentChildren, forwardRef, EventEmitter, Output, Input, NgModule, Injectable, Pipe, Directive, HostBinding, InjectionToken, Inject, HostListener, Injector, ViewChild, ElementRef, Host, SkipSelf, PLATFORM_ID, ContentChild, ViewChildren, Optional, TemplateRef } from '@angular/core';
import * as i1 from '@angular/common';
import { CommonModule, DOCUMENT, isPlatformServer } from '@angular/common';
import { SlideUpDownAnimation, FadeInOutAnimation, CarouselSlideAnimation, ColorTransitionAnimation } from '@mintplayer/ng-animations';
import { Subject, BehaviorSubject, map, takeUntil, filter, take, Observable, combineLatest, debounceTime } from 'rxjs';
import { map as map$1, takeUntil as takeUntil$1, take as take$1 } from 'rxjs/operators';
import { ComponentPortal, TemplatePortal } from '@angular/cdk/portal';
import * as i1$1 from '@angular/cdk/overlay';
import { OverlayModule } from '@angular/cdk/overlay';
import * as i3 from 'ngx-highlightjs';
import { HighlightModule } from 'ngx-highlightjs';
import * as i1$2 from '@mintplayer/ng-click-outside';
import { ClickOutsideDirective, ClickOutsideModule } from '@mintplayer/ng-click-outside';
import { FocusOnLoadModule } from '@mintplayer/ng-focus-on-load';
import * as i1$3 from '@angular/router';
import { RouterModule, ROUTER_CONFIGURATION } from '@angular/router';
import * as i3$1 from '@angular/forms';
import { FormsModule } from '@angular/forms';

class BsAccordionTabComponent {
    constructor(accordion) {
        this.accordion = accordion;
    }
}
BsAccordionTabComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAccordionTabComponent, deps: [{ token: BsAccordionComponent }], target: i0.ɵɵFactoryTarget.Component });
BsAccordionTabComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsAccordionTabComponent, selector: "bs-accordion-tab", queries: [{ propertyName: "childAccordions", predicate: i0.forwardRef(function () { return BsAccordionComponent; }) }], ngImport: i0, template: "<div class=\"card\">\n    <ng-content select=\"bs-accordion-tab-header\"></ng-content>\n    <div class=\"card-block overflow-hidden\" [@slideUpDown] *ngIf=\"accordion.activeTab === this\">\n        <ng-content></ng-content>\n    </div>\n</div>", styles: [".card,.card-header,.card-block{border-radius:0}.card{margin-bottom:-1px}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], animations: [SlideUpDownAnimation] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAccordionTabComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-accordion-tab', animations: [SlideUpDownAnimation], template: "<div class=\"card\">\n    <ng-content select=\"bs-accordion-tab-header\"></ng-content>\n    <div class=\"card-block overflow-hidden\" [@slideUpDown] *ngIf=\"accordion.activeTab === this\">\n        <ng-content></ng-content>\n    </div>\n</div>", styles: [".card,.card-header,.card-block{border-radius:0}.card{margin-bottom:-1px}\n"] }]
        }], ctorParameters: function () { return [{ type: BsAccordionComponent }]; }, propDecorators: { childAccordions: [{
                type: ContentChildren,
                args: [forwardRef(() => BsAccordionComponent)]
            }] } });

class BsAccordionComponent {
    constructor() {
        //#region ActiveTab
        this.activeTabChange = new EventEmitter();
        this._activeTab = null;
    }
    get activeTab() {
        return this._activeTab;
    }
    set activeTab(value) {
        this._activeTab = value;
        this.tabPages.filter((tab) => tab !== value).forEach((tab) => {
            console.log('children', tab.childAccordions);
            tab.childAccordions.forEach((acc) => {
                acc.activeTab = null;
            });
        });
        this.activeTabChange.emit(value);
    }
}
BsAccordionComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAccordionComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsAccordionComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsAccordionComponent, selector: "bs-accordion", inputs: { activeTab: "activeTab" }, outputs: { activeTabChange: "activeTabChange" }, queries: [{ propertyName: "tabPages", predicate: BsAccordionTabComponent }], ngImport: i0, template: "<ng-content></ng-content>", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAccordionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-accordion', template: "<ng-content></ng-content>", styles: [""] }]
        }], propDecorators: { tabPages: [{
                type: ContentChildren,
                args: [BsAccordionTabComponent]
            }], activeTabChange: [{
                type: Output
            }], activeTab: [{
                type: Input
            }] } });

class BsAccordionTabHeaderComponent {
    constructor(accordionTab, accordion) {
        this.accordionTab = accordionTab;
        this.accordion = accordion;
    }
    headerClicked(event) {
        event.preventDefault();
        if (this.accordion.activeTab === this.accordionTab) {
            this.accordion.activeTab = null;
        }
        else {
            this.accordion.activeTab = this.accordionTab;
        }
    }
}
BsAccordionTabHeaderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAccordionTabHeaderComponent, deps: [{ token: BsAccordionTabComponent }, { token: BsAccordionComponent }], target: i0.ɵɵFactoryTarget.Component });
BsAccordionTabHeaderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsAccordionTabHeaderComponent, selector: "bs-accordion-tab-header", ngImport: i0, template: "<div class=\"card-header cursor-pointer\" (click)=\"headerClicked($event)\">\n    <ng-content></ng-content>\n</div>", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAccordionTabHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-accordion-tab-header', template: "<div class=\"card-header cursor-pointer\" (click)=\"headerClicked($event)\">\n    <ng-content></ng-content>\n</div>", styles: [""] }]
        }], ctorParameters: function () { return [{ type: BsAccordionTabComponent }, { type: BsAccordionComponent }]; } });

class BsAccordionModule {
}
BsAccordionModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAccordionModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsAccordionModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAccordionModule, declarations: [BsAccordionComponent,
        BsAccordionTabComponent,
        BsAccordionTabHeaderComponent], imports: [CommonModule], exports: [BsAccordionComponent,
        BsAccordionTabComponent,
        BsAccordionTabHeaderComponent] });
BsAccordionModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAccordionModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAccordionModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsAccordionComponent,
                        BsAccordionTabComponent,
                        BsAccordionTabHeaderComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsAccordionComponent,
                        BsAccordionTabComponent,
                        BsAccordionTabHeaderComponent
                    ]
                }]
        }] });

var Color;
(function (Color) {
    Color[Color["primary"] = 0] = "primary";
    Color[Color["secondary"] = 1] = "secondary";
    Color[Color["success"] = 2] = "success";
    Color[Color["danger"] = 3] = "danger";
    Color[Color["warning"] = 4] = "warning";
    Color[Color["info"] = 5] = "info";
    Color[Color["light"] = 6] = "light";
    Color[Color["dark"] = 7] = "dark";
    Color[Color["body"] = 8] = "body";
    Color[Color["white"] = 9] = "white";
    Color[Color["transparent"] = 10] = "transparent";
})(Color || (Color = {}));

var Position;
(function (Position) {
    Position[Position["top"] = 0] = "top";
    Position[Position["left"] = 1] = "left";
    Position[Position["bottom"] = 2] = "bottom";
    Position[Position["right"] = 3] = "right";
})(Position || (Position = {}));

class BsAlertComponent {
    constructor() {
        this.type = Color.primary;
        this.colors = Color;
        this.isVisible = true;
    }
}
BsAlertComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAlertComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsAlertComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsAlertComponent, selector: "bs-alert", inputs: { type: "type" }, ngImport: i0, template: "<div class=\"mb-3 overflow-hidden\" *ngIf=\"isVisible\" [@fadeInOut]>\n    <div class=\"alert mb-0\" [ngClass]=\"'alert-' + colors[type]\">\n        <ng-content></ng-content>\n    </div>\n</div>", styles: ["::ng-deep .alert .btn{bottom:0;display:inline-flex;align-items:center}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], animations: [FadeInOutAnimation] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAlertComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-alert', animations: [FadeInOutAnimation], template: "<div class=\"mb-3 overflow-hidden\" *ngIf=\"isVisible\" [@fadeInOut]>\n    <div class=\"alert mb-0\" [ngClass]=\"'alert-' + colors[type]\">\n        <ng-content></ng-content>\n    </div>\n</div>", styles: ["::ng-deep .alert .btn{bottom:0;display:inline-flex;align-items:center}\n"] }]
        }], propDecorators: { type: [{
                type: Input
            }] } });

class BsAlertCloseComponent {
    constructor(alert) {
        this.alert = alert;
    }
    closeAlert() {
        this.alert.isVisible = false;
    }
}
BsAlertCloseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAlertCloseComponent, deps: [{ token: BsAlertComponent }], target: i0.ɵɵFactoryTarget.Component });
BsAlertCloseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsAlertCloseComponent, selector: "bs-alert-close", ngImport: i0, template: "<button class=\"btn float-end\" (click)=\"closeAlert()\">\n    <span class=\"text-dark\">\u00D7</span>\n</button>", styles: ["button{top:0;right:0;border:0;position:absolute;padding:.75rem 1.25rem!important;background:transparent}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAlertCloseComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-alert-close', template: "<button class=\"btn float-end\" (click)=\"closeAlert()\">\n    <span class=\"text-dark\">\u00D7</span>\n</button>", styles: ["button{top:0;right:0;border:0;position:absolute;padding:.75rem 1.25rem!important;background:transparent}\n"] }]
        }], ctorParameters: function () { return [{ type: BsAlertComponent }]; } });

class BsAlertModule {
}
BsAlertModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAlertModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsAlertModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAlertModule, declarations: [BsAlertComponent,
        BsAlertCloseComponent], imports: [CommonModule], exports: [BsAlertComponent,
        BsAlertCloseComponent] });
BsAlertModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAlertModule, imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsAlertModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    declarations: [
                        BsAlertComponent,
                        BsAlertCloseComponent
                    ],
                    exports: [
                        BsAlertComponent,
                        BsAlertCloseComponent
                    ]
                }]
        }] });

class BsCalendarMonthService {
    getWeeks(month) {
        const firstAndLast = this.getFirstAndLastDayOfMonth(month);
        const firstOfMonth = this.getMondayBefore(firstAndLast.first);
        const lastOfMonth = this.getSundayAfter(firstAndLast.last);
        const days = this.dateDiff(firstOfMonth, lastOfMonth) + 1;
        const firstDayOffset = (firstAndLast.first.getDay() + 7 - 1) % 7;
        const allDays = this.generateList(days).map(d => d - firstDayOffset).map(d => {
            const wrongDate = new Date(firstAndLast.first.getFullYear(), firstAndLast.first.getMonth(), firstAndLast.first.getDate() + d);
            const correctDate = new Date(wrongDate.getFullYear(), wrongDate.getMonth(), wrongDate.getDate());
            return {
                date: correctDate,
                dayOfMonth: correctDate.getDate(),
                isInMonth: (correctDate.getFullYear() === month.getFullYear()) && (correctDate.getMonth() === month.getMonth())
            };
        });
        const weeks = this.chunk(allDays, 7);
        const weeksMapped = weeks.map((w, i) => {
            var _a;
            return ({
                number: this.weekOfYear(new Date(month.getFullYear(), month.getMonth(), (_a = w.find(d => d.isInMonth)) === null || _a === void 0 ? void 0 : _a.dayOfMonth)),
                days: w
            });
        });
        return weeksMapped;
    }
    generateList(count) {
        return [...Array(count).keys()];
    }
    dayOfWeekMondayBased(date) {
        const d = date.getDay() - 1;
        if (d < 0) {
            return 6;
        }
        else {
            return d;
        }
    }
    weekOfYear(date) {
        const dateClone = new Date(Date.UTC(date.getFullYear(), date.getMonth(), date.getDate()));
        dateClone.setUTCDate(dateClone.getUTCDate() + 4 - (dateClone.getUTCDay() || 7));
        const yearStart = new Date(Date.UTC(dateClone.getUTCFullYear(), 0, 1));
        const utcDiff = this.toUTC(dateClone) - this.toUTC(yearStart);
        return Math.ceil((utcDiff / (1000 * 60 * 60 * 24) + 1) / 7);
    }
    getFirstAndLastDayOfMonth(date) {
        const first = new Date(date.getFullYear(), date.getMonth(), 1);
        const last = new Date(date.getFullYear(), date.getMonth() + 1, 0);
        return { first, last };
    }
    dateDiff(date1, date2) {
        const utc1 = this.toUTC(date1);
        const utc2 = this.toUTC(date2);
        const msPerDay = 1000 * 60 * 60 * 24;
        return Math.floor((utc2 - utc1) / msPerDay);
    }
    dayOfYear(date) {
        const start = new Date(date.getFullYear(), 0, 0);
        return this.dateDiff(start, date);
    }
    toUTC(date) {
        return Date.UTC(date.getFullYear(), date.getMonth(), date.getDate());
    }
    chunk(items, size) {
        const result = [];
        for (let i = 0; i < items.length; i += size) {
            result.push(items.slice(i, i + size));
        }
        return result;
    }
    getMondayBefore(date) {
        const day = date.getDay(), diff = date.getDate() - day + (day == 0 ? -6 : 1); // adjust when day is sunday
        const monday = new Date(date);
        monday.setDate(diff);
        return monday;
    }
    getSundayAfter(date) {
        const day = date.getDay();
        const sunday = new Date(date);
        if (day !== 0) {
            const diff = date.getDate() + 7 - day;
            sunday.setDate(diff);
        }
        return sunday;
    }
}
BsCalendarMonthService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCalendarMonthService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
BsCalendarMonthService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCalendarMonthService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCalendarMonthService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class UcFirstPipe {
    transform(value, ...args) {
        return value[0].toUpperCase() + value.slice(1);
    }
}
UcFirstPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: UcFirstPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
UcFirstPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: UcFirstPipe, name: "ucFirst" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: UcFirstPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'ucFirst'
                }]
        }] });

class MonthNamePipe {
    transform(date, ...args) {
        if (date) {
            return date.toLocaleString("default", { month: 'long' });
        }
        else {
            return '';
        }
    }
}
MonthNamePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: MonthNamePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
MonthNamePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: MonthNamePipe, name: "monthName" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: MonthNamePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monthName'
                }]
        }] });

class BsCalendarComponent {
    constructor(calendarMonthService) {
        this.calendarMonthService = calendarMonthService;
        this.destroyed$ = new Subject();
        //#region CurrentMonth
        this.currentMonth$ = new BehaviorSubject(new Date());
        this.currentMonthChange = new EventEmitter();
        //#endregion
        //#region SelectedDate
        this.selectedDate$ = new BehaviorSubject(new Date());
        this.selectedDateChange = new EventEmitter();
        this.weeks$ = this.currentMonth$
            .pipe(map((month) => this.calendarMonthService.getWeeks(month)))
            .pipe(takeUntil(this.destroyed$));
        this.shownDays$ = this.weeks$
            .pipe(filter((weeks) => weeks.length > 1))
            .pipe(map((weeks) => weeks[1].days))
            .pipe(map((days) => {
            const firstDay = days[0];
            if (firstDay) {
                return days.map((d) => {
                    const date = new Date(firstDay.date.getFullYear(), firstDay.date.getMonth(), d === null || d === void 0 ? void 0 : d.dayOfMonth);
                    return {
                        short: date.toLocaleString('default', { weekday: 'short' }),
                        long: date.toLocaleString('default', { weekday: 'long' })
                    };
                });
            }
            else {
                return [];
            }
        }));
        this.selectedDate$.pipe(takeUntil(this.destroyed$)).subscribe((date) => {
            this.selectedDateChange.emit(date);
        });
        this.currentMonth$.pipe(takeUntil(this.destroyed$)).subscribe((month) => {
            this.currentMonthChange.emit(month);
        });
    }
    get currentMonth() {
        return this.currentMonth$.value;
    }
    set currentMonth(value) {
        this.currentMonth$.next(value);
    }
    get selectedDate() {
        return this.selectedDate$.value;
    }
    set selectedDate(value) {
        this.selectedDate$.next(value);
    }
    //#endregion
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
    previousMonth() {
        this.currentMonth$.pipe(take(1)).subscribe((month) => {
            this.currentMonth$.next(new Date(month.getFullYear(), month.getMonth() - 1, 1));
        });
        return false;
    }
    nextMonth() {
        this.currentMonth$.pipe(take(1)).subscribe((month) => {
            this.currentMonth$.next(new Date(month.getFullYear(), month.getMonth() + 1, 1));
        });
        return false;
    }
    isSameDate(date1, date2) {
        if (date1 === null && date2 === null)
            return true;
        if (date1 === null || date2 === null)
            return false;
        return (date1.getFullYear() === date2.getFullYear() &&
            date1.getMonth() === date2.getMonth() &&
            date1.getDate() === date2.getDate());
    }
    goto(day) {
        if (day) {
            this.selectedDate$.next(day.date);
        }
    }
}
BsCalendarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCalendarComponent, deps: [{ token: BsCalendarMonthService }], target: i0.ɵɵFactoryTarget.Component });
BsCalendarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsCalendarComponent, selector: "bs-calendar", inputs: { currentMonth: "currentMonth", selectedDate: "selectedDate" }, outputs: { currentMonthChange: "currentMonthChange", selectedDateChange: "selectedDateChange" }, ngImport: i0, template: "<table class=\"table w-auto mb-0\">\n    <tr>\n        <td>\n            <button class=\"btn btn-default\" (click)=\"previousMonth()\">\n                <i class=\"bi bi-chevron-left fw-bolder\"></i>\n            </button>\n        </td>\n        <td colspan=\"6\" class=\"fw-bolder\">\n            {{ currentMonth$ | async | monthName | ucFirst }}\n            {{ (currentMonth$ | async)?.getFullYear() }}\n        </td>\n        <td>\n            <button class=\"btn btn-default border-bottom-0\" (click)=\"nextMonth()\">\n                <i class=\"bi bi-chevron-right fw-bolder\"></i>\n            </button>\n        </td>\n    </tr>\n    <tr>\n        <th></th>\n        <th *ngFor=\"let dayOfWeek of shownDays$ | async\" [title]=\"dayOfWeek.long\">\n            {{ dayOfWeek.short }}\n        </th>\n    </tr>\n    <tr *ngFor=\"let week of (weeks$ | async)\">\n        <th>\n            {{ week.number }}\n        </th>\n        <td [class.selected]=\"day === null ? false : isSameDate(selectedDate$ | async, day.date)\" *ngFor=\"let day of week.days\" (click)=\"goto(day)\">\n            <span *ngIf=\"day !== null\" [class.text-muted]=\"!day.isInMonth\">{{ day.dayOfMonth }}</span>\n        </td>\n    </tr>\n</table>", styles: [".text-muted{color:#9ea7af!important}table{border-collapse:collapse;border:1px solid rgba(0,0,0,.125);background:#fff}table td,table th{width:40px;height:40px;text-align:center}table td span,table th span{cursor:pointer;white-space:nowrap}table td.selected{background-color:#0d6efd;color:#fff}table th{background-color:#f8f9fa}table tr{border-top:none}table tr:first-child>td{border-bottom:1px solid rgba(0,0,0,.125)}table tr:nth-of-type(2)>th:not(:nth-of-type(1)){border-bottom:1px solid rgba(0,0,0,.125)}table tr:not(:nth-of-type(2))>th:nth-of-type(1){border-right:1px solid rgba(0,0,0,.125)}\n"], directives: [{ type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], pipes: { "ucFirst": UcFirstPipe, "monthName": MonthNamePipe, "async": i1.AsyncPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCalendarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-calendar', template: "<table class=\"table w-auto mb-0\">\n    <tr>\n        <td>\n            <button class=\"btn btn-default\" (click)=\"previousMonth()\">\n                <i class=\"bi bi-chevron-left fw-bolder\"></i>\n            </button>\n        </td>\n        <td colspan=\"6\" class=\"fw-bolder\">\n            {{ currentMonth$ | async | monthName | ucFirst }}\n            {{ (currentMonth$ | async)?.getFullYear() }}\n        </td>\n        <td>\n            <button class=\"btn btn-default border-bottom-0\" (click)=\"nextMonth()\">\n                <i class=\"bi bi-chevron-right fw-bolder\"></i>\n            </button>\n        </td>\n    </tr>\n    <tr>\n        <th></th>\n        <th *ngFor=\"let dayOfWeek of shownDays$ | async\" [title]=\"dayOfWeek.long\">\n            {{ dayOfWeek.short }}\n        </th>\n    </tr>\n    <tr *ngFor=\"let week of (weeks$ | async)\">\n        <th>\n            {{ week.number }}\n        </th>\n        <td [class.selected]=\"day === null ? false : isSameDate(selectedDate$ | async, day.date)\" *ngFor=\"let day of week.days\" (click)=\"goto(day)\">\n            <span *ngIf=\"day !== null\" [class.text-muted]=\"!day.isInMonth\">{{ day.dayOfMonth }}</span>\n        </td>\n    </tr>\n</table>", styles: [".text-muted{color:#9ea7af!important}table{border-collapse:collapse;border:1px solid rgba(0,0,0,.125);background:#fff}table td,table th{width:40px;height:40px;text-align:center}table td span,table th span{cursor:pointer;white-space:nowrap}table td.selected{background-color:#0d6efd;color:#fff}table th{background-color:#f8f9fa}table tr{border-top:none}table tr:first-child>td{border-bottom:1px solid rgba(0,0,0,.125)}table tr:nth-of-type(2)>th:not(:nth-of-type(1)){border-bottom:1px solid rgba(0,0,0,.125)}table tr:not(:nth-of-type(2))>th:nth-of-type(1){border-right:1px solid rgba(0,0,0,.125)}\n"] }]
        }], ctorParameters: function () { return [{ type: BsCalendarMonthService }]; }, propDecorators: { currentMonthChange: [{
                type: Output
            }], currentMonth: [{
                type: Input
            }], selectedDateChange: [{
                type: Output
            }], selectedDate: [{
                type: Input
            }] } });

class BsMonthNamePipeModule {
}
BsMonthNamePipeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsMonthNamePipeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsMonthNamePipeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsMonthNamePipeModule, declarations: [MonthNamePipe], imports: [CommonModule], exports: [MonthNamePipe] });
BsMonthNamePipeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsMonthNamePipeModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsMonthNamePipeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        MonthNamePipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        MonthNamePipe
                    ]
                }]
        }] });

class BsUcFirstPipeModule {
}
BsUcFirstPipeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsUcFirstPipeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsUcFirstPipeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsUcFirstPipeModule, declarations: [UcFirstPipe], imports: [CommonModule], exports: [UcFirstPipe] });
BsUcFirstPipeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsUcFirstPipeModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsUcFirstPipeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        UcFirstPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        UcFirstPipe
                    ]
                }]
        }] });

class WeekdayNamePipe {
    transform(date, ...args) {
        return date.toLocaleString("default", { weekday: 'short' });
    }
}
WeekdayNamePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: WeekdayNamePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
WeekdayNamePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: WeekdayNamePipe, name: "weekdayName" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: WeekdayNamePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'weekdayName'
                }]
        }] });

class BsWeekdayNameModule {
}
BsWeekdayNameModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsWeekdayNameModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsWeekdayNameModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsWeekdayNameModule, declarations: [WeekdayNamePipe], imports: [CommonModule], exports: [WeekdayNamePipe] });
BsWeekdayNameModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsWeekdayNameModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsWeekdayNameModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        WeekdayNamePipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        WeekdayNamePipe
                    ]
                }]
        }] });

class BsCalendarModule {
}
BsCalendarModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCalendarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsCalendarModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCalendarModule, declarations: [BsCalendarComponent], imports: [CommonModule,
        BsUcFirstPipeModule,
        BsMonthNamePipeModule,
        BsWeekdayNameModule], exports: [BsCalendarComponent] });
BsCalendarModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCalendarModule, imports: [[
            CommonModule,
            BsUcFirstPipeModule,
            BsMonthNamePipeModule,
            BsWeekdayNameModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCalendarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsCalendarComponent
                    ],
                    imports: [
                        CommonModule,
                        BsUcFirstPipeModule,
                        BsMonthNamePipeModule,
                        BsWeekdayNameModule
                    ],
                    exports: [
                        BsCalendarComponent
                    ]
                }]
        }] });

class BsCardComponent {
}
BsCardComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCardComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsCardComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsCardComponent, selector: "bs-card", ngImport: i0, template: "<div class=\"card\">\n    <ng-content select=\"bs-card-header\"></ng-content>\n    <div class=\"card-block\">\n        <ng-content></ng-content>\n    </div>\n</div>", styles: [".card-block{margin:-1px}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCardComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-card', template: "<div class=\"card\">\n    <ng-content select=\"bs-card-header\"></ng-content>\n    <div class=\"card-block\">\n        <ng-content></ng-content>\n    </div>\n</div>", styles: [".card-block{margin:-1px}\n"] }]
        }] });

class BsCardHeaderComponent {
}
BsCardHeaderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCardHeaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsCardHeaderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsCardHeaderComponent, selector: "bs-card-header", ngImport: i0, template: "<div class=\"card-header\">\n    <ng-content></ng-content>\n</div>", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCardHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-card-header', template: "<div class=\"card-header\">\n    <ng-content></ng-content>\n</div>", styles: [""] }]
        }] });

class BsCardModule {
}
BsCardModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCardModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsCardModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCardModule, declarations: [BsCardComponent,
        BsCardHeaderComponent], imports: [CommonModule], exports: [BsCardComponent,
        BsCardHeaderComponent] });
BsCardModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCardModule, imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCardModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    declarations: [
                        BsCardComponent,
                        BsCardHeaderComponent
                    ],
                    exports: [
                        BsCardComponent,
                        BsCardHeaderComponent
                    ]
                }]
        }] });

class BsCarouselImageDirective {
    constructor(templateRef) {
        this.templateRef = templateRef;
        this.itemTemplate = this.templateRef;
    }
}
BsCarouselImageDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCarouselImageDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
BsCarouselImageDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsCarouselImageDirective, selector: "*[bsCarouselImage]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCarouselImageDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '*[bsCarouselImage]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; } });

class BsCarouselComponent {
    constructor() {
        this.animationsDisabled = false;
        this.indicators = true;
        this._animation = 'slide';
        this.destroyed$ = new Subject();
        this.currentImageCounter$ = new BehaviorSubject(-1);
        this.currentImageIndex$ = this.currentImageCounter$
            .pipe(map$1((counter) => {
            const l = this.images.length;
            return ((counter % l) + l) % l;
        }))
            .pipe(takeUntil$1(this.destroyed$));
        this.currentImage$ = this.currentImageIndex$
            .pipe(map$1((index) => { var _a, _b; return (_b = (_a = this.images.get(index)) === null || _a === void 0 ? void 0 : _a.itemTemplate) !== null && _b !== void 0 ? _b : null; }))
            .pipe(takeUntil$1(this.destroyed$));
    }
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
    ngAfterContentInit() {
        if (this.images.length > 0) {
            this.currentImageCounter$.next(0);
        }
        else {
            this.currentImageCounter$.next(-1);
        }
    }
    //#region Animation
    set animation(value) {
        this.animationsDisabled = true;
        this._animation = value;
        setTimeout(() => {
            this.animationsDisabled = false;
        }, 20);
    }
    get animation() {
        return this._animation;
    }
    //#endregion
    previousImage() {
        this.currentImageCounter$
            .pipe(take$1(1))
            .subscribe((currentImageCounter) => {
            this.currentImageCounter$.next(currentImageCounter - 1);
        });
    }
    nextImage() {
        this.currentImageCounter$
            .pipe(take$1(1))
            .subscribe((currentImageCounter) => {
            this.currentImageCounter$.next(currentImageCounter + 1);
        });
    }
    setCurrentImage(index) {
        const currentValue = this.currentImageCounter$.value;
        const l = this.images.length;
        const counterMod = ((currentValue % l) + l) % l;
        const newValue = currentValue - counterMod + index;
        this.currentImageCounter$.next(newValue);
    }
}
BsCarouselComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCarouselComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsCarouselComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsCarouselComponent, selector: "bs-carousel", inputs: { indicators: "indicators", animation: "animation" }, host: { properties: { "@.disabled": "this.animationsDisabled" } }, queries: [{ propertyName: "images", predicate: BsCarouselImageDirective }], ngImport: i0, template: "<div class=\"carousel slide\">\n    <div *ngIf=\"indicators\" class=\"carousel-indicators\">\n        <button *ngFor=\"let image of images; let i = index\" type=\"button\" (click)=\"setCurrentImage(i)\"\n            [class.active]=\"(currentImageIndex$ | async) === i\" data-bs-target\n            [attr.aria-current]=\"(currentImageIndex$ | async) === i ? true : null\"\n            [attr.aria-label]=\"'Slide ' + i\"></button>\n    </div>\n\n    <div class=\"carousel-inner\" [@carouselSlide]=\"currentImageCounter$ | async\" *ngIf=\"animation === 'slide'\">\n        <ng-container *ngFor=\"let image of images; let i = index\">\n            <div class=\"carousel-item\" [class.active]=\"true\" *ngIf=\"(currentImageIndex$ | async) === i\">\n                <ng-container [ngTemplateOutlet]=\"image.itemTemplate\"></ng-container>    \n            </div>\n        </ng-container>\n    </div>\n    <div class=\"carousel-inner\" *ngIf=\"animation === 'fade'\">\n        <ng-container *ngFor=\"let image of images; let i = index\">\n            <div class=\"carousel-item\" [class.active]=\"true\" @fadeInOut *ngIf=\"(currentImageIndex$ | async) === i\">\n                <ng-container [ngTemplateOutlet]=\"image.itemTemplate\"></ng-container>    \n            </div>\n        </ng-container>\n    </div>\n\n    <button class=\"carousel-control-prev\" type=\"button\" (click)=\"previousImage()\">\n        <span class=\"carousel-control-prev-icon\" aria-hidden=\"true\"></span>\n        <span class=\"visually-hidden\">Previous</span>\n    </button>\n    <button class=\"carousel-control-next\" type=\"button\" (click)=\"nextImage()\">\n        <span class=\"carousel-control-next-icon\" aria-hidden=\"true\"></span>\n        <span class=\"visually-hidden\">Next</span>\n    </button>\n</div>", styles: [".carousel{min-height:100px}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], pipes: { "async": i1.AsyncPipe }, animations: [FadeInOutAnimation, CarouselSlideAnimation] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCarouselComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-carousel', animations: [FadeInOutAnimation, CarouselSlideAnimation], template: "<div class=\"carousel slide\">\n    <div *ngIf=\"indicators\" class=\"carousel-indicators\">\n        <button *ngFor=\"let image of images; let i = index\" type=\"button\" (click)=\"setCurrentImage(i)\"\n            [class.active]=\"(currentImageIndex$ | async) === i\" data-bs-target\n            [attr.aria-current]=\"(currentImageIndex$ | async) === i ? true : null\"\n            [attr.aria-label]=\"'Slide ' + i\"></button>\n    </div>\n\n    <div class=\"carousel-inner\" [@carouselSlide]=\"currentImageCounter$ | async\" *ngIf=\"animation === 'slide'\">\n        <ng-container *ngFor=\"let image of images; let i = index\">\n            <div class=\"carousel-item\" [class.active]=\"true\" *ngIf=\"(currentImageIndex$ | async) === i\">\n                <ng-container [ngTemplateOutlet]=\"image.itemTemplate\"></ng-container>    \n            </div>\n        </ng-container>\n    </div>\n    <div class=\"carousel-inner\" *ngIf=\"animation === 'fade'\">\n        <ng-container *ngFor=\"let image of images; let i = index\">\n            <div class=\"carousel-item\" [class.active]=\"true\" @fadeInOut *ngIf=\"(currentImageIndex$ | async) === i\">\n                <ng-container [ngTemplateOutlet]=\"image.itemTemplate\"></ng-container>    \n            </div>\n        </ng-container>\n    </div>\n\n    <button class=\"carousel-control-prev\" type=\"button\" (click)=\"previousImage()\">\n        <span class=\"carousel-control-prev-icon\" aria-hidden=\"true\"></span>\n        <span class=\"visually-hidden\">Previous</span>\n    </button>\n    <button class=\"carousel-control-next\" type=\"button\" (click)=\"nextImage()\">\n        <span class=\"carousel-control-next-icon\" aria-hidden=\"true\"></span>\n        <span class=\"visually-hidden\">Next</span>\n    </button>\n</div>", styles: [".carousel{min-height:100px}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { animationsDisabled: [{
                type: HostBinding,
                args: ['@.disabled']
            }], indicators: [{
                type: Input
            }], images: [{
                type: ContentChildren,
                args: [BsCarouselImageDirective]
            }], animation: [{
                type: Input
            }] } });

class BsCarouselModule {
}
BsCarouselModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCarouselModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsCarouselModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCarouselModule, declarations: [BsCarouselComponent,
        BsCarouselImageDirective], imports: [CommonModule], exports: [BsCarouselComponent,
        BsCarouselImageDirective] });
BsCarouselModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCarouselModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCarouselModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsCarouselComponent,
                        BsCarouselImageDirective
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsCarouselComponent,
                        BsCarouselImageDirective
                    ]
                }]
        }] });

const SNACKBAR_CONTENT = new InjectionToken('SnackbarContent');

class BsSnackbarComponent {
    constructor(content) {
        this.displayBlock = true;
        this.width100 = true;
        this.instance = null;
        //#region Monitor @slideUpDown hooks
        this.animationState = '';
        this.animationStateChanged = new EventEmitter();
        this.content = content;
    }
    onAnimationChanged(event) {
        this.animationStateChanged.emit(event);
    }
}
BsSnackbarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSnackbarComponent, deps: [{ token: SNACKBAR_CONTENT }], target: i0.ɵɵFactoryTarget.Component });
BsSnackbarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsSnackbarComponent, selector: "bs-snackbar", host: { properties: { "class.d-block": "this.displayBlock", "class.w-100": "this.width100" } }, ngImport: i0, template: "<div [@slideUpDown]=\"animationState\"\n     (@slideUpDown.start)=\"onAnimationChanged($event)\"\n     (@slideUpDown.done)=\"onAnimationChanged($event)\">\n\n    <ng-container *ngTemplateOutlet=\"content; context: { $implicit: this }\" ></ng-container>\n</div>", styles: [":host{background:#232323;color:rgba(var(--bs-light-rgb))}\n"], directives: [{ type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], animations: [SlideUpDownAnimation] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSnackbarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-snackbar', animations: [SlideUpDownAnimation], template: "<div [@slideUpDown]=\"animationState\"\n     (@slideUpDown.start)=\"onAnimationChanged($event)\"\n     (@slideUpDown.done)=\"onAnimationChanged($event)\">\n\n    <ng-container *ngTemplateOutlet=\"content; context: { $implicit: this }\" ></ng-container>\n</div>", styles: [":host{background:#232323;color:rgba(var(--bs-light-rgb))}\n"] }]
        }], ctorParameters: function () {
        return [{ type: i0.TemplateRef, decorators: [{
                        type: Inject,
                        args: [SNACKBAR_CONTENT]
                    }] }];
    }, propDecorators: { displayBlock: [{
                type: HostBinding,
                args: ['class.d-block']
            }], width100: [{
                type: HostBinding,
                args: ['class.w-100']
            }] } });

class BsSnackbarCloseDirective {
    constructor(snackbarService) {
        this.snackbarService = snackbarService;
    }
    onClick() {
        this.snackbarService.hide(this.bsSnackbarClose);
    }
}
BsSnackbarCloseDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSnackbarCloseDirective, deps: [{ token: BsSnackbarService }], target: i0.ɵɵFactoryTarget.Directive });
BsSnackbarCloseDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsSnackbarCloseDirective, selector: "[bsSnackbarClose]", inputs: { bsSnackbarClose: "bsSnackbarClose" }, host: { listeners: { "click": "onClick()" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSnackbarCloseDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsSnackbarClose]'
                }]
        }], ctorParameters: function () { return [{ type: BsSnackbarService }]; }, propDecorators: { bsSnackbarClose: [{
                type: Input
            }], onClick: [{
                type: HostListener,
                args: ['click']
            }] } });

class BsSnackbarModule {
}
BsSnackbarModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSnackbarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsSnackbarModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSnackbarModule, declarations: [BsSnackbarComponent,
        BsSnackbarCloseDirective], imports: [CommonModule,
        OverlayModule], exports: [BsSnackbarComponent,
        BsSnackbarCloseDirective] });
BsSnackbarModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSnackbarModule, imports: [[
            CommonModule,
            OverlayModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSnackbarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsSnackbarComponent,
                        BsSnackbarCloseDirective
                    ],
                    imports: [
                        CommonModule,
                        OverlayModule
                    ],
                    exports: [
                        BsSnackbarComponent,
                        BsSnackbarCloseDirective
                    ]
                }]
        }] });

class BsSnackbarService {
    constructor(overlay, parentInjector) {
        this.overlay = overlay;
        this.parentInjector = parentInjector;
    }
    show(template) {
        const injector = Injector.create({
            providers: [{ provide: SNACKBAR_CONTENT, useValue: template }],
            parent: this.parentInjector
        });
        const portal = new ComponentPortal(BsSnackbarComponent, null, injector);
        const overlayRef = this.overlay.create({
            scrollStrategy: this.overlay.scrollStrategies.reposition(),
            positionStrategy: this.overlay.position()
                .global().centerHorizontally().bottom('0'),
            width: '100%'
        });
        const componentInstance = overlayRef.attach(portal);
        componentInstance.instance['instance'] = {
            component: componentInstance,
            overlay: overlayRef
        };
        return componentInstance.instance;
    }
    hide(snackbar) {
        snackbar.animationStateChanged.pipe(filter(ev => ev.phaseName === 'done' && ev.toState === 'void'), take(1)).subscribe(() => {
            var _a;
            (_a = snackbar['instance']) === null || _a === void 0 ? void 0 : _a.overlay.dispose();
        });
        snackbar.animationState = 'void';
    }
}
BsSnackbarService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSnackbarService, deps: [{ token: i1$1.Overlay }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Injectable });
BsSnackbarService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSnackbarService, providedIn: BsSnackbarModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSnackbarService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: BsSnackbarModule
                }]
        }], ctorParameters: function () { return [{ type: i1$1.Overlay }, { type: i0.Injector }]; } });

class BsCopyDirective {
    constructor(doc) {
        this.bsCopy = null;
        this.bsCopied = new EventEmitter();
        this.doc = doc;
    }
    click(event) {
        event.preventDefault();
        const listener = (e) => {
            var _a;
            if (!!this.bsCopy && !!window) {
                const clipboard = e.clipboardData || window['clipboardData'] || null;
                if (clipboard) {
                    clipboard.setData('text', (_a = this.bsCopy) === null || _a === void 0 ? void 0 : _a.toString());
                    e.preventDefault();
                    this.bsCopied.emit(this.bsCopy);
                }
            }
        };
        this.doc.addEventListener('copy', listener, false);
        this.doc.execCommand('copy');
        this.doc.removeEventListener('copy', listener, false);
    }
}
BsCopyDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCopyDirective, deps: [{ token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Directive });
BsCopyDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsCopyDirective, selector: "[bsCopy]", inputs: { bsCopy: "bsCopy" }, outputs: { bsCopied: "bsCopied" }, host: { listeners: { "click": "click($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCopyDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsCopy]',
                }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [DOCUMENT]
                    }] }];
    }, propDecorators: { bsCopy: [{
                type: Input
            }], bsCopied: [{
                type: Output
            }], click: [{
                type: HostListener,
                args: ['click', ['$event']]
            }] } });

class BsCodeSnippetComponent {
    constructor(snackbarService) {
        this.snackbarService = snackbarService;
        this.htmlToCopy = '';
    }
    copiedHtml() {
        const snackbar = this.snackbarService.show(this.copiedTemplate);
        setTimeout(() => this.snackbarService.hide(snackbar), 3000);
    }
}
BsCodeSnippetComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCodeSnippetComponent, deps: [{ token: BsSnackbarService }], target: i0.ɵɵFactoryTarget.Component });
BsCodeSnippetComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsCodeSnippetComponent, selector: "bs-code-snippet", inputs: { htmlToCopy: "htmlToCopy" }, viewQueries: [{ propertyName: "copiedTemplate", first: true, predicate: ["copiedTemplate"], descendants: true }], ngImport: i0, template: "<div class=\"position-relative\">\n    <button #copyBtn [bsCopy]=\"htmlToCopy\" (bsCopied)=\"copiedHtml()\" class=\"btn btn-link rounded-0 text-light position-absolute copy-btn\">\n        Copy html\n    </button>\n    <pre class=\"white-space-normal\">\n        <code class=\"d-block white-space-pre\" [highlight]=\"htmlToCopy\"></code>\n    </pre>\n    <ng-template #copiedTemplate>\n        <div class=\"p-3\">Copied!</div>\n    </ng-template>\n</div>", styles: [".copy-btn{right:0}\n"], directives: [{ type: BsCopyDirective, selector: "[bsCopy]", inputs: ["bsCopy"], outputs: ["bsCopied"] }, { type: i3.Highlight, selector: "[highlight]", inputs: ["highlight", "languages", "lineNumbers"], outputs: ["highlighted"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCodeSnippetComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-code-snippet', template: "<div class=\"position-relative\">\n    <button #copyBtn [bsCopy]=\"htmlToCopy\" (bsCopied)=\"copiedHtml()\" class=\"btn btn-link rounded-0 text-light position-absolute copy-btn\">\n        Copy html\n    </button>\n    <pre class=\"white-space-normal\">\n        <code class=\"d-block white-space-pre\" [highlight]=\"htmlToCopy\"></code>\n    </pre>\n    <ng-template #copiedTemplate>\n        <div class=\"p-3\">Copied!</div>\n    </ng-template>\n</div>", styles: [".copy-btn{right:0}\n"] }]
        }], ctorParameters: function () { return [{ type: BsSnackbarService }]; }, propDecorators: { htmlToCopy: [{
                type: Input
            }], copiedTemplate: [{
                type: ViewChild,
                args: ['copiedTemplate']
            }] } });

class BsCopyModule {
}
BsCopyModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCopyModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsCopyModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCopyModule, declarations: [BsCopyDirective], imports: [CommonModule], exports: [BsCopyDirective] });
BsCopyModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCopyModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCopyModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsCopyDirective
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsCopyDirective
                    ]
                }]
        }] });

class BsCodeSnippetModule {
}
BsCodeSnippetModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCodeSnippetModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsCodeSnippetModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCodeSnippetModule, declarations: [BsCodeSnippetComponent], imports: [CommonModule,
        BsCopyModule,
        HighlightModule], exports: [BsCodeSnippetComponent] });
BsCodeSnippetModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCodeSnippetModule, imports: [[
            CommonModule,
            BsCopyModule,
            HighlightModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsCodeSnippetModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsCodeSnippetComponent
                    ],
                    imports: [
                        CommonModule,
                        BsCopyModule,
                        HighlightModule
                    ],
                    exports: [
                        BsCodeSnippetComponent
                    ]
                }]
        }] });

class BsContextMenuDirective {
    constructor(overlay, templateRef, viewContainerRef, element) {
        this.overlay = overlay;
        this.templateRef = templateRef;
        this.viewContainerRef = viewContainerRef;
        this.element = element;
        this.overlayRef = null;
        this.templatePortal = null;
        this.element.nativeElement.oncontextmenu = (ev) => {
            ev.preventDefault();
            this.checkAndCloseExisting(ev);
            const target = {
                getBoundingClientRect: () => {
                    console.log('getBoundingClientRect', {
                        clientX: ev.clientX,
                        clientY: ev.clientY,
                        scrollY: window.scrollY,
                    });
                    return ({
                        width: 0,
                        height: 0,
                        top: ev.clientY + window.scrollY,
                        left: ev.clientX,
                        bottom: ev.clientY + window.scrollY,
                        right: ev.clientX,
                    });
                },
            };
            const element = new ElementRef(target);
            this.overlayRef = this.overlay.create({
                hasBackdrop: false,
                scrollStrategy: this.overlay.scrollStrategies.reposition(),
                positionStrategy: this.overlay.position()
                    .flexibleConnectedTo(element)
                    .withPositions([
                    { originX: "end", originY: "top", overlayX: "start", overlayY: "top" },
                    { originX: "end", originY: "bottom", overlayX: "start", overlayY: "bottom" },
                    { originX: "start", originY: "top", overlayX: "end", overlayY: "top" },
                    { originX: "start", originY: "bottom", overlayX: "end", overlayY: "bottom" },
                ])
            });
            this.templatePortal = new TemplatePortal(this.templateRef, this.viewContainerRef);
            const view = this.overlayRef.attach(this.templatePortal);
            view.rootNodes.forEach(node => node.classList.add('position-static'));
        };
    }
    clickAnywhere(ev) {
        this.checkAndCloseExisting(ev);
    }
    onBlur() {
        this.close();
    }
    close() {
        if (this.overlayRef) {
            this.overlayRef.detach();
            this.overlayRef.dispose();
            this.overlayRef = null;
        }
    }
    checkAndCloseExisting(ev) {
        if (this.overlayRef && !this.overlayRef.overlayElement.contains(ev.target)) {
            this.close();
        }
    }
}
BsContextMenuDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsContextMenuDirective, deps: [{ token: i1$1.Overlay }, { token: i0.TemplateRef }, { token: i0.ViewContainerRef }, { token: i0.ElementRef, host: true, skipSelf: true }], target: i0.ɵɵFactoryTarget.Directive });
BsContextMenuDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsContextMenuDirective, selector: "[bsContextMenu]", host: { listeners: { "document:click": "clickAnywhere($event)", "window:blur": "onBlur()" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsContextMenuDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsContextMenu]'
                }]
        }], ctorParameters: function () {
        return [{ type: i1$1.Overlay }, { type: i0.TemplateRef }, { type: i0.ViewContainerRef }, { type: i0.ElementRef, decorators: [{
                        type: Host
                    }, {
                        type: SkipSelf
                    }] }];
    }, propDecorators: { clickAnywhere: [{
                type: HostListener,
                args: ['document:click', ['$event']]
            }], onBlur: [{
                type: HostListener,
                args: ['window:blur']
            }] } });

class BsContextMenuModule {
}
BsContextMenuModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsContextMenuModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsContextMenuModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsContextMenuModule, declarations: [BsContextMenuDirective], imports: [CommonModule,
        OverlayModule], exports: [BsContextMenuDirective] });
BsContextMenuModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsContextMenuModule, imports: [[
            CommonModule,
            OverlayModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsContextMenuModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsContextMenuDirective
                    ],
                    imports: [
                        CommonModule,
                        OverlayModule
                    ],
                    exports: [
                        BsContextMenuDirective
                    ]
                }]
        }] });

class BsDatatableColumnDirective {
    constructor(templateRef) {
        this.bsDatatableColumn = { name: '', sortable: true };
        this.templateRef = templateRef;
    }
}
BsDatatableColumnDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDatatableColumnDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
BsDatatableColumnDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsDatatableColumnDirective, selector: "[bsDatatableColumn]", inputs: { bsDatatableColumn: "bsDatatableColumn" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDatatableColumnDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsDatatableColumn]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; }, propDecorators: { bsDatatableColumn: [{
                type: Input
            }] } });

class DatatableSettings {
    constructor(data) {
        this.sortProperty = '';
        this.sortDirection = 'ascending';
        Object.assign(this, data);
        if (data && data.perPage) {
            this.perPage = data.perPage;
        }
        else {
            // Set default value
            this.perPage = {
                values: [10, 20, 50],
                selected: 20
            };
        }
        if (data && data.page) {
            this.page = data.page;
        }
        else {
            // Set default value
            this.page = {
                values: [1],
                selected: 1
            };
        }
    }
    toPagination() {
        const res = {
            sortProperty: this.sortProperty,
            sortDirection: this.sortDirection,
            perPage: this.perPage.selected,
            page: this.page.selected
        };
        return res;
    }
}

class BsPaginationComponent {
    constructor() {
        /** All page numbers. */
        this.pageNumbers$ = new BehaviorSubject([]);
        /** Selected number. */
        this.selectedPageNumber$ = new BehaviorSubject(1);
        /** Number of boxes. */
        this.numberOfBoxes$ = new BehaviorSubject(0);
        /** Display previous/next arrows. */
        this.showArrows$ = new BehaviorSubject(true);
        /** Indicates if first value is selected. */
        this.isFirstPage$ = new Observable();
        /** Indicates if last value is selected. */
        this.isLastPage$ = new Observable();
        /** The number of boxes (excluding arrows) that's being shown on the pagination component. */
        this.visibleNumberOfNumberBoxes$ = new Observable();
        this._selectedPageNumber = 0;
        this._numberOfBoxes = 0;
        this._pageNumbers = [];
        this._showArrows = true;
        //#region SelectedPageNumber
        this.selectedPageNumberChange = new EventEmitter();
        this.destroyed$ = new Subject();
        this.visibleNumberOfNumberBoxes$ = combineLatest([
            this.numberOfBoxes$,
            this.pageNumbers$,
            this.showArrows$,
        ])
            .pipe(takeUntil(this.destroyed$))
            .pipe(map(([numberOfBoxes, pageNumbers, showArrows]) => {
            if (numberOfBoxes <= 0) {
                return pageNumbers.length;
            }
            else if (!showArrows) {
                return Math.min(numberOfBoxes, pageNumbers.length);
            }
            else if (numberOfBoxes <= 2) {
                return Math.min(1, pageNumbers.length);
            }
            else {
                return Math.min(numberOfBoxes - 2, pageNumbers.length);
            }
        }));
        this.shownPageNumbers$ = combineLatest([
            this.pageNumbers$,
            this.selectedPageNumber$,
            this.visibleNumberOfNumberBoxes$,
        ])
            .pipe(takeUntil(this.destroyed$))
            .pipe(map(([pageNumbers, selectedPageNumber, visibleNumberOfNumberBoxes]) => {
            let startIndex = 0;
            const half = Math.round((visibleNumberOfNumberBoxes - 1) / 2);
            if (pageNumbers.indexOf(selectedPageNumber) < half) {
                startIndex = 0;
            }
            else if (pageNumbers.indexOf(selectedPageNumber) >=
                pageNumbers.length - half) {
                startIndex = pageNumbers.length - visibleNumberOfNumberBoxes;
            }
            else {
                startIndex = pageNumbers.indexOf(selectedPageNumber) - half;
            }
            return [...Array(visibleNumberOfNumberBoxes).keys()]
                .map((p) => p + startIndex)
                .map((p) => ({
                page: pageNumbers[p],
                selected: pageNumbers[p] === selectedPageNumber,
            }));
        }));
        this.isFirstPage$ = combineLatest([
            this.pageNumbers$,
            this.selectedPageNumber$,
        ])
            .pipe(takeUntil(this.destroyed$))
            .pipe(map(([pageNumbers, selectedPageNumber]) => {
            return pageNumbers.indexOf(selectedPageNumber) === 0;
        }));
        this.isLastPage$ = combineLatest([
            this.pageNumbers$,
            this.selectedPageNumber$,
        ])
            .pipe(takeUntil(this.destroyed$))
            .pipe(map(([pageNumbers, selectedPageNumber]) => {
            return (pageNumbers.indexOf(selectedPageNumber) === pageNumbers.length - 1);
        }));
        this.selectedPageNumber$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((selectedPageNumber) => {
            this.selectedPageNumberChange.emit(selectedPageNumber);
        });
    }
    set selectedPageNumber(value) {
        this._selectedPageNumber = value;
        this.selectedPageNumber$.next(value);
    }
    get selectedPageNumber() {
        return this._selectedPageNumber;
    }
    //#endregion
    //#region NumberOfBoxes
    set numberOfBoxes(value) {
        this._numberOfBoxes = value;
        this.numberOfBoxes$.next(value);
    }
    get numberOfBoxes() {
        return this._numberOfBoxes;
    }
    //#endregion
    //#region PageNumbers
    set pageNumbers(value) {
        this._pageNumbers = value;
        this.pageNumbers$.next(value);
    }
    get pageNumbers() {
        return this._pageNumbers;
    }
    //#endregion
    //#region ShowArrows
    set showArrows(value) {
        this._showArrows = value;
        this.showArrows$.next(value);
    }
    get showArrows() {
        return this._showArrows;
    }
    //#endregion
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
    onSelectPage(event, page) {
        this.selectedPageNumber$.next(page);
        return false;
    }
    onPrevious() {
        this.selectedPageNumber$.next(this.selectedPageNumber$.value - 1);
        return false;
    }
    onNext() {
        this.selectedPageNumber$.next(this.selectedPageNumber$.value + 1);
        return false;
    }
}
BsPaginationComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsPaginationComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsPaginationComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsPaginationComponent, selector: "bs-pagination", inputs: { selectedPageNumber: "selectedPageNumber", numberOfBoxes: "numberOfBoxes", pageNumbers: "pageNumbers", showArrows: "showArrows" }, outputs: { selectedPageNumberChange: "selectedPageNumberChange" }, ngImport: i0, template: "<ul class=\"pagination\">\n    <li class=\"page-item\" *ngIf=\"showArrows$ | async\" [class.disabled]=\"isFirstPage$ | async\">\n        <a class=\"page-link\" href=\"\" (click)=\"onPrevious()\" aria-label=\"Previous\">\n            <span aria-hidden=\"true\">&laquo;</span>\n            <span class=\"visually-hidden\">Previous</span>\n        </a>\n    </li>\n    <li *ngFor=\"let pageNumber of (shownPageNumbers$ | async)\" class=\"page-item\"\n        [ngClass]=\"{ 'active': pageNumber.selected }\">\n        <a class=\"page-link\" href=\"\" (click)=\"onSelectPage($event, pageNumber.page)\" *ngIf=\"pageNumber.page != '...'\">\n            {{ pageNumber.page }}\n            <span class=\"visually-hidden\" *ngIf=\"pageNumber.selected\">(current)</span>\n        </a>\n    </li>\n    <li class=\"page-item\" *ngIf=\"showArrows$ | async\" [class.disabled]=\"isLastPage$ | async\">\n        <a class=\"page-link\" href=\"\" (click)=\"onNext()\" aria-label=\"Next\">\n            <span aria-hidden=\"true\">&raquo;</span>\n            <span class=\"visually-hidden\">Next</span>\n        </a>\n    </li>\n</ul>", styles: [":host{display:inline-block}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], pipes: { "async": i1.AsyncPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsPaginationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-pagination', template: "<ul class=\"pagination\">\n    <li class=\"page-item\" *ngIf=\"showArrows$ | async\" [class.disabled]=\"isFirstPage$ | async\">\n        <a class=\"page-link\" href=\"\" (click)=\"onPrevious()\" aria-label=\"Previous\">\n            <span aria-hidden=\"true\">&laquo;</span>\n            <span class=\"visually-hidden\">Previous</span>\n        </a>\n    </li>\n    <li *ngFor=\"let pageNumber of (shownPageNumbers$ | async)\" class=\"page-item\"\n        [ngClass]=\"{ 'active': pageNumber.selected }\">\n        <a class=\"page-link\" href=\"\" (click)=\"onSelectPage($event, pageNumber.page)\" *ngIf=\"pageNumber.page != '...'\">\n            {{ pageNumber.page }}\n            <span class=\"visually-hidden\" *ngIf=\"pageNumber.selected\">(current)</span>\n        </a>\n    </li>\n    <li class=\"page-item\" *ngIf=\"showArrows$ | async\" [class.disabled]=\"isLastPage$ | async\">\n        <a class=\"page-link\" href=\"\" (click)=\"onNext()\" aria-label=\"Next\">\n            <span aria-hidden=\"true\">&raquo;</span>\n            <span class=\"visually-hidden\">Next</span>\n        </a>\n    </li>\n</ul>", styles: [":host{display:inline-block}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { selectedPageNumberChange: [{
                type: Output
            }], selectedPageNumber: [{
                type: Input
            }], numberOfBoxes: [{
                type: Input
            }], pageNumbers: [{
                type: Input
            }], showArrows: [{
                type: Input
            }] } });

class BsDatatableComponent {
    constructor() {
        this.columns = [];
        this.reloadData = new EventEmitter();
        this.settings = new DatatableSettings();
        this.settings.sortProperty = '';
        this.settings.sortDirection = 'ascending';
        this.settings.perPage = { values: [10, 20, 50], selected: 20 };
        this.settings.page = { values: [1], selected: 1 };
    }
    columnHeaderClicked(column) {
        if (column.bsDatatableColumn.sortable) {
            if (this.settings.sortProperty !== column.bsDatatableColumn.name) {
                this.settings.sortProperty = column.bsDatatableColumn.name;
                this.settings.sortDirection = 'ascending';
            }
            else if (this.settings.sortDirection === 'descending') {
                this.settings.sortDirection = 'ascending';
            }
            else {
                this.settings.sortDirection = 'descending';
            }
            this.reloadData.emit();
        }
    }
}
BsDatatableComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDatatableComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsDatatableComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsDatatableComponent, selector: "bs-datatable", inputs: { settings: "settings", data: "data" }, outputs: { reloadData: "reloadData" }, queries: [{ propertyName: "columns", predicate: BsDatatableColumnDirective }], ngImport: i0, template: "<div class=\"table-responsive overflow-y-hidden mb-3\">\n    <table class=\"table table-striped table-hover w-100 mb-0\" cellspacing=\"0\" role=\"grid\">\n        <thead>\n            <tr>\n                <th *ngFor=\"let column of columns\" class=\"text-nowrap\"\n                    [class.sort]=\"column.bsDatatableColumn.sortable\"\n                    [class.sort-asc]=\"column.bsDatatableColumn.sortable && (settings.sortProperty === column.bsDatatableColumn.name) && (settings.sortDirection === 'ascending')\"\n                    [class.sort-desc]=\"column.bsDatatableColumn.sortable && (settings.sortProperty === column.bsDatatableColumn.name) && (settings.sortDirection === 'descending')\"\n                    (click)=\"columnHeaderClicked(column)\">\n                    <ng-container *ngTemplateOutlet=\"column.templateRef\"></ng-container>\n                </th>\n            </tr>\n        </thead>\n        <tbody>\n            <ng-container *ngIf=\"!!data && !!rowTemplate\">\n                <ng-container *ngFor=\"let item of data.data\">\n                    <ng-container *ngTemplateOutlet=\"rowTemplate; context: { $implicit: item }\"></ng-container>\n                </ng-container>\n            </ng-container>\n        </tbody>\n    </table>\n</div>\n<div class=\"container-fluid\">\n    <div class=\"row\">\n        <div class=\"col-md-12\">\n            <bs-pagination class=\"float-start\" [pageNumbers]=\"settings.perPage.values\"\n                [(selectedPageNumber)]=\"settings.perPage.selected\" (selectedPageNumberChange)=\"reloadData.emit()\"\n                [showArrows]=\"false\"></bs-pagination>\n            <bs-pagination class=\"float-end\" [pageNumbers]=\"settings.page.values\"\n                [(selectedPageNumber)]=\"settings.page.selected\" (selectedPageNumberChange)=\"reloadData.emit()\"\n                [showArrows]=\"true\"></bs-pagination>\n        </div>\n    </div>\n</div>", styles: ["@charset \"UTF-8\";.overflow-y-hidden{overflow-y:hidden}.table thead th.sort{position:relative;cursor:pointer}.table thead th.sort:before,.table thead th.sort:after{position:absolute;display:block;opacity:.3;bottom:.5em}.table thead th.sort:before{content:\"\\2191\";right:1em}.table thead th.sort:after{content:\"\\2193\";right:.5em}.table thead th.sort.sort-asc:after{opacity:1}.table thead th.sort.sort-desc:before{opacity:1}\n"], components: [{ type: BsPaginationComponent, selector: "bs-pagination", inputs: ["selectedPageNumber", "numberOfBoxes", "pageNumbers", "showArrows"], outputs: ["selectedPageNumberChange"] }], directives: [{ type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDatatableComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-datatable', template: "<div class=\"table-responsive overflow-y-hidden mb-3\">\n    <table class=\"table table-striped table-hover w-100 mb-0\" cellspacing=\"0\" role=\"grid\">\n        <thead>\n            <tr>\n                <th *ngFor=\"let column of columns\" class=\"text-nowrap\"\n                    [class.sort]=\"column.bsDatatableColumn.sortable\"\n                    [class.sort-asc]=\"column.bsDatatableColumn.sortable && (settings.sortProperty === column.bsDatatableColumn.name) && (settings.sortDirection === 'ascending')\"\n                    [class.sort-desc]=\"column.bsDatatableColumn.sortable && (settings.sortProperty === column.bsDatatableColumn.name) && (settings.sortDirection === 'descending')\"\n                    (click)=\"columnHeaderClicked(column)\">\n                    <ng-container *ngTemplateOutlet=\"column.templateRef\"></ng-container>\n                </th>\n            </tr>\n        </thead>\n        <tbody>\n            <ng-container *ngIf=\"!!data && !!rowTemplate\">\n                <ng-container *ngFor=\"let item of data.data\">\n                    <ng-container *ngTemplateOutlet=\"rowTemplate; context: { $implicit: item }\"></ng-container>\n                </ng-container>\n            </ng-container>\n        </tbody>\n    </table>\n</div>\n<div class=\"container-fluid\">\n    <div class=\"row\">\n        <div class=\"col-md-12\">\n            <bs-pagination class=\"float-start\" [pageNumbers]=\"settings.perPage.values\"\n                [(selectedPageNumber)]=\"settings.perPage.selected\" (selectedPageNumberChange)=\"reloadData.emit()\"\n                [showArrows]=\"false\"></bs-pagination>\n            <bs-pagination class=\"float-end\" [pageNumbers]=\"settings.page.values\"\n                [(selectedPageNumber)]=\"settings.page.selected\" (selectedPageNumberChange)=\"reloadData.emit()\"\n                [showArrows]=\"true\"></bs-pagination>\n        </div>\n    </div>\n</div>", styles: ["@charset \"UTF-8\";.overflow-y-hidden{overflow-y:hidden}.table thead th.sort{position:relative;cursor:pointer}.table thead th.sort:before,.table thead th.sort:after{position:absolute;display:block;opacity:.3;bottom:.5em}.table thead th.sort:before{content:\"\\2191\";right:1em}.table thead th.sort:after{content:\"\\2193\";right:.5em}.table thead th.sort.sort-asc:after{opacity:1}.table thead th.sort.sort-desc:before{opacity:1}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { columns: [{
                type: ContentChildren,
                args: [BsDatatableColumnDirective]
            }], settings: [{
                type: Input
            }], data: [{
                type: Input
            }], reloadData: [{
                type: Output
            }] } });

class BsRowTemplateDirective {
    constructor(datatableComponent, templateRef) {
        this.datatableComponent = datatableComponent;
        this.datatableComponent.rowTemplate = templateRef;
    }
}
BsRowTemplateDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsRowTemplateDirective, deps: [{ token: BsDatatableComponent }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
BsRowTemplateDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsRowTemplateDirective, selector: "[bsRowTemplate]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsRowTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsRowTemplate]'
                }]
        }], ctorParameters: function () { return [{ type: BsDatatableComponent }, { type: i0.TemplateRef }]; } });

class BsPaginationModule {
}
BsPaginationModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsPaginationModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsPaginationModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsPaginationModule, declarations: [BsPaginationComponent], imports: [CommonModule], exports: [BsPaginationComponent] });
BsPaginationModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsPaginationModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsPaginationModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsPaginationComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsPaginationComponent
                    ]
                }]
        }] });

class BsDatatableModule {
}
BsDatatableModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDatatableModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsDatatableModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDatatableModule, declarations: [BsDatatableComponent,
        BsRowTemplateDirective,
        BsDatatableColumnDirective], imports: [CommonModule,
        BsPaginationModule], exports: [BsDatatableComponent,
        BsRowTemplateDirective,
        BsDatatableColumnDirective] });
BsDatatableModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDatatableModule, imports: [[
            CommonModule,
            BsPaginationModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDatatableModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsDatatableComponent,
                        BsRowTemplateDirective,
                        BsDatatableColumnDirective
                    ],
                    imports: [
                        CommonModule,
                        BsPaginationModule
                    ],
                    exports: [
                        BsDatatableComponent,
                        BsRowTemplateDirective,
                        BsDatatableColumnDirective
                    ]
                }]
        }] });

class BsDropdownMenuDirective extends ClickOutsideDirective {
    constructor(dropdown, viewContainerRef, templateRef, overlay, elementRef, zone, platformId) {
        super(elementRef, zone, platformId);
        this.dropdown = dropdown;
        this.viewContainerRef = viewContainerRef;
        this.templateRef = templateRef;
        this.overlay = overlay;
        this.wait = false;
        this.destroyed$ = new Subject();
        this.overlayRef = null;
        this.templatePortal = null;
        this.dropdown.isOpen$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((isOpen) => {
            if (isOpen) {
                this.wait = true;
                setTimeout(() => this.wait = false, 100);
                this.overlayRef = this.overlay.create({
                    hasBackdrop: this.dropdown.hasBackdrop,
                    scrollStrategy: this.overlay.scrollStrategies.reposition(),
                    positionStrategy: this.overlay.position()
                        .flexibleConnectedTo(!this.dropdown.toggle ? dropdown.elementRef : this.dropdown.toggle.toggleButton)
                        .withPositions([
                        // element: BottomLeft - dropdown: TopLeft
                        { originX: "start", originY: "bottom", overlayX: "start", overlayY: "top", offsetY: 0 },
                        // element: TopLeft - dropdown: BottomLeft
                        { originX: "start", originY: "top", overlayX: "start", overlayY: "bottom", offsetY: 0 },
                    ]),
                });
                if (this.dropdown.hasBackdrop && this.dropdown.closeOnClickOutside) {
                    this.overlayRef.backdropClick().subscribe(() => {
                        this.dropdown.isOpen = false;
                    });
                }
                this.templatePortal = new TemplatePortal(this.templateRef, this.viewContainerRef);
                const view = this.overlayRef.attach(this.templatePortal);
                if (this.dropdown.sameDropdownWidth) {
                    const width = this.dropdown.elementRef.nativeElement.offsetWidth;
                    view.rootNodes[0].style.width = width + 'px';
                }
            }
            else {
                if (this.overlayRef) {
                    this.overlayRef.detach();
                    this.overlayRef.dispose();
                    this.overlayRef = null;
                }
            }
        });
    }
    get show() { return this.dropdown.isOpen; }
    clickedOutside(ev) {
        var _a;
        if (!this.wait) {
            if (!((_a = this.overlayRef) === null || _a === void 0 ? void 0 : _a.overlayElement.contains(ev.target))) {
                this.dropdown.isOpen$.pipe(take(1)).subscribe((isOpen) => {
                    if (isOpen && !this.dropdown.hasBackdrop && this.dropdown.closeOnClickOutside) {
                        this.dropdown.isOpen = false;
                    }
                });
            }
        }
    }
}
BsDropdownMenuDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDropdownMenuDirective, deps: [{ token: forwardRef(() => BsDropdownDirective) }, { token: i0.ViewContainerRef }, { token: i0.TemplateRef }, { token: i1$1.Overlay }, { token: i0.ElementRef }, { token: i0.NgZone }, { token: PLATFORM_ID }], target: i0.ɵɵFactoryTarget.Directive });
BsDropdownMenuDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsDropdownMenuDirective, selector: "[bsDropdownMenu]", host: { listeners: { "clickOutside": "clickedOutside($event)" }, properties: { "class.show": "this.show" } }, usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDropdownMenuDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsDropdownMenu]'
                }]
        }], ctorParameters: function () {
        return [{ type: BsDropdownDirective, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => BsDropdownDirective)]
                    }] }, { type: i0.ViewContainerRef }, { type: i0.TemplateRef }, { type: i1$1.Overlay }, { type: i0.ElementRef }, { type: i0.NgZone }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [PLATFORM_ID]
                    }] }];
    }, propDecorators: { show: [{
                type: HostBinding,
                args: ['class.show']
            }], clickedOutside: [{
                type: HostListener,
                args: ['clickOutside', ['$event']]
            }] } });

class BsDropdownToggleDirective {
    constructor(dropdown, toggleButton) {
        this.dropdown = dropdown;
        this.toggleButton = toggleButton;
    }
    onClick() {
        this.dropdown.isOpen$.pipe(take(1)).subscribe((isOpen) => {
            this.dropdown.isOpen$.next(!isOpen);
        });
    }
}
BsDropdownToggleDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDropdownToggleDirective, deps: [{ token: BsDropdownDirective }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
BsDropdownToggleDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsDropdownToggleDirective, selector: "[bsDropdownToggle]", host: { listeners: { "click": "onClick()" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDropdownToggleDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsDropdownToggle]'
                }]
        }], ctorParameters: function () { return [{ type: BsDropdownDirective }, { type: i0.ElementRef }]; }, propDecorators: { onClick: [{
                type: HostListener,
                args: ['click']
            }] } });

class BsDropdownDirective {
    constructor(elementRef) {
        this.isOpen$ = new BehaviorSubject(false);
        this.toggle = null;
        this.hasBackdrop = false;
        this.sameWidth = false;
        this.closeOnClickOutside = false;
        this.sameDropdownWidth = false;
        this.isOpenChange = new EventEmitter();
        this.elementRef = elementRef;
    }
    //#region IsOpen
    get isOpen() {
        return this.isOpen$.value;
    }
    set isOpen(value) {
        if (this.isOpen$.value !== value) {
            this.isOpen$.next(value);
            this.isOpenChange.emit(value);
        }
    }
    //#endregion
    onBlur() {
        this.isOpen = false;
    }
}
BsDropdownDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDropdownDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
BsDropdownDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsDropdownDirective, selector: "[bsDropdown]", inputs: { hasBackdrop: "hasBackdrop", sameWidth: "sameWidth", closeOnClickOutside: "closeOnClickOutside", sameDropdownWidth: "sameDropdownWidth", isOpen: "isOpen" }, outputs: { isOpenChange: "isOpenChange" }, host: { listeners: { "window:blur": "onBlur()" } }, queries: [{ propertyName: "menu", first: true, predicate: BsDropdownMenuDirective, descendants: true }, { propertyName: "toggle", first: true, predicate: BsDropdownToggleDirective, descendants: true }], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDropdownDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsDropdown]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { menu: [{
                type: ContentChild,
                args: [BsDropdownMenuDirective, { static: false }]
            }], toggle: [{
                type: ContentChild,
                args: [BsDropdownToggleDirective, { static: false }]
            }], hasBackdrop: [{
                type: Input
            }], sameWidth: [{
                type: Input
            }], closeOnClickOutside: [{
                type: Input
            }], sameDropdownWidth: [{
                type: Input
            }], isOpenChange: [{
                type: Output
            }], isOpen: [{
                type: Input
            }], onBlur: [{
                type: HostListener,
                args: ['window:blur']
            }] } });

class BsDatepickerComponent {
    constructor() {
        //#region SelectedDate
        this._selectedDate = new Date();
        this.selectedDateChange = new EventEmitter();
        //#endregion
        //#region CurrentMonth
        this._currentMonth = new Date();
        this.currentMonthChange = new EventEmitter();
    }
    get selectedDate() {
        return this._selectedDate;
    }
    set selectedDate(value) {
        this._selectedDate = value;
        this.selectedDateChange.emit(value);
    }
    get currentMonth() {
        return this._currentMonth;
    }
    set currentMonth(value) {
        this._currentMonth = value;
        this.currentMonthChange.emit(value);
    }
}
BsDatepickerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDatepickerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsDatepickerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsDatepickerComponent, selector: "bs-datepicker", inputs: { selectedDate: "selectedDate", currentMonth: "currentMonth" }, outputs: { selectedDateChange: "selectedDateChange", currentMonthChange: "currentMonthChange" }, ngImport: i0, template: "<div bsDropdown [hasBackdrop]=\"true\" [closeOnClickOutside]=\"true\">\n    <button bsDropdownToggle class=\"btn btn-primary\">{{ selectedDate | date }}</button>\n    <div *bsDropdownMenu>\n        <bs-calendar [(selectedDate)]=\"selectedDate\" [(currentMonth)]=\"currentMonth\"></bs-calendar>\n    </div>\n</div>", styles: [""], components: [{ type: BsCalendarComponent, selector: "bs-calendar", inputs: ["currentMonth", "selectedDate"], outputs: ["currentMonthChange", "selectedDateChange"] }], directives: [{ type: BsDropdownDirective, selector: "[bsDropdown]", inputs: ["hasBackdrop", "sameWidth", "closeOnClickOutside", "sameDropdownWidth", "isOpen"], outputs: ["isOpenChange"] }, { type: BsDropdownToggleDirective, selector: "[bsDropdownToggle]" }, { type: BsDropdownMenuDirective, selector: "[bsDropdownMenu]" }], pipes: { "date": i1.DatePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDatepickerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-datepicker', template: "<div bsDropdown [hasBackdrop]=\"true\" [closeOnClickOutside]=\"true\">\n    <button bsDropdownToggle class=\"btn btn-primary\">{{ selectedDate | date }}</button>\n    <div *bsDropdownMenu>\n        <bs-calendar [(selectedDate)]=\"selectedDate\" [(currentMonth)]=\"currentMonth\"></bs-calendar>\n    </div>\n</div>", styles: [""] }]
        }], propDecorators: { selectedDateChange: [{
                type: Output
            }], selectedDate: [{
                type: Input
            }], currentMonthChange: [{
                type: Output
            }], currentMonth: [{
                type: Input
            }] } });

class BsDropdownModule {
}
BsDropdownModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDropdownModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsDropdownModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDropdownModule, declarations: [BsDropdownDirective,
        BsDropdownToggleDirective,
        BsDropdownMenuDirective], imports: [CommonModule,
        OverlayModule,
        ClickOutsideModule], exports: [BsDropdownDirective,
        BsDropdownToggleDirective,
        BsDropdownMenuDirective] });
BsDropdownModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDropdownModule, imports: [[
            CommonModule,
            OverlayModule,
            ClickOutsideModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDropdownModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsDropdownDirective,
                        BsDropdownToggleDirective,
                        BsDropdownMenuDirective
                    ],
                    imports: [
                        CommonModule,
                        OverlayModule,
                        ClickOutsideModule
                    ],
                    exports: [
                        BsDropdownDirective,
                        BsDropdownToggleDirective,
                        BsDropdownMenuDirective
                    ]
                }]
        }] });

class BsDatepickerModule {
}
BsDatepickerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDatepickerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsDatepickerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDatepickerModule, declarations: [BsDatepickerComponent], imports: [CommonModule,
        BsCalendarModule,
        BsDropdownModule], exports: [BsDatepickerComponent] });
BsDatepickerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDatepickerModule, imports: [[
            CommonModule,
            BsCalendarModule,
            BsDropdownModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsDatepickerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsDatepickerComponent
                    ],
                    imports: [
                        CommonModule,
                        BsCalendarModule,
                        BsDropdownModule
                    ],
                    exports: [
                        BsDatepickerComponent
                    ]
                }]
        }] });

class BsProgressComponent {
    constructor() {
        this.progressClass = true;
        this.height = null;
        this.isIndeterminate = false;
    }
}
BsProgressComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsProgressComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsProgressComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsProgressComponent, selector: "bs-progress", inputs: { height: "height", isIndeterminate: "isIndeterminate" }, host: { properties: { "class.progress": "this.progressClass", "style.height.px": "this.height" } }, ngImport: i0, template: "<ng-content *ngIf=\"!isIndeterminate\"></ng-content>\n<div *ngIf=\"isIndeterminate\" class=\"progress-bar progress-bar-infinite\" role=\"progressbar\" aria-valuenow=\"infinite\"></div>", styles: ["@keyframes progress-infinite{0%{width:10%;margin-left:0%}25%{width:70%;margin-left:15%}50%{width:10%;margin-left:90%}75%{width:70%;margin-left:15%}to{width:10%;margin-left:0%}}.progress-bar-infinite{animation:progress-infinite 1.5s infinite}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsProgressComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-progress', template: "<ng-content *ngIf=\"!isIndeterminate\"></ng-content>\n<div *ngIf=\"isIndeterminate\" class=\"progress-bar progress-bar-infinite\" role=\"progressbar\" aria-valuenow=\"infinite\"></div>", styles: ["@keyframes progress-infinite{0%{width:10%;margin-left:0%}25%{width:70%;margin-left:15%}50%{width:10%;margin-left:90%}75%{width:70%;margin-left:15%}to{width:10%;margin-left:0%}}.progress-bar-infinite{animation:progress-infinite 1.5s infinite}\n"] }]
        }], propDecorators: { progressClass: [{
                type: HostBinding,
                args: ['class.progress']
            }], height: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['style.height.px']
            }], isIndeterminate: [{
                type: Input
            }] } });

class BsProgressBarComponent {
    constructor() {
        this.destroyed$ = new Subject();
        this.minimum$ = new BehaviorSubject(0);
        this.maximum$ = new BehaviorSubject(100);
        this.value$ = new BehaviorSubject(50);
        this.color$ = new BehaviorSubject(Color.primary);
        this.striped = false;
        this.animated = false;
        this.progressBar = true;
        this.colorClass = 'bg-primary';
        this.widthStyle = '0';
        this.role = 'progressbar';
        this.valueNow = 50;
        this.valueMin = 0;
        this.valueMax = 100;
        this.percentage$ = combineLatest([this.minimum$, this.maximum$, this.value$])
            .pipe(map(([minimum, maximum, value]) => {
            return (value - minimum) / (maximum - minimum) * 100;
        }));
        this.width$ = this.percentage$
            .pipe(map((width) => {
            return String(width) + '%';
        }));
        this.colorClass$ = this.color$
            .pipe(map((color) => {
            const name = Color[color];
            return `bg-${name}`;
        }));
        this.colorClass$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((color) => {
            this.colorClass = color;
        });
        this.width$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((width) => {
            this.widthStyle = width;
        });
        this.value$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((value) => {
            this.valueNow = value;
        });
        this.minimum$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((value) => {
            this.valueMin = value;
        });
        this.maximum$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((value) => {
            this.valueMax = value;
        });
    }
    set minimum(value) {
        this.minimum$.next(value);
    }
    set maximum(value) {
        this.maximum$.next(value);
    }
    set value(value) {
        this.value$.next(value);
    }
    set color(value) {
        this.color$.next(value);
    }
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
}
BsProgressBarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsProgressBarComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsProgressBarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsProgressBarComponent, selector: "bs-progress-bar", inputs: { minimum: "minimum", maximum: "maximum", value: "value", color: "color", striped: "striped", animated: "animated" }, host: { properties: { "class.progress-bar-striped": "this.striped", "class.progress-bar-animated": "this.animated", "class.progress-bar": "this.progressBar", "class": "this.colorClass", "style.width": "this.widthStyle", "attr.role": "this.role", "attr.aria-valuenow": "this.valueNow", "attr.aria-valuemin": "this.valueMin", "attr.aria-valuemax": "this.valueMax" } }, ngImport: i0, template: "", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsProgressBarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-progress-bar', template: "", styles: [""] }]
        }], ctorParameters: function () { return []; }, propDecorators: { minimum: [{
                type: Input
            }], maximum: [{
                type: Input
            }], value: [{
                type: Input
            }], color: [{
                type: Input
            }], striped: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.progress-bar-striped']
            }], animated: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.progress-bar-animated']
            }], progressBar: [{
                type: HostBinding,
                args: ['class.progress-bar']
            }], colorClass: [{
                type: HostBinding,
                args: ['class']
            }], widthStyle: [{
                type: HostBinding,
                args: ['style.width']
            }], role: [{
                type: HostBinding,
                args: ['attr.role']
            }], valueNow: [{
                type: HostBinding,
                args: ['attr.aria-valuenow']
            }], valueMin: [{
                type: HostBinding,
                args: ['attr.aria-valuemin']
            }], valueMax: [{
                type: HostBinding,
                args: ['attr.aria-valuemax']
            }] } });

class BsForDirective {
    constructor() {
        this.defaultCursor = true;
    }
    onMouseClick() {
        if (!('tagName' in this.bsFor)) {
            this.bsFor.focus();
        }
        else if (this.bsFor.tagName.toLowerCase() !== 'input') {
            this.bsFor.focus();
        }
        else if (this.bsFor.type.toLowerCase() === 'file') {
            this.bsFor.click();
        }
        else {
            this.bsFor.focus();
        }
    }
}
BsForDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsForDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
BsForDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsForDirective, selector: "[bsFor]", inputs: { bsFor: "bsFor" }, host: { listeners: { "click": "onMouseClick()" }, properties: { "class.cursor-default": "this.defaultCursor" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsForDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsFor]'
                }]
        }], propDecorators: { defaultCursor: [{
                type: HostBinding,
                args: ['class.cursor-default']
            }], bsFor: [{
                type: Input
            }], onMouseClick: [{
                type: HostListener,
                args: ['click']
            }] } });

class BsFormatBytesPipe {
    transform(value, decimals = 2) {
        if (value === 0) {
            return "0 Bytes";
        }
        const k = 1024;
        const dm = decimals <= 0 ? 0 : decimals;
        const sizes = ["Bytes", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"];
        const i = Math.floor(Math.log(value) / Math.log(k));
        return parseFloat((value / Math.pow(k, i)).toFixed(dm)) + " " + sizes[i];
    }
}
BsFormatBytesPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFormatBytesPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
BsFormatBytesPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFormatBytesPipe, name: "bsFormatBytes" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFormatBytesPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'bsFormatBytes'
                }]
        }] });

class BsFileUploadComponent {
    constructor() {
        this.dropFilesCaption = 'Drop your files here';
        this.browseFilesCaption = 'Browse for files';
        this.placeholder = 'Drop files to upload';
        this.isDraggingFile = false;
        this.files = [];
        this.filesDropped = new EventEmitter();
    }
    onChange(event) {
        if (!event.target)
            return;
        if (!('files' in event.target))
            return;
        if (!event.target['files'])
            return;
        const files = event.target.files;
        if (!files)
            return;
        this.processDroppedFiles(files);
    }
    onDragOver(event) {
        event.preventDefault();
        event.stopPropagation();
        if (event.dataTransfer) {
            this.isDraggingFile = true;
            event.dataTransfer.effectAllowed = "copy";
        }
    }
    onDragLeave(event) {
        event.preventDefault();
        event.stopPropagation();
        this.isDraggingFile = false;
    }
    onDrop(event) {
        event.preventDefault();
        event.stopPropagation();
        this.isDraggingFile = false;
        if (event.dataTransfer && event.dataTransfer.files) {
            this.processDroppedFiles(event.dataTransfer.files);
        }
    }
    processDroppedFiles(fileList) {
        const newFiles = [...Array(fileList.length).keys()]
            .map(i => fileList.item(i))
            .filter(f => !!f)
            .map(f => ({ file: f, progress: 0 }));
        this.files.push(...newFiles);
        this.filesDropped.emit(newFiles);
    }
}
BsFileUploadComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFileUploadComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsFileUploadComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsFileUploadComponent, selector: "bs-file-upload", inputs: { dropFilesCaption: "dropFilesCaption", browseFilesCaption: "browseFilesCaption", placeholder: "placeholder", files: "files" }, outputs: { filesDropped: "filesDropped" }, host: { listeners: { "dragover": "onDragOver($event)", "dragleave": "onDragLeave($event)", "drop": "onDrop($event)" } }, ngImport: i0, template: "<div class=\"dropzone border position-relative p-5\" [class.dragging]=\"isDraggingFile\">\n    <input type=\"file\" multiple #fileUpload (change)=\"onChange($event)\" [title]=\"placeholder\" [placeholder]=\"placeholder\" class=\"position-absolute w-100 h-100\">\n    <!-- <img src=\"/assets/ic-file-upload.svg\" [alt]=\"placeholder\"> -->\n    <span class=\"h3 d-block\">{{ dropFilesCaption }}</span>\n    <label class=\"btn btn-primary position-relative\" [bsFor]=\"fileUpload\">{{ browseFilesCaption }}</label>\n</div>\n<ul class=\"list-group files-list\">\n    <li class=\"list-group-item\" *ngFor=\"let upload of files\">\n        <ng-container *ngTemplateOutlet=\"fileTemplate ?? defaultFileTemplate; context: { $implicit: upload }\"></ng-container>\n    </li>\n</ul>\n\n<ng-template #defaultFileTemplate let-upload>\n    <div class=\"d-flex flex-row mx-auto\">\n        <div class=\"file-img\"></div>\n        <div class=\"flex-grow-1 text-start px-2\">\n            <span class=\"d-block text-truncate text-secondary\">{{ upload.file.name }}</span>\n            <span class=\"d-block text-grey mb-0\">{{ upload.file.size | bsFormatBytes }}</span>\n            <bs-progress [height]=\"4\">\n                <bs-progress-bar [minimum]=\"0\" [maximum]=\"upload.file.size\" [value]=\"upload.progress\"></bs-progress-bar>\n            </bs-progress>\n        </div>\n    </div>\n</ng-template>", styles: [".dropzone{z-index:1}.dropzone.dragging{border:4px solid #CB1535!important;background:#DC88A8;margin:-3px -3px -4px}.dropzone input{opacity:0;z-index:2;top:0;left:0}.dropzone .btn{z-index:5}.files-list{margin-top:-1px}.files-list .d-flex{max-width:400px}.text-grey{color:#999}.list-group span{margin:-5px auto}\n"], components: [{ type: BsProgressComponent, selector: "bs-progress", inputs: ["height", "isIndeterminate"] }, { type: BsProgressBarComponent, selector: "bs-progress-bar", inputs: ["minimum", "maximum", "value", "color", "striped", "animated"] }], directives: [{ type: BsForDirective, selector: "[bsFor]", inputs: ["bsFor"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], pipes: { "bsFormatBytes": BsFormatBytesPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFileUploadComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-file-upload', template: "<div class=\"dropzone border position-relative p-5\" [class.dragging]=\"isDraggingFile\">\n    <input type=\"file\" multiple #fileUpload (change)=\"onChange($event)\" [title]=\"placeholder\" [placeholder]=\"placeholder\" class=\"position-absolute w-100 h-100\">\n    <!-- <img src=\"/assets/ic-file-upload.svg\" [alt]=\"placeholder\"> -->\n    <span class=\"h3 d-block\">{{ dropFilesCaption }}</span>\n    <label class=\"btn btn-primary position-relative\" [bsFor]=\"fileUpload\">{{ browseFilesCaption }}</label>\n</div>\n<ul class=\"list-group files-list\">\n    <li class=\"list-group-item\" *ngFor=\"let upload of files\">\n        <ng-container *ngTemplateOutlet=\"fileTemplate ?? defaultFileTemplate; context: { $implicit: upload }\"></ng-container>\n    </li>\n</ul>\n\n<ng-template #defaultFileTemplate let-upload>\n    <div class=\"d-flex flex-row mx-auto\">\n        <div class=\"file-img\"></div>\n        <div class=\"flex-grow-1 text-start px-2\">\n            <span class=\"d-block text-truncate text-secondary\">{{ upload.file.name }}</span>\n            <span class=\"d-block text-grey mb-0\">{{ upload.file.size | bsFormatBytes }}</span>\n            <bs-progress [height]=\"4\">\n                <bs-progress-bar [minimum]=\"0\" [maximum]=\"upload.file.size\" [value]=\"upload.progress\"></bs-progress-bar>\n            </bs-progress>\n        </div>\n    </div>\n</ng-template>", styles: [".dropzone{z-index:1}.dropzone.dragging{border:4px solid #CB1535!important;background:#DC88A8;margin:-3px -3px -4px}.dropzone input{opacity:0;z-index:2;top:0;left:0}.dropzone .btn{z-index:5}.files-list{margin-top:-1px}.files-list .d-flex{max-width:400px}.text-grey{color:#999}.list-group span{margin:-5px auto}\n"] }]
        }], propDecorators: { dropFilesCaption: [{
                type: Input
            }], browseFilesCaption: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], files: [{
                type: Input
            }], filesDropped: [{
                type: Output
            }], onDragOver: [{
                type: HostListener,
                args: ['dragover', ['$event']]
            }], onDragLeave: [{
                type: HostListener,
                args: ['dragleave', ['$event']]
            }], onDrop: [{
                type: HostListener,
                args: ['drop', ['$event']]
            }] } });

class BsFileUploadTemplateDirective {
    constructor(fileUploadComponent, templateRef) {
        fileUploadComponent.fileTemplate = templateRef;
    }
}
BsFileUploadTemplateDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFileUploadTemplateDirective, deps: [{ token: BsFileUploadComponent }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
BsFileUploadTemplateDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsFileUploadTemplateDirective, selector: "[bsFileUploadTemplate]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFileUploadTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsFileUploadTemplate]'
                }]
        }], ctorParameters: function () { return [{ type: BsFileUploadComponent }, { type: i0.TemplateRef }]; } });

class BsForModule {
}
BsForModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsForModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsForModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsForModule, declarations: [BsForDirective], imports: [CommonModule], exports: [BsForDirective] });
BsForModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsForModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsForModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsForDirective
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsForDirective
                    ]
                }]
        }] });

class BsProgressBarModule {
}
BsProgressBarModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsProgressBarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsProgressBarModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsProgressBarModule, declarations: [BsProgressBarComponent,
        BsProgressComponent], imports: [CommonModule], exports: [BsProgressBarComponent,
        BsProgressComponent] });
BsProgressBarModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsProgressBarModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsProgressBarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsProgressBarComponent,
                        BsProgressComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsProgressBarComponent,
                        BsProgressComponent
                    ]
                }]
        }] });

class BsFormatBytesModule {
}
BsFormatBytesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFormatBytesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsFormatBytesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFormatBytesModule, declarations: [BsFormatBytesPipe], imports: [CommonModule], exports: [BsFormatBytesPipe] });
BsFormatBytesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFormatBytesModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFormatBytesModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsFormatBytesPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsFormatBytesPipe
                    ]
                }]
        }] });

class BsFileUploadModule {
}
BsFileUploadModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFileUploadModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsFileUploadModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFileUploadModule, declarations: [BsFileUploadComponent,
        BsFileUploadTemplateDirective], imports: [CommonModule,
        BsForModule,
        BsFormatBytesModule,
        BsProgressBarModule], exports: [BsFileUploadComponent,
        BsFileUploadTemplateDirective] });
BsFileUploadModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFileUploadModule, imports: [[
            CommonModule,
            BsForModule,
            BsFormatBytesModule,
            BsProgressBarModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFileUploadModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsFileUploadComponent,
                        BsFileUploadTemplateDirective
                    ],
                    imports: [
                        CommonModule,
                        BsForModule,
                        BsFormatBytesModule,
                        BsProgressBarModule
                    ],
                    exports: [
                        BsFileUploadComponent,
                        BsFileUploadTemplateDirective
                    ]
                }]
        }] });

var ESchedulerMode;
(function (ESchedulerMode) {
    ESchedulerMode[ESchedulerMode["week"] = 0] = "week";
    ESchedulerMode[ESchedulerMode["timeline"] = 1] = "timeline";
})(ESchedulerMode || (ESchedulerMode = {}));

var EDragOperation;
(function (EDragOperation) {
    EDragOperation[EDragOperation["none"] = 0] = "none";
    EDragOperation[EDragOperation["createEvent"] = 1] = "createEvent";
    EDragOperation[EDragOperation["resizeEvent"] = 2] = "resizeEvent";
    EDragOperation[EDragOperation["moveEvent"] = 3] = "moveEvent";
})(EDragOperation || (EDragOperation = {}));

class BsTimelineService {
    splitInParts(event) {
        let startTime = event.start;
        const result = [];
        const eventOrNull = 'color' in event ? event : null;
        while (!this.dateEquals(startTime, event.end)) {
            const end = new Date(startTime.getFullYear(), startTime.getMonth(), startTime.getDate() + 1, 0, 0, 0);
            result.push({ start: startTime, end: end, event: eventOrNull });
            startTime = end;
        }
        if (startTime != event.end) {
            result.push({ start: startTime, end: event.end, event: eventOrNull });
        }
        return { event: event, parts: result };
    }
    dateEquals(date1, date2) {
        return (date1.getFullYear() === date2.getFullYear() &&
            date1.getMonth() === date2.getMonth() &&
            date1.getDate() === date2.getDate());
    }
    getTimeline(events) {
        const timestamps = this.getTimestamps(events);
        const tracks = [];
        timestamps.forEach((timestamp, tIndex) => {
            const starting = events.filter((e) => e.start === timestamp);
            // const ending = events.filter((e) => e.end === timestamp);
            starting.forEach((startedEvent, eIndex) => {
                const freeTracks = tracks.filter(t => this.trackIsFreeAt(t, startedEvent));
                if (freeTracks.length === 0) {
                    tracks.push({ index: tracks.length, events: [startedEvent] });
                }
                else {
                    freeTracks[0].events.push(startedEvent);
                }
            });
        });
        return tracks;
    }
    getTimestamps(events) {
        const allTimestamps = events.map(e => [e.start, e.end])
            .reduce((flat, toFlatten) => flat.concat(toFlatten), []);
        return allTimestamps
            .filter((t, i) => allTimestamps.indexOf(t) === i)
            .sort((t1, t2) => t1 - t2);
    }
    trackIsFreeAt(track, event) {
        if (track.events.every((ev) => (ev.end <= event.start) || (event.end <= ev.start))) {
            return true;
        }
        else {
            return false;
        }
    }
}
BsTimelineService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTimelineService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
BsTimelineService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTimelineService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTimelineService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class ResourceGroupPresenterComponent {
    constructor() {
        this.level = 0;
        this.resourceOrGroup$ = new BehaviorSubject(null);
        this.timeSlots$ = new BehaviorSubject([]);
        this.isExpanded$ = new BehaviorSubject(false);
        this.destroyed$ = new Subject();
        this.data$ = this.resourceOrGroup$
            .pipe(map((resourceOrGroup) => {
            if (!resourceOrGroup) {
                return null;
            }
            else if ('children' in resourceOrGroup) {
                return {
                    resource: null,
                    resourceGroup: resourceOrGroup
                };
            }
            else {
                return {
                    resource: resourceOrGroup,
                    resourceGroup: null
                };
            }
        }))
            .pipe(filter((resourceOrGroup) => !!resourceOrGroup))
            .pipe(map((resourceOrGroup) => resourceOrGroup));
        this.colSpan$ = this.timeSlots$
            .pipe(map(timeSlots => timeSlots
            .map(timeslot => timeslot.slots.length)
            .reduce((sum, current) => sum + current, 0)));
    }
    //#region resourceOrGroup
    get resourceOrGroup() {
        return this.resourceOrGroup$.value;
    }
    set resourceGroup(value) {
        this.resourceOrGroup$.next(value);
    }
    //#endregion
    //#region timeSlots
    get timeSlots() {
        return this.timeSlots$.value;
    }
    set timeSlots(value) {
        this.timeSlots$.next(value);
    }
    //#endregion
    //#region isExpanded
    get isExpanded() {
        return this.isExpanded$.value;
    }
    set isExpanded(value) {
        this.isExpanded$.next(value);
    }
    //#endregion
    toggleExpanded() {
        this.isExpanded$.pipe(take(1)).subscribe((isExpanded) => {
            this.isExpanded$.next(!isExpanded);
        });
    }
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
}
ResourceGroupPresenterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: ResourceGroupPresenterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
ResourceGroupPresenterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: ResourceGroupPresenterComponent, selector: "bs-resource-group-presenter", inputs: { level: "level", resourceGroup: "resourceGroup", timeSlots: "timeSlots", isExpanded: "isExpanded" }, ngImport: i0, template: "<ng-container *ngIf=\"(data$ | async) as data\">\n\n    <!-- Data is a resource group -->\n    <ng-container *ngIf=\"data.resourceGroup\">\n        <!-- Header -->\n        <tr class=\"p-0 cursor-pointer\" *ngIf=\"(timeSlots$ | async) as timeSlots\" [title]=\"data.resourceGroup.description\">\n            <ng-container *ngIf=\"(colSpan$ | async) as colspan\">\n                <td class=\"p-2 cursor-pointer\" [colSpan]=\"colspan + 1\" (click)=\"toggleExpanded()\">\n                    <span class=\"p-2 align-middle position-sticky\">\n                        <i class=\"bi bi-chevron-down\" [style.padding-left.px]=\"level * 20\" *ngIf=\"isExpanded$ | async\"></i>\n                        <i class=\"bi bi-chevron-right\" [style.padding-left.px]=\"level * 20\" *ngIf=\"(isExpanded$ | async) === false\"></i>\n                        {{ data.resourceGroup.description }}\n                    </span>\n                </td>\n            </ng-container>\n        </tr>\n\n        <!-- Subgroups or resources -->\n        <ng-container *ngIf=\"isExpanded$ | async\">\n            <ng-container *ngIf=\"(timeSlots$ | async) as timeSlots\">\n                <ng-container *ngFor=\"let child of data.resourceGroup.children\">\n                    <bs-resource-group-presenter [resourceGroup]=\"child\" [timeSlots]=\"timeSlots\" [level]=\"level + 1\"></bs-resource-group-presenter>\n                </ng-container>\n            </ng-container>\n        </ng-container>\n    </ng-container>\n\n    <!-- Data is a resource -->\n    <tr *ngIf=\"data.resource\" class=\"p-0 bordered\" [title]=\"data.resource.description\">\n        <td class=\"p-0 bg-white\">\n            <div class=\"p-2\">{{ data.resource.description }}</div>\n        </td>\n        <ng-container *ngFor=\"let slots of (timeSlots$ | async)\">\n            <td class=\"bg-white border-1\" *ngFor=\"let slot of slots.slots\">\n                <!-- {{ slot.start | date: 'dd/MM/yyyy HH:mm:ss' }} -->\n            </td>\n        </ng-container>\n    </tr>\n</ng-container>", styles: [":host{display:contents}tr{border-bottom-width:1px}tr:not(.bordered) td span.position-sticky{left:0;right:0}\n"], components: [{ type: ResourceGroupPresenterComponent, selector: "bs-resource-group-presenter", inputs: ["level", "resourceGroup", "timeSlots", "isExpanded"] }], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], pipes: { "async": i1.AsyncPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: ResourceGroupPresenterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-resource-group-presenter', template: "<ng-container *ngIf=\"(data$ | async) as data\">\n\n    <!-- Data is a resource group -->\n    <ng-container *ngIf=\"data.resourceGroup\">\n        <!-- Header -->\n        <tr class=\"p-0 cursor-pointer\" *ngIf=\"(timeSlots$ | async) as timeSlots\" [title]=\"data.resourceGroup.description\">\n            <ng-container *ngIf=\"(colSpan$ | async) as colspan\">\n                <td class=\"p-2 cursor-pointer\" [colSpan]=\"colspan + 1\" (click)=\"toggleExpanded()\">\n                    <span class=\"p-2 align-middle position-sticky\">\n                        <i class=\"bi bi-chevron-down\" [style.padding-left.px]=\"level * 20\" *ngIf=\"isExpanded$ | async\"></i>\n                        <i class=\"bi bi-chevron-right\" [style.padding-left.px]=\"level * 20\" *ngIf=\"(isExpanded$ | async) === false\"></i>\n                        {{ data.resourceGroup.description }}\n                    </span>\n                </td>\n            </ng-container>\n        </tr>\n\n        <!-- Subgroups or resources -->\n        <ng-container *ngIf=\"isExpanded$ | async\">\n            <ng-container *ngIf=\"(timeSlots$ | async) as timeSlots\">\n                <ng-container *ngFor=\"let child of data.resourceGroup.children\">\n                    <bs-resource-group-presenter [resourceGroup]=\"child\" [timeSlots]=\"timeSlots\" [level]=\"level + 1\"></bs-resource-group-presenter>\n                </ng-container>\n            </ng-container>\n        </ng-container>\n    </ng-container>\n\n    <!-- Data is a resource -->\n    <tr *ngIf=\"data.resource\" class=\"p-0 bordered\" [title]=\"data.resource.description\">\n        <td class=\"p-0 bg-white\">\n            <div class=\"p-2\">{{ data.resource.description }}</div>\n        </td>\n        <ng-container *ngFor=\"let slots of (timeSlots$ | async)\">\n            <td class=\"bg-white border-1\" *ngFor=\"let slot of slots.slots\">\n                <!-- {{ slot.start | date: 'dd/MM/yyyy HH:mm:ss' }} -->\n            </td>\n        </ng-container>\n    </tr>\n</ng-container>", styles: [":host{display:contents}tr{border-bottom-width:1px}tr:not(.bordered) td span.position-sticky{left:0;right:0}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { level: [{
                type: Input
            }], resourceGroup: [{
                type: Input
            }], timeSlots: [{
                type: Input
            }], isExpanded: [{
                type: Input
            }] } });

class BsSecondsTodayOffsetPipe {
    transform(value) {
        const today = new Date(value.start);
        today.setHours(0);
        today.setMinutes(0);
        today.setSeconds(0);
        return (value.start.getTime() - today.getTime()) / 1000;
    }
}
BsSecondsTodayOffsetPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSecondsTodayOffsetPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
BsSecondsTodayOffsetPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSecondsTodayOffsetPipe, name: "bsSecondsTodayOffset" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSecondsTodayOffsetPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'bsSecondsTodayOffset'
                }]
        }] });

class BsSecondsTimespanPipe {
    transform(value) {
        return (value.end.getTime() - value.start.getTime()) / 1000;
    }
}
BsSecondsTimespanPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSecondsTimespanPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
BsSecondsTimespanPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSecondsTimespanPipe, name: "bsSecondsTimespan" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSecondsTimespanPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'bsSecondsTimespan'
                }]
        }] });

class DayOfWeekPipe {
    transform(value) {
        const dayOfWeek = value.start.getDay();
        if (dayOfWeek === 0) {
            return 7;
        }
        else {
            return dayOfWeek;
        }
    }
}
DayOfWeekPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: DayOfWeekPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
DayOfWeekPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: DayOfWeekPipe, name: "dayOfWeek" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: DayOfWeekPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'dayOfWeek'
                }]
        }] });

class BsSchedulerComponent {
    constructor(calendarMonthService, timelineService) {
        this.calendarMonthService = calendarMonthService;
        this.timelineService = timelineService;
        this.resources$ = new BehaviorSubject([]);
        this.weekOptions$ = new BehaviorSubject({ unitHeight: 30 });
        this.timelineOptions$ = new BehaviorSubject({ unitWidth: 50 });
        this.previewEvent$ = new BehaviorSubject(null);
        this.timeSlotDuration$ = new BehaviorSubject(1800);
        this.timeSlots$ = new BehaviorSubject([]);
        this.mouseState$ = new BehaviorSubject(false);
        this.hoveredTimeSlot$ = new BehaviorSubject(null);
        this.hoveredEvent$ = new BehaviorSubject(null);
        this.destroyed$ = new Subject();
        //#region Mode
        this.modes = ESchedulerMode;
        this.mode$ = new BehaviorSubject(ESchedulerMode.week);
        this.modeChange = new EventEmitter();
        //#endregion
        // //#region Scale
        // scale$ = new BehaviorSubject<SchedulerScale>(availableScales[4]);
        // @Output() public scaleChange = new EventEmitter<SchedulerScale>();
        // public get scale() {
        //   return this.scale$.value;
        // }
        // @Input() public set scale(value: SchedulerScale) {
        //   this.scale$.next(value);
        // }
        // //#endregion
        //#region WeekOptions
        this.weekOptionsChange = new EventEmitter();
        //#endregion
        //#region TimelineOptions
        this.timelineOptionsChange = new EventEmitter();
        //#endregion
        //#region maxInnerHeight
        this.maxInnerHeight = null;
        this.operation = null;
        this.dragStartTimeslot = null;
        const monday = this.calendarMonthService.getMondayBefore(new Date());
        this.currentWeekOrMonth$ = new BehaviorSubject(monday);
        this.shownDays$ = combineLatest([this.currentWeekOrMonth$, this.mode$])
            .pipe(map(([currentDay, mode]) => {
            currentDay.setHours(0);
            currentDay.setMinutes(0);
            currentDay.setSeconds(0);
            currentDay.setMilliseconds(0);
            switch (mode) {
                case ESchedulerMode.week: {
                    return Array.from(Array(7).keys()).map((x) => this.addDays(currentDay, x));
                }
                case ESchedulerMode.timeline: {
                    const firstDay = new Date(currentDay.getFullYear(), currentDay.getMonth(), 1);
                    const daysOfMonth = new Date(currentDay.getFullYear(), currentDay.getMonth() + 1, 0).getDate();
                    return Array.from(Array(daysOfMonth).keys()).map((x) => this.addDays(firstDay, x));
                }
            }
        }));
        this.daysOfWeekWithTimestamps$ = this.shownDays$
            .pipe(map((shownDays) => ({ start: shownDays[0].getTime(), end: shownDays[shownDays.length - 1].getTime() + 24 * 60 * 60 * 1000 })));
        this.events$ = this.resources$
            .pipe(map((resourcesOrGroups) => resourcesOrGroups.map(resOrGroup => this.getResourcesForGroup(resOrGroup))))
            .pipe(map(jaggedResources => jaggedResources.reduce((flat, toFlatten) => flat.concat(toFlatten), [])))
            .pipe(map(resources => resources.map(res => res.events)))
            .pipe(map(jaggedEvents => jaggedEvents.reduce((flat, toFlatten) => flat.concat(toFlatten), [])));
        // groups.reduce((flat, toFlatten) => flat.concat(toFlatten.children), [])
        this.eventParts$ = this.events$.pipe(map((events) => events.map((ev) => this.timelineService.splitInParts(ev))));
        this.eventPartsForThisWeek$ = combineLatest([
            this.daysOfWeekWithTimestamps$,
            this.eventParts$
                .pipe(map(eventParts => eventParts.map(evp => evp.parts)))
                .pipe(map(jaggedParts => jaggedParts.reduce((flat, toFlatten) => flat.concat(toFlatten), [])))
        ])
            .pipe(map(([startAndEnd, eventParts]) => {
            return eventParts.filter(eventPart => {
                return !((eventPart.end.getTime() <= startAndEnd.start) || (eventPart.start.getTime() >= startAndEnd.end));
            });
        }));
        this.previewEventParts$ = this.previewEvent$.pipe(map((event) => {
            if (event) {
                return this.timelineService.splitInParts(event);
            }
            else {
                return null;
            }
        }));
        this.previewEventPartsForThisWeek$ = combineLatest([this.daysOfWeekWithTimestamps$, this.previewEventParts$])
            .pipe(map(([startAndEnd, previewEventParts]) => {
            if (previewEventParts) {
                return previewEventParts.parts.filter(eventPart => {
                    return !((eventPart.end.getTime() <= startAndEnd.start) || (eventPart.start.getTime() >= startAndEnd.end));
                });
            }
            else {
                return [];
            }
        }));
        this.timelinedEventPartsForThisWeek$ = this.eventPartsForThisWeek$
            .pipe(map(eventParts => {
            // We'll only use the events for this week
            const events = eventParts.map(ep => ep.event)
                .filter((e, i, list) => list.indexOf(e) === i)
                .filter((e) => !!e)
                .map((e) => e);
            const timeline = this.timelineService.getTimeline(events);
            const result = timeline.map(track => track.events.map(ev => ({ event: ev, index: track.index })))
                .reduce((flat, toFlatten) => flat.concat(toFlatten), [])
                .map((evi) => eventParts.filter(p => p.event === evi.event).map(p => ({ part: p, index: evi.index })))
                .reduce((flat, toFlatten) => flat.concat(toFlatten), []);
            return {
                total: timeline.length,
                parts: result
            };
        }));
        combineLatest([this.mode$, this.shownDays$, this.timeSlotDuration$])
            .pipe(filter(([mode, shownDays, duration]) => mode !== null))
            .pipe(map(([mode, shownDays, duration]) => {
            switch (mode) {
                case ESchedulerMode.week: {
                    const timeSlotsPerDay = Math.floor((60 * 60 * 24) / duration);
                    return Array.from(Array(timeSlotsPerDay).keys()).map((index) => {
                        const timeslotForMonday = this.createTimeslot(shownDays[0], index, duration);
                        return {
                            slots: shownDays.map((day) => {
                                const start = new Date(day);
                                start.setHours(timeslotForMonday.start.getHours());
                                start.setMinutes(timeslotForMonday.start.getMinutes());
                                start.setSeconds(timeslotForMonday.start.getSeconds());
                                start.setMilliseconds(timeslotForMonday.start.getMilliseconds());
                                const end = new Date(day);
                                end.setHours(timeslotForMonday.end.getHours());
                                end.setMinutes(timeslotForMonday.end.getMinutes());
                                end.setSeconds(timeslotForMonday.end.getSeconds());
                                end.setMilliseconds(timeslotForMonday.end.getMilliseconds());
                                end.setDate(end.getDate() + timeslotForMonday.end.getDate() - timeslotForMonday.start.getDate());
                                return { start, end };
                            }),
                            stamp: timeslotForMonday.start
                        };
                    });
                }
                case ESchedulerMode.timeline: {
                    const totalTimeslots = (24 * 60 * 60) / duration;
                    return shownDays.map((day) => {
                        return {
                            slots: Array.from(Array(totalTimeslots).keys())
                                .map((index) => {
                                return this.createTimeslot(day, index, duration);
                            }),
                            stamp: day
                        };
                    });
                }
                default: {
                    throw 'Unknown value for Mode: ' + mode;
                }
            }
        }))
            .subscribe((timeslots) => {
            // For performance reasons, we're not using an observable here, but persist the timeslots in a BehaviorSubject.
            this.timeSlots$.next(timeslots);
        });
        this.weekOptions$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((weekOptions) => {
            this.weekOptionsChange.emit(weekOptions);
        });
        this.timelineOptions$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((timelineOptions) => {
            this.timelineOptionsChange.emit(timelineOptions);
        });
        // combineLatest([this.mode$, this.scale$])
        //   .pipe(filter(([mode, scale]) => mode === ESchedulerMode.timeline))
    }
    createTimeslot(date, index, duration) {
        const timeSlotStart = new Date(date);
        timeSlotStart.setTime(+timeSlotStart.getTime() + index * duration * 1000);
        const timeSlotEnd = new Date(timeSlotStart);
        timeSlotEnd.setTime(+timeSlotEnd.getTime() + duration * 1000);
        return { start: timeSlotStart, end: timeSlotEnd };
    }
    getResourcesForGroup(resourceOrGroup) {
        if ('children' in resourceOrGroup) {
            return resourceOrGroup.children
                .map((child) => this.getResourcesForGroup(child))
                .reduce((flat, toFlatten) => flat.concat(toFlatten), []);
        }
        else {
            return [resourceOrGroup];
        }
    }
    get mode() {
        return this.mode$.value;
    }
    set mode(value) {
        this.mode$.next(value);
    }
    get weekOptions() {
        return this.weekOptions$.value;
    }
    set weekOptions(value) {
        this.weekOptions$.next(value);
    }
    get timelineOptions() {
        return this.timelineOptions$.value;
    }
    set timelineOptions(value) {
        this.timelineOptions$.next(value);
    }
    //#endregion
    //#region Resources
    get resources() {
        return this.resources$.value;
    }
    set resources(value) {
        this.resources$.next(value);
    }
    //#endregion
    addDays(date, days) {
        const result = new Date(date);
        result.setDate(result.getDate() + days);
        return result;
    }
    onPreviousWeekOrMonth() {
        this.onChangeWeekOrMonth(false);
    }
    onNextWeekOrMonth() {
        this.onChangeWeekOrMonth(true);
    }
    onChangeWeekOrMonth(next) {
        combineLatest([this.currentWeekOrMonth$, this.mode$])
            .pipe(map(([currentWeekOrMonth, mode]) => {
            switch (mode) {
                case ESchedulerMode.week: {
                    return this.addDays(currentWeekOrMonth, (next ? 7 : -7));
                }
                case ESchedulerMode.timeline: {
                    return new Date(currentWeekOrMonth.getFullYear(), currentWeekOrMonth.getMonth() + (next ? 1 : -1), 1);
                }
            }
        }), take(1))
            .subscribe((w) => this.currentWeekOrMonth$.next(w));
    }
    onHoverEvent(ev) {
        console.log('hovered', ev);
        this.hoveredEvent$.next(ev);
    }
    onLeaveEvent(ev) {
        this.hoveredEvent$.next(null);
    }
    onCreateEvent(ev, slot) {
        ev.preventDefault();
        this.mouseState$.next(true);
        this.dragStartTimeslot = slot;
        this.operation = {
            operation: EDragOperation.createEvent,
            event: {
                start: slot.start,
                end: slot.end,
                color: '#F00',
                description: 'Test event',
            },
            meta: null,
        };
        this.previewEvent$.next({ start: slot.start, end: slot.end });
    }
    randomColor() {
        const brightness = 128;
        return '#' + this.randomChannel(brightness) + this.randomChannel(brightness) + this.randomChannel(brightness);
    }
    randomChannel(brightness) {
        const r = 255 - brightness;
        const n = 0 | ((Math.random() * r) + brightness);
        const s = n.toString(16);
        return (s.length == 1) ? '0' + s : s;
    }
    onStartDragEvent(eventPart, ev) {
        ev.preventDefault();
        this.hoveredTimeSlot$.pipe(take(1)).subscribe((hoveredTimeSlot) => {
            if (eventPart.event) {
                this.dragStartTimeslot = hoveredTimeSlot;
                this.operation = {
                    operation: EDragOperation.moveEvent,
                    event: eventPart.event,
                    meta: null,
                };
                this.previewEvent$.next({ start: eventPart.event.start, end: eventPart.event.end });
            }
        });
    }
    onStartResizeEvent(event, position) {
        if (event) {
            switch (position) {
                case 'top':
                    {
                        this.operation = {
                            operation: EDragOperation.resizeEvent,
                            event: event,
                            meta: { position },
                        };
                        this.previewEvent$.next({ start: event.start, end: event.end });
                    }
                    break;
                case 'bottom':
                    {
                        this.operation = {
                            operation: EDragOperation.resizeEvent,
                            event: event,
                            meta: { position },
                        };
                        this.previewEvent$.next({ start: event.start, end: event.end });
                    }
                    break;
            }
        }
    }
    //#region hoveredTimeslot$
    getHoveredTimeslot(ev, timeSlots) {
        const hoveredSlots = this.timeSlotElements.filter((el) => {
            const rct = el.nativeElement.getBoundingClientRect();
            if (rct.left <= ev.x && ev.x <= rct.right && rct.top <= ev.y && ev.y <= rct.bottom) {
                return true;
            }
            else {
                return false;
            }
        });
        if (!hoveredSlots || hoveredSlots.length === 0) {
            return null;
        }
        const slotElement = hoveredSlots[0].nativeElement;
        const strRow = slotElement.getAttribute('data-row');
        if (!strRow) {
            return null;
        }
        const row = parseInt(strRow);
        const strColumn = slotElement.getAttribute('data-column');
        if (!strColumn) {
            return null;
        }
        const column = parseInt(strColumn);
        const slot = timeSlots[row].slots[column];
        return slot;
    }
    onMousemove(ev) {
        this.timeSlots$.pipe(take(1)).subscribe((timeSlots) => {
            const hovered = this.getHoveredTimeslot(ev, timeSlots);
            this.hoveredTimeSlot$.next(hovered);
            if (this.operation) {
                switch (this.operation.operation) {
                    case EDragOperation.createEvent:
                        {
                            if (this.operation.event && this.dragStartTimeslot && hovered && (this.operation.event.end.getTime() != hovered.end.getTime())) {
                                if (this.dragStartTimeslot.start.getTime() === hovered.start.getTime()) {
                                    // 1 slot
                                }
                                else if (this.dragStartTimeslot.start.getTime() < hovered.start.getTime()) {
                                    // Drag down
                                    this.previewEvent$
                                        .pipe(filter((ev) => !!ev && !!this.dragStartTimeslot))
                                        .pipe(map((ev) => {
                                        if (ev && this.dragStartTimeslot) {
                                            ev.start = this.dragStartTimeslot.start;
                                            ev.end = hovered.end;
                                        }
                                        return ev;
                                    }))
                                        .pipe(take(1))
                                        .subscribe((ev) => this.previewEvent$.next(ev));
                                }
                                else if (this.dragStartTimeslot.start.getTime() > hovered.start.getTime()) {
                                    // Drag up
                                    this.previewEvent$
                                        .pipe(filter((ev) => !!ev && !!this.dragStartTimeslot))
                                        .pipe(map((ev) => {
                                        if (ev && this.dragStartTimeslot) {
                                            ev.start = hovered.start;
                                            ev.end = this.dragStartTimeslot.end;
                                        }
                                        return ev;
                                    }))
                                        .pipe(take(1))
                                        .subscribe((ev) => this.previewEvent$.next(ev));
                                }
                            }
                        }
                        break;
                    case EDragOperation.moveEvent:
                        {
                            if (hovered && this.dragStartTimeslot) {
                                this.previewEvent$
                                    .pipe(filter((ev) => !!ev && !!this.dragStartTimeslot))
                                    .pipe(map((ev) => {
                                    if (ev && this.dragStartTimeslot) {
                                        const result = {
                                            start: new Date(ev.start.getTime() + hovered.start.getTime() - this.dragStartTimeslot.start.getTime()),
                                            end: new Date(ev.end.getTime() + hovered.start.getTime() - this.dragStartTimeslot.start.getTime())
                                        };
                                        this.dragStartTimeslot = hovered;
                                        return result;
                                    }
                                    else {
                                        return ev;
                                    }
                                }))
                                    .pipe(take(1))
                                    .subscribe(ev => this.previewEvent$.next(ev));
                            }
                        }
                        break;
                    case EDragOperation.resizeEvent:
                        {
                            if (hovered) {
                                this.previewEvent$
                                    .pipe(filter((ev) => !!ev))
                                    .pipe(map((ev) => {
                                    if (ev && this.operation && this.operation.event) {
                                        if (this.operation.meta.position === 'top') {
                                            ev.start = hovered.start;
                                            ev.end = this.operation.event.end;
                                        }
                                        else if (this.operation.meta.position === 'bottom') {
                                            ev.start = this.operation.event.start;
                                            ev.end = hovered.end;
                                        }
                                    }
                                    return ev;
                                }))
                                    .pipe(take(1))
                                    .subscribe((ev) => this.previewEvent$.next(ev));
                            }
                        }
                        break;
                }
            }
        });
    }
    //#endregion
    onMouseUp(ev) {
        if (this.operation) {
            switch (this.operation.operation) {
                case EDragOperation.createEvent:
                    {
                        combineLatest([this.previewEvent$])
                            .pipe(take(1))
                            .subscribe(([previewEvent]) => {
                            if (previewEvent) {
                                this.operation = null;
                                this.dragStartTimeslot = null;
                                this.resources$.next([
                                    ...this.resources$.value,
                                    {
                                        description: 'New resource group',
                                        events: [{
                                                start: previewEvent.start,
                                                end: previewEvent.end,
                                                color: this.randomColor(),
                                                description: 'New event'
                                            }]
                                    }
                                ]);
                                this.previewEvent$.next(null);
                            }
                        });
                    }
                    break;
                case EDragOperation.moveEvent:
                case EDragOperation.resizeEvent:
                    {
                        this.previewEvent$
                            .pipe(filter((ev) => !!ev))
                            .pipe(take(1))
                            .subscribe((previewEvent) => {
                            if (this.operation && this.operation.event && previewEvent) {
                                this.operation.event.start = previewEvent.start;
                                this.operation.event.end = previewEvent.end;
                                this.operation = null;
                                this.dragStartTimeslot = null;
                                this.resources$.next(this.resources$.value);
                                this.previewEvent$.next(null);
                            }
                        });
                    }
                    break;
            }
        }
    }
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
}
BsSchedulerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSchedulerComponent, deps: [{ token: BsCalendarMonthService }, { token: BsTimelineService }], target: i0.ɵɵFactoryTarget.Component });
BsSchedulerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsSchedulerComponent, selector: "bs-scheduler", inputs: { mode: "mode", weekOptions: "weekOptions", timelineOptions: "timelineOptions", maxInnerHeight: "maxInnerHeight", resources: "resources" }, outputs: { modeChange: "modeChange", weekOptionsChange: "weekOptionsChange", timelineOptionsChange: "timelineOptionsChange" }, host: { listeners: { "document:mousemove": "onMousemove($event)", "document:mouseup": "onMouseUp($event)" } }, viewQueries: [{ propertyName: "timeSlotElements", predicate: ["slot"], descendants: true }], ngImport: i0, template: "<div class=\"table d-flex w-100 overflow-y-auto mb-0 week-schedule\" [style.max-height.px]=\"null\"\n    *ngIf=\"(mode$ | async) === modes.week\">\n    <div class=\"calendar-head\">\n        <div class=\"w-100 d-flex flex-row\">\n            <div class=\"d-flex calendar-left justify-content-between\">\n                <button class=\"btn btn-default flex-start\" (click)=\"onPreviousWeekOrMonth()\">\n                    <i class=\"bi-chevron-left px-0\"></i>\n                </button>\n                <button class=\"btn btn-default flex-end\" (click)=\"onNextWeekOrMonth()\">\n                    <i class=\"bi-chevron-right px-0\"></i>\n                </button>\n            </div>\n            <div class=\"flex-grow-1 calendar-head-cell\" *ngFor=\"let day of (shownDays$ | async)\">\n                <span class=\"d-block col-form-label text-center\">\n                    <span>{{ day | date: 'dd-MM' }}</span><span class=\"d-none d-lg-inline-block\">-{{ day | date: 'yyyy' }}</span>\n                </span>\n            </div>\n        </div>\n    </div>\n    <div class=\"calendar-body\" [style.height.px]=\"maxInnerHeight\">\n        <div class=\"position-relative\" *ngIf=\"(timeSlots$ | async) as row\">\n            <ng-container *ngIf=\"(weekOptions$ | async) as weekOptions\">\n                <!-- Timeslots -->\n                <div *ngFor=\"let timeslots of row; let i = index\" class=\"d-flex flex-row p-0 timeslot\" [style.height.px]=\"weekOptions.unitHeight\">\n                    <div class=\"calendar-cell calendar-left align-top px-2 py-0\">{{ timeslots.slots[0].start | date: 'HH:mm:ss' }}</div>\n                    <div class=\"calendar-cell flex-grow-1\" *ngFor=\"let slot of timeslots.slots; let j = index\" #slot (mousedown)=\"onCreateEvent($event, slot)\" [attr.data-row]=\"i\" [attr.data-column]=\"j\"></div>\n                </div>\n\n                <!-- Events -->\n                <ng-container *ngIf=\"(timeSlotDuration$ | async) as timeSlotDuration\">\n                    <ng-container *ngIf=\"(timelinedEventPartsForThisWeek$ | async) as partData\">\n                        <div *ngFor=\"let eventPart of partData.parts\" class=\"event p-0\"\n                            [style.top.px]=\"(eventPart.part | bsSecondsTodayOffset) / timeSlotDuration * weekOptions.unitHeight\"\n                            [style.height.px]=\"(eventPart.part | bsSecondsTimespan) / timeSlotDuration * weekOptions.unitHeight\"\n                            [style.left]=\"'calc(90px + ((100% - 90px) / 7 * ' + ((eventPart.part | dayOfWeek) - 1) + '))'\">\n                            <div class=\"event-inner\" [class.hover]=\"(hoveredEvent$ | async) === eventPart.part.event\"\n                                [style.width]=\"'calc(100% / ' + partData.total + ')'\"\n                                [style.height.px]=\"(eventPart.part | bsSecondsTimespan) / timeSlotDuration * weekOptions.unitHeight\"\n                                [style.margin-left]=\"'calc(100% / ' + partData.total + ' * ' + eventPart.index + ')'\">\n\n                                <div class=\"event-resize top\"\n                                    *ngIf=\"eventPart.part.start === eventPart.part.event?.start\"\n                                    (mousedown)=\"onStartResizeEvent(eventPart.part.event, 'top')\"></div>\n                                <div class=\"event-border\"></div>\n                                <div class=\"event-wrapper\" *ngIf=\"eventPart.part.event\"\n                                    (mousedown)=\"onStartDragEvent(eventPart.part, $event)\"\n                                    (mouseenter)=\"onHoverEvent(eventPart.part.event)\"\n                                    (mouseleave)=\"onLeaveEvent(eventPart.part.event)\">\n                                    <div class=\"event-bg\" [style.background-color]=\"eventPart.part.event.color\"></div>\n                                    <div class=\"event-label\">{{ eventPart.part.event.description }}</div>\n                                </div>\n                                <div class=\"event-resize bottom\"\n                                    *ngIf=\"eventPart.part.end === eventPart.part.event?.end\"\n                                    (mousedown)=\"onStartResizeEvent(eventPart.part.event, 'bottom')\"></div>\n                            </div>\n                        </div>\n                    </ng-container>\n                    <ng-container *ngIf=\"(previewEventPartsForThisWeek$ | async) as previewPartData\">\n                        <div *ngFor=\"let eventPart of previewPartData\" class=\"event preview p-0\"\n                            [style.top.px]=\"(eventPart | bsSecondsTodayOffset) / timeSlotDuration * weekOptions.unitHeight\"\n                            [style.height.px]=\"(eventPart | bsSecondsTimespan) / timeSlotDuration * weekOptions.unitHeight\"\n                            [style.left]=\"'calc(90px + ((100% - 90px) / 7 * ' + ((eventPart | dayOfWeek) - 1) + '))'\">\n                            <div class=\"event-inner w-100\"\n                                [style.height.px]=\"(eventPart | bsSecondsTimespan) / timeSlotDuration * weekOptions.unitHeight\">\n                            </div>\n                        </div>\n                    </ng-container>\n                </ng-container>\n            </ng-container>\n        </div>\n    </div>\n</div>\n<div class=\"table d-flex w-100 overflow-y-auto mb-0 bg-white timeline\" *ngIf=\"(mode$ | async) === modes.timeline\">\n    <div class=\"calendar-head d-flex\">\n        <button class=\"btn flex-start\" (click)=\"onPreviousWeekOrMonth()\">\n            <i class=\"bi-chevron-left px-0\"></i>\n        </button>\n        <div class=\"flex-grow-1 h3 py-2 mb-0 text-center\">{{ currentWeekOrMonth$ | async | date: 'MMMM yyyy' }}</div>\n        <button class=\"btn flex-start\" (click)=\"onNextWeekOrMonth()\">\n            <i class=\"bi-chevron-right px-0\"></i>\n        </button>\n    </div>\n    <div class=\"calendar-body table-responsive overflow-x-auto\">\n        <table class=\"table mb-0\">\n            <ng-container *ngIf=\"(timeSlots$ | async) as timeSlots\">\n                <tr>\n                    <td></td>\n                    <td *ngFor=\"let day of timeSlots\" [attr.colspan]=\"day.slots.length\" class=\"text-center px-2\">\n                        <span class=\"position-sticky day-label\">{{ day.stamp | date: 'd EE' }}</span>\n                    </td>\n                </tr>\n                <tr>\n                    <td></td>\n                    <ng-container *ngIf=\"(timelineOptions$ | async) as timelineOptions\">\n                        <ng-container *ngFor=\"let day of timeSlots\">\n                            <td *ngFor=\"let slot of day.slots\">\n                                <span class=\"d-block p-0 text-center\" [style.width.px]=\"timelineOptions.unitWidth\">\n                                    {{ slot.start | date: 'HH:mm' }}\n                                </span>\n                            </td>\n                        </ng-container>\n                    </ng-container>\n                </tr>\n                <bs-resource-group-presenter *ngFor=\"let group of (resources$ | async)\" [resourceGroup]=\"group\" [timeSlots]=\"timeSlots\"></bs-resource-group-presenter>\n            </ng-container>\n        </table>\n    </div>\n</div>", styles: [":host{display:block;border:1px solid #333;border-top-right-radius:10px;border-top-left-radius:10px;overflow:hidden}.calendar-head{background:#F7F7F7;color:#007aff}.table .calendar-head{flex:0 0 auto}.table .calendar-body{display:block;flex:1 1 auto}.week-schedule.table{flex-flow:column}.week-schedule.table .calendar-head>div{padding-right:18px}.week-schedule.table .calendar-body{overflow-y:scroll;overflow-x:hidden}.week-schedule.table .calendar-body .calendar-cell{border-right:1px solid #DEE2E6;border-bottom:1px solid #DEE2E6;cursor:default}.week-schedule.table .calendar-body .calendar-cell.hover{border-top-width:3px}.week-schedule.table .calendar-left{width:90px}.week-schedule .event{z-index:5;width:calc((100% - 90px) / 7);height:100px;overflow:hidden;position:absolute;-webkit-user-select:none;user-select:none;pointer-events:none}.week-schedule .event.preview{background:#666;opacity:.6}.week-schedule .event .event-border{background:black;top:0;left:0;bottom:3px;width:3px;position:absolute;z-index:10;opacity:.3}.week-schedule .event .event-inner{position:relative;left:0px;right:5px;top:0px;bottom:5px;cursor:move;pointer-events:all;overflow:hidden}.week-schedule .event .event-inner .event-wrapper{width:calc(100% - 2px);margin:1px auto 1px 0;height:calc(100% - 3px)}.week-schedule .event .event-inner .event-wrapper .event-bg{opacity:.5;height:100%;transition:opacity .15s ease-in-out}.week-schedule .event .event-inner .event-wrapper .event-label{position:absolute;top:0;font-size:12px;font-weight:600;padding:4px}.week-schedule .event .event-inner .event-resize{position:absolute;cursor:ns-resize;height:4px;left:0;right:0;z-index:400}.week-schedule .event .event-inner .event-resize.top{top:0}.week-schedule .event .event-inner .event-resize.bottom{bottom:0}.week-schedule .event .event-inner .event-resize:hover{background:#DDD}.week-schedule .event .event-inner.hover .event-bg{opacity:.7!important}@media (max-width: 767px){.week-schedule.table .calendar-head .calendar-head-cell{text-orientation:sideways;writing-mode:vertical-rl}}.timeline.table{flex-flow:column}.timeline .calendar-body .table{background-color:#f7f7f7}.timeline .calendar-body .table tr:first-child td{background-color:#fff;border:1px solid #000}.timeline .calendar-body .table tr:first-child td:first-child{min-width:10rem}.timeline .calendar-body .table tr:first-child span.day-label{left:0;right:0}.timeline .calendar-body .table tr:nth-child(2) td{border-width:1px;border-color:inherit}.timeline .calendar-body .table>:not(:first-child){border-top:none!important}\n"], components: [{ type: ResourceGroupPresenterComponent, selector: "bs-resource-group-presenter", inputs: ["level", "resourceGroup", "timeSlots", "isExpanded"] }], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], pipes: { "async": i1.AsyncPipe, "date": i1.DatePipe, "bsSecondsTodayOffset": BsSecondsTodayOffsetPipe, "bsSecondsTimespan": BsSecondsTimespanPipe, "dayOfWeek": DayOfWeekPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSchedulerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-scheduler', template: "<div class=\"table d-flex w-100 overflow-y-auto mb-0 week-schedule\" [style.max-height.px]=\"null\"\n    *ngIf=\"(mode$ | async) === modes.week\">\n    <div class=\"calendar-head\">\n        <div class=\"w-100 d-flex flex-row\">\n            <div class=\"d-flex calendar-left justify-content-between\">\n                <button class=\"btn btn-default flex-start\" (click)=\"onPreviousWeekOrMonth()\">\n                    <i class=\"bi-chevron-left px-0\"></i>\n                </button>\n                <button class=\"btn btn-default flex-end\" (click)=\"onNextWeekOrMonth()\">\n                    <i class=\"bi-chevron-right px-0\"></i>\n                </button>\n            </div>\n            <div class=\"flex-grow-1 calendar-head-cell\" *ngFor=\"let day of (shownDays$ | async)\">\n                <span class=\"d-block col-form-label text-center\">\n                    <span>{{ day | date: 'dd-MM' }}</span><span class=\"d-none d-lg-inline-block\">-{{ day | date: 'yyyy' }}</span>\n                </span>\n            </div>\n        </div>\n    </div>\n    <div class=\"calendar-body\" [style.height.px]=\"maxInnerHeight\">\n        <div class=\"position-relative\" *ngIf=\"(timeSlots$ | async) as row\">\n            <ng-container *ngIf=\"(weekOptions$ | async) as weekOptions\">\n                <!-- Timeslots -->\n                <div *ngFor=\"let timeslots of row; let i = index\" class=\"d-flex flex-row p-0 timeslot\" [style.height.px]=\"weekOptions.unitHeight\">\n                    <div class=\"calendar-cell calendar-left align-top px-2 py-0\">{{ timeslots.slots[0].start | date: 'HH:mm:ss' }}</div>\n                    <div class=\"calendar-cell flex-grow-1\" *ngFor=\"let slot of timeslots.slots; let j = index\" #slot (mousedown)=\"onCreateEvent($event, slot)\" [attr.data-row]=\"i\" [attr.data-column]=\"j\"></div>\n                </div>\n\n                <!-- Events -->\n                <ng-container *ngIf=\"(timeSlotDuration$ | async) as timeSlotDuration\">\n                    <ng-container *ngIf=\"(timelinedEventPartsForThisWeek$ | async) as partData\">\n                        <div *ngFor=\"let eventPart of partData.parts\" class=\"event p-0\"\n                            [style.top.px]=\"(eventPart.part | bsSecondsTodayOffset) / timeSlotDuration * weekOptions.unitHeight\"\n                            [style.height.px]=\"(eventPart.part | bsSecondsTimespan) / timeSlotDuration * weekOptions.unitHeight\"\n                            [style.left]=\"'calc(90px + ((100% - 90px) / 7 * ' + ((eventPart.part | dayOfWeek) - 1) + '))'\">\n                            <div class=\"event-inner\" [class.hover]=\"(hoveredEvent$ | async) === eventPart.part.event\"\n                                [style.width]=\"'calc(100% / ' + partData.total + ')'\"\n                                [style.height.px]=\"(eventPart.part | bsSecondsTimespan) / timeSlotDuration * weekOptions.unitHeight\"\n                                [style.margin-left]=\"'calc(100% / ' + partData.total + ' * ' + eventPart.index + ')'\">\n\n                                <div class=\"event-resize top\"\n                                    *ngIf=\"eventPart.part.start === eventPart.part.event?.start\"\n                                    (mousedown)=\"onStartResizeEvent(eventPart.part.event, 'top')\"></div>\n                                <div class=\"event-border\"></div>\n                                <div class=\"event-wrapper\" *ngIf=\"eventPart.part.event\"\n                                    (mousedown)=\"onStartDragEvent(eventPart.part, $event)\"\n                                    (mouseenter)=\"onHoverEvent(eventPart.part.event)\"\n                                    (mouseleave)=\"onLeaveEvent(eventPart.part.event)\">\n                                    <div class=\"event-bg\" [style.background-color]=\"eventPart.part.event.color\"></div>\n                                    <div class=\"event-label\">{{ eventPart.part.event.description }}</div>\n                                </div>\n                                <div class=\"event-resize bottom\"\n                                    *ngIf=\"eventPart.part.end === eventPart.part.event?.end\"\n                                    (mousedown)=\"onStartResizeEvent(eventPart.part.event, 'bottom')\"></div>\n                            </div>\n                        </div>\n                    </ng-container>\n                    <ng-container *ngIf=\"(previewEventPartsForThisWeek$ | async) as previewPartData\">\n                        <div *ngFor=\"let eventPart of previewPartData\" class=\"event preview p-0\"\n                            [style.top.px]=\"(eventPart | bsSecondsTodayOffset) / timeSlotDuration * weekOptions.unitHeight\"\n                            [style.height.px]=\"(eventPart | bsSecondsTimespan) / timeSlotDuration * weekOptions.unitHeight\"\n                            [style.left]=\"'calc(90px + ((100% - 90px) / 7 * ' + ((eventPart | dayOfWeek) - 1) + '))'\">\n                            <div class=\"event-inner w-100\"\n                                [style.height.px]=\"(eventPart | bsSecondsTimespan) / timeSlotDuration * weekOptions.unitHeight\">\n                            </div>\n                        </div>\n                    </ng-container>\n                </ng-container>\n            </ng-container>\n        </div>\n    </div>\n</div>\n<div class=\"table d-flex w-100 overflow-y-auto mb-0 bg-white timeline\" *ngIf=\"(mode$ | async) === modes.timeline\">\n    <div class=\"calendar-head d-flex\">\n        <button class=\"btn flex-start\" (click)=\"onPreviousWeekOrMonth()\">\n            <i class=\"bi-chevron-left px-0\"></i>\n        </button>\n        <div class=\"flex-grow-1 h3 py-2 mb-0 text-center\">{{ currentWeekOrMonth$ | async | date: 'MMMM yyyy' }}</div>\n        <button class=\"btn flex-start\" (click)=\"onNextWeekOrMonth()\">\n            <i class=\"bi-chevron-right px-0\"></i>\n        </button>\n    </div>\n    <div class=\"calendar-body table-responsive overflow-x-auto\">\n        <table class=\"table mb-0\">\n            <ng-container *ngIf=\"(timeSlots$ | async) as timeSlots\">\n                <tr>\n                    <td></td>\n                    <td *ngFor=\"let day of timeSlots\" [attr.colspan]=\"day.slots.length\" class=\"text-center px-2\">\n                        <span class=\"position-sticky day-label\">{{ day.stamp | date: 'd EE' }}</span>\n                    </td>\n                </tr>\n                <tr>\n                    <td></td>\n                    <ng-container *ngIf=\"(timelineOptions$ | async) as timelineOptions\">\n                        <ng-container *ngFor=\"let day of timeSlots\">\n                            <td *ngFor=\"let slot of day.slots\">\n                                <span class=\"d-block p-0 text-center\" [style.width.px]=\"timelineOptions.unitWidth\">\n                                    {{ slot.start | date: 'HH:mm' }}\n                                </span>\n                            </td>\n                        </ng-container>\n                    </ng-container>\n                </tr>\n                <bs-resource-group-presenter *ngFor=\"let group of (resources$ | async)\" [resourceGroup]=\"group\" [timeSlots]=\"timeSlots\"></bs-resource-group-presenter>\n            </ng-container>\n        </table>\n    </div>\n</div>", styles: [":host{display:block;border:1px solid #333;border-top-right-radius:10px;border-top-left-radius:10px;overflow:hidden}.calendar-head{background:#F7F7F7;color:#007aff}.table .calendar-head{flex:0 0 auto}.table .calendar-body{display:block;flex:1 1 auto}.week-schedule.table{flex-flow:column}.week-schedule.table .calendar-head>div{padding-right:18px}.week-schedule.table .calendar-body{overflow-y:scroll;overflow-x:hidden}.week-schedule.table .calendar-body .calendar-cell{border-right:1px solid #DEE2E6;border-bottom:1px solid #DEE2E6;cursor:default}.week-schedule.table .calendar-body .calendar-cell.hover{border-top-width:3px}.week-schedule.table .calendar-left{width:90px}.week-schedule .event{z-index:5;width:calc((100% - 90px) / 7);height:100px;overflow:hidden;position:absolute;-webkit-user-select:none;user-select:none;pointer-events:none}.week-schedule .event.preview{background:#666;opacity:.6}.week-schedule .event .event-border{background:black;top:0;left:0;bottom:3px;width:3px;position:absolute;z-index:10;opacity:.3}.week-schedule .event .event-inner{position:relative;left:0px;right:5px;top:0px;bottom:5px;cursor:move;pointer-events:all;overflow:hidden}.week-schedule .event .event-inner .event-wrapper{width:calc(100% - 2px);margin:1px auto 1px 0;height:calc(100% - 3px)}.week-schedule .event .event-inner .event-wrapper .event-bg{opacity:.5;height:100%;transition:opacity .15s ease-in-out}.week-schedule .event .event-inner .event-wrapper .event-label{position:absolute;top:0;font-size:12px;font-weight:600;padding:4px}.week-schedule .event .event-inner .event-resize{position:absolute;cursor:ns-resize;height:4px;left:0;right:0;z-index:400}.week-schedule .event .event-inner .event-resize.top{top:0}.week-schedule .event .event-inner .event-resize.bottom{bottom:0}.week-schedule .event .event-inner .event-resize:hover{background:#DDD}.week-schedule .event .event-inner.hover .event-bg{opacity:.7!important}@media (max-width: 767px){.week-schedule.table .calendar-head .calendar-head-cell{text-orientation:sideways;writing-mode:vertical-rl}}.timeline.table{flex-flow:column}.timeline .calendar-body .table{background-color:#f7f7f7}.timeline .calendar-body .table tr:first-child td{background-color:#fff;border:1px solid #000}.timeline .calendar-body .table tr:first-child td:first-child{min-width:10rem}.timeline .calendar-body .table tr:first-child span.day-label{left:0;right:0}.timeline .calendar-body .table tr:nth-child(2) td{border-width:1px;border-color:inherit}.timeline .calendar-body .table>:not(:first-child){border-top:none!important}\n"] }]
        }], ctorParameters: function () { return [{ type: BsCalendarMonthService }, { type: BsTimelineService }]; }, propDecorators: { timeSlotElements: [{
                type: ViewChildren,
                args: ['slot']
            }], modeChange: [{
                type: Output
            }], mode: [{
                type: Input
            }], weekOptionsChange: [{
                type: Output
            }], weekOptions: [{
                type: Input
            }], timelineOptionsChange: [{
                type: Output
            }], timelineOptions: [{
                type: Input
            }], maxInnerHeight: [{
                type: Input
            }], resources: [{
                type: Input
            }], onMousemove: [{
                type: HostListener,
                args: ['document:mousemove', ['$event']]
            }], onMouseUp: [{
                type: HostListener,
                args: ['document:mouseup', ['$event']]
            }] } });

const availableScales = [
    { time: 60, pixels: 60, markerSize: 900 },
    { time: 120, pixels: 60, markerSize: 900 },
    { time: 300, pixels: 60, markerSize: 900 },
    { time: 900, pixels: 60, markerSize: 900 },
    { time: 3600, pixels: 60, markerSize: 21600 },
    { time: 7200, pixels: 60, markerSize: 21600 },
    { time: 10800, pixels: 60, markerSize: 21600 },
    { time: 21600, pixels: 60, markerSize: 21600 },
    { time: 86400, pixels: 60, markerSize: 604800 }, // 6000s / 60px   = 100 s/px
];

class DateOffsetPipe {
    transform(value) {
        const today = new Date(value.start);
        today.setHours(0);
        today.setMinutes(0);
        today.setSeconds(0);
        return (value.start.getTime() - today.getTime()) / 1000;
    }
}
DateOffsetPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: DateOffsetPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
DateOffsetPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: DateOffsetPipe, name: "dateOffset" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: DateOffsetPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'dateOffset'
                }]
        }] });

class BsSchedulerModule {
}
BsSchedulerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSchedulerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsSchedulerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSchedulerModule, declarations: [BsSchedulerComponent,
        BsSecondsTimespanPipe,
        BsSecondsTodayOffsetPipe,
        DateOffsetPipe,
        DayOfWeekPipe,
        ResourceGroupPresenterComponent], imports: [CommonModule], exports: [BsSchedulerComponent,
        ResourceGroupPresenterComponent] });
BsSchedulerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSchedulerModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSchedulerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsSchedulerComponent,
                        BsSecondsTimespanPipe,
                        BsSecondsTodayOffsetPipe,
                        DateOffsetPipe,
                        DayOfWeekPipe,
                        ResourceGroupPresenterComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsSchedulerComponent,
                        ResourceGroupPresenterComponent
                    ]
                }]
        }] });

class BsListGroupItemComponent {
    constructor() {
    }
    ngOnInit() {
    }
}
BsListGroupItemComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsListGroupItemComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsListGroupItemComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsListGroupItemComponent, selector: "bs-list-group-item", ngImport: i0, template: "<li class=\"list-group-item\">\n    <ng-content></ng-content>\n</li>", styles: [".list-group-item{margin-bottom:-1px}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsListGroupItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-list-group-item', template: "<li class=\"list-group-item\">\n    <ng-content></ng-content>\n</li>", styles: [".list-group-item{margin-bottom:-1px}\n"] }]
        }], ctorParameters: function () { return []; } });

class BsListGroupComponent {
    constructor() {
    }
    ngOnInit() {
    }
}
BsListGroupComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsListGroupComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsListGroupComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsListGroupComponent, selector: "bs-list-group", queries: [{ propertyName: "items", predicate: BsListGroupItemComponent }], ngImport: i0, template: "<ul class=\"list-group mt-0\">\n    <ng-content></ng-content>\n</ul>", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsListGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-list-group', template: "<ul class=\"list-group mt-0\">\n    <ng-content></ng-content>\n</ul>", styles: [""] }]
        }], ctorParameters: function () { return []; }, propDecorators: { items: [{
                type: ContentChildren,
                args: [BsListGroupItemComponent]
            }] } });

class BsListGroupModule {
}
BsListGroupModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsListGroupModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsListGroupModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsListGroupModule, declarations: [BsListGroupComponent,
        BsListGroupItemComponent], imports: [CommonModule], exports: [BsListGroupComponent,
        BsListGroupItemComponent] });
BsListGroupModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsListGroupModule, imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsListGroupModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    declarations: [
                        BsListGroupComponent,
                        BsListGroupItemComponent
                    ],
                    exports: [
                        BsListGroupComponent,
                        BsListGroupItemComponent
                    ]
                }]
        }] });

class BsModalComponent {
    constructor() { }
}
BsModalComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsModalComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsModalComponent, selector: "bs-modal", ngImport: i0, template: "<div class=\"modal-dialog\">\n    <div class=\"modal-content\">\n        <div class=\"modal-header\">\n            <ng-container *ngTemplateOutlet=\"header\"></ng-container>\n        </div>\n        <div class=\"modal-body\">\n            <ng-container *ngTemplateOutlet=\"body\"></ng-container>\n        </div>\n        <div class=\"modal-footer\">\n            <ng-container *ngTemplateOutlet=\"footer\"></ng-container>\n        </div>\n    </div>\n</div>", styles: [""], directives: [{ type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-modal', template: "<div class=\"modal-dialog\">\n    <div class=\"modal-content\">\n        <div class=\"modal-header\">\n            <ng-container *ngTemplateOutlet=\"header\"></ng-container>\n        </div>\n        <div class=\"modal-body\">\n            <ng-container *ngTemplateOutlet=\"body\"></ng-container>\n        </div>\n        <div class=\"modal-footer\">\n            <ng-container *ngTemplateOutlet=\"footer\"></ng-container>\n        </div>\n    </div>\n</div>", styles: [""] }]
        }], ctorParameters: function () { return []; } });

const MODAL_CONTENT = new InjectionToken('ModalContent');

class BsModalContentComponent {
    constructor(content) {
        this.instance = null;
        //#region Monitor @slideUpDown hooks
        this.animationState = '';
        this.animationStateChanged = new EventEmitter();
        this.content = content;
    }
    onAnimationChanged(event) {
        this.animationStateChanged.emit(event);
    }
}
BsModalContentComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalContentComponent, deps: [{ token: MODAL_CONTENT }], target: i0.ɵɵFactoryTarget.Component });
BsModalContentComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsModalContentComponent, selector: "bs-modal-content", ngImport: i0, template: "<div class=\"modal d-block\" tabindex=\"-1\"\n     [@fadeInOut]=\"animationState\"\n     (@fadeInOut.start)=\"onAnimationChanged($event)\"\n     (@fadeInOut.done)=\"onAnimationChanged($event)\">\n\n    <ng-container *ngTemplateOutlet=\"content; context: { $implicit: this }\" ></ng-container>\n\n</div>", styles: [""], directives: [{ type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], animations: [FadeInOutAnimation] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalContentComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-modal-content', animations: [FadeInOutAnimation], template: "<div class=\"modal d-block\" tabindex=\"-1\"\n     [@fadeInOut]=\"animationState\"\n     (@fadeInOut.start)=\"onAnimationChanged($event)\"\n     (@fadeInOut.done)=\"onAnimationChanged($event)\">\n\n    <ng-container *ngTemplateOutlet=\"content; context: { $implicit: this }\" ></ng-container>\n\n</div>", styles: [""] }]
        }], ctorParameters: function () {
        return [{ type: i0.TemplateRef, decorators: [{
                        type: Inject,
                        args: [MODAL_CONTENT]
                    }] }];
    } });

class BsModalHeaderDirective {
    constructor(modal, template) {
        modal.header = template;
    }
}
BsModalHeaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalHeaderDirective, deps: [{ token: BsModalComponent }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
BsModalHeaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsModalHeaderDirective, selector: "[bsModalHeader]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalHeaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsModalHeader]'
                }]
        }], ctorParameters: function () { return [{ type: BsModalComponent }, { type: i0.TemplateRef }]; } });

class BsModalBodyDirective {
    constructor(modal, template) {
        modal.body = template;
    }
}
BsModalBodyDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalBodyDirective, deps: [{ token: BsModalComponent }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
BsModalBodyDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsModalBodyDirective, selector: "[bsModalBody]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalBodyDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsModalBody]'
                }]
        }], ctorParameters: function () { return [{ type: BsModalComponent }, { type: i0.TemplateRef }]; } });

class BsModalFooterDirective {
    constructor(modal, template) {
        modal.footer = template;
    }
}
BsModalFooterDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalFooterDirective, deps: [{ token: BsModalComponent }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
BsModalFooterDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsModalFooterDirective, selector: "[bsModalFooter]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalFooterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsModalFooter]'
                }]
        }], ctorParameters: function () { return [{ type: BsModalComponent }, { type: i0.TemplateRef }]; } });

class BsModalModule {
}
BsModalModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsModalModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalModule, declarations: [BsModalHeaderDirective,
        BsModalBodyDirective,
        BsModalFooterDirective,
        BsModalComponent,
        BsModalContentComponent], imports: [CommonModule,
        OverlayModule], exports: [BsModalHeaderDirective,
        BsModalBodyDirective,
        BsModalFooterDirective,
        BsModalComponent] });
BsModalModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalModule, imports: [[
            CommonModule,
            OverlayModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsModalHeaderDirective,
                        BsModalBodyDirective,
                        BsModalFooterDirective,
                        BsModalComponent,
                        BsModalContentComponent
                    ],
                    imports: [
                        CommonModule,
                        OverlayModule
                    ],
                    exports: [
                        BsModalHeaderDirective,
                        BsModalBodyDirective,
                        BsModalFooterDirective,
                        BsModalComponent
                    ]
                }]
        }] });

class BsModalService {
    constructor(overlay, parentInjector, componentFactoryResolver) {
        this.overlay = overlay;
        this.parentInjector = parentInjector;
        this.componentFactoryResolver = componentFactoryResolver;
    }
    show(template) {
        const injector = Injector.create({
            providers: [{ provide: MODAL_CONTENT, useValue: template }],
            parent: this.parentInjector
        });
        const portal = new ComponentPortal(BsModalContentComponent, null, injector, this.componentFactoryResolver);
        const overlayRef = this.overlay.create({
            scrollStrategy: this.overlay.scrollStrategies.reposition(),
            positionStrategy: this.overlay.position()
                .global().centerHorizontally().bottom('0').top('0').left('0').right('0'),
            width: '100%',
            hasBackdrop: true
        });
        const componentInstance = overlayRef.attach(portal);
        componentInstance.instance['instance'] = {
            component: componentInstance,
            overlay: overlayRef
        };
        return componentInstance.instance;
    }
    hide(modal) {
        modal.animationStateChanged.pipe(filter(ev => ev.phaseName === 'done' && ev.toState === 'void'), take(1)).subscribe(() => {
            var _a;
            (_a = modal['instance']) === null || _a === void 0 ? void 0 : _a.overlay.dispose();
        });
        modal.animationState = 'void';
    }
}
BsModalService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalService, deps: [{ token: i1$1.Overlay }, { token: i0.Injector }, { token: i0.ComponentFactoryResolver }], target: i0.ɵɵFactoryTarget.Injectable });
BsModalService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalService, providedIn: BsModalModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsModalService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: BsModalModule
                }]
        }], ctorParameters: function () { return [{ type: i1$1.Overlay }, { type: i0.Injector }, { type: i0.ComponentFactoryResolver }]; } });

class BsMultiselectComponent {
    constructor() {
        this.items = [];
        this.selectedItems = [];
    }
    itemChange(item, event) {
        if (event.target.checked) {
            this.selectedItems.push(item);
        }
        else {
            this.selectedItems.splice(this.selectedItems.findIndex((i) => i === item), 1);
        }
    }
}
BsMultiselectComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsMultiselectComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsMultiselectComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsMultiselectComponent, selector: "bs-multiselect", inputs: { items: "items", selectedItems: "selectedItems" }, viewQueries: [{ propertyName: "defaultButtonTemplate", first: true, predicate: ["defaultButtonTemplate"], descendants: true }], ngImport: i0, template: "<div bsDropdown [hasBackdrop]=\"true\" [closeOnClickOutside]=\"true\">\n    <button bsDropdownToggle class=\"btn btn-primary\">\n        <ng-container *ngTemplateOutlet=\"buttonTemplate ?? defaultButtonTemplate; context: { $implicit: selectedItems.length }\"></ng-container>\n    </button>\n    <div *bsDropdownMenu class=\"bg-white mw-250px p-3 border rounded shadow\">\n        <ng-container *ngTemplateOutlet=\"headerTemplate\"></ng-container>\n        <hr class=\"my-2\" *ngIf=\"headerTemplate\">\n        <label *ngFor=\"let item of items\" class=\"form-check\">\n            <input type=\"checkbox\" [checked]=\"selectedItems.indexOf(item) > -1\" (change)=\"itemChange(item, $event)\" class=\"form-check-input\">\n            <span class=\"form-check-label\">{{ item }}</span>\n        </label>\n        <hr class=\"my-2\" *ngIf=\"footerTemplate\">\n        <ng-container *ngTemplateOutlet=\"footerTemplate\"></ng-container>\n    </div>\n</div>\n<ng-template #defaultButtonTemplate let-count>\n    {{ count }} selected\n</ng-template>", styles: [".mw-250px{min-width:250px}\n"], directives: [{ type: BsDropdownDirective, selector: "[bsDropdown]", inputs: ["hasBackdrop", "sameWidth", "closeOnClickOutside", "sameDropdownWidth", "isOpen"], outputs: ["isOpenChange"] }, { type: BsDropdownToggleDirective, selector: "[bsDropdownToggle]" }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: BsDropdownMenuDirective, selector: "[bsDropdownMenu]" }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsMultiselectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-multiselect', template: "<div bsDropdown [hasBackdrop]=\"true\" [closeOnClickOutside]=\"true\">\n    <button bsDropdownToggle class=\"btn btn-primary\">\n        <ng-container *ngTemplateOutlet=\"buttonTemplate ?? defaultButtonTemplate; context: { $implicit: selectedItems.length }\"></ng-container>\n    </button>\n    <div *bsDropdownMenu class=\"bg-white mw-250px p-3 border rounded shadow\">\n        <ng-container *ngTemplateOutlet=\"headerTemplate\"></ng-container>\n        <hr class=\"my-2\" *ngIf=\"headerTemplate\">\n        <label *ngFor=\"let item of items\" class=\"form-check\">\n            <input type=\"checkbox\" [checked]=\"selectedItems.indexOf(item) > -1\" (change)=\"itemChange(item, $event)\" class=\"form-check-input\">\n            <span class=\"form-check-label\">{{ item }}</span>\n        </label>\n        <hr class=\"my-2\" *ngIf=\"footerTemplate\">\n        <ng-container *ngTemplateOutlet=\"footerTemplate\"></ng-container>\n    </div>\n</div>\n<ng-template #defaultButtonTemplate let-count>\n    {{ count }} selected\n</ng-template>", styles: [".mw-250px{min-width:250px}\n"] }]
        }], propDecorators: { items: [{
                type: Input
            }], selectedItems: [{
                type: Input
            }], defaultButtonTemplate: [{
                type: ViewChild,
                args: ['defaultButtonTemplate']
            }] } });

class BsHeaderTemplateDirective {
    constructor(template, multiselect) {
        multiselect.headerTemplate = template;
    }
}
BsHeaderTemplateDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsHeaderTemplateDirective, deps: [{ token: i0.TemplateRef }, { token: BsMultiselectComponent }], target: i0.ɵɵFactoryTarget.Directive });
BsHeaderTemplateDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsHeaderTemplateDirective, selector: "[bsHeaderTemplate]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsHeaderTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsHeaderTemplate]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }, { type: BsMultiselectComponent }]; } });

class BsFooterTemplateDirective {
    constructor(template, multiselect) {
        multiselect.footerTemplate = template;
    }
}
BsFooterTemplateDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFooterTemplateDirective, deps: [{ token: i0.TemplateRef }, { token: BsMultiselectComponent }], target: i0.ɵɵFactoryTarget.Directive });
BsFooterTemplateDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsFooterTemplateDirective, selector: "[bsFooterTemplate]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFooterTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsFooterTemplate]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }, { type: BsMultiselectComponent }]; } });

class BsButtonTemplateDirective {
    constructor(template, multiselect) {
        multiselect.buttonTemplate = template;
    }
}
BsButtonTemplateDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsButtonTemplateDirective, deps: [{ token: i0.TemplateRef }, { token: BsMultiselectComponent }], target: i0.ɵɵFactoryTarget.Directive });
BsButtonTemplateDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsButtonTemplateDirective, selector: "[bsButtonTemplate]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsButtonTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsButtonTemplate]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }, { type: BsMultiselectComponent }]; } });

class BsMultiselectModule {
}
BsMultiselectModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsMultiselectModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsMultiselectModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsMultiselectModule, declarations: [BsMultiselectComponent,
        BsHeaderTemplateDirective,
        BsFooterTemplateDirective,
        BsButtonTemplateDirective], imports: [CommonModule,
        BsDropdownModule,
        FocusOnLoadModule], exports: [BsMultiselectComponent,
        BsHeaderTemplateDirective,
        BsFooterTemplateDirective,
        BsButtonTemplateDirective] });
BsMultiselectModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsMultiselectModule, imports: [[
            CommonModule,
            BsDropdownModule,
            FocusOnLoadModule,
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsMultiselectModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsMultiselectComponent,
                        BsHeaderTemplateDirective,
                        BsFooterTemplateDirective,
                        BsButtonTemplateDirective
                    ],
                    imports: [
                        CommonModule,
                        BsDropdownModule,
                        FocusOnLoadModule,
                    ],
                    exports: [
                        BsMultiselectComponent,
                        BsHeaderTemplateDirective,
                        BsFooterTemplateDirective,
                        BsButtonTemplateDirective
                    ]
                }]
        }] });

class BsNavbarComponent {
    constructor() {
        this.autoclose = true;
        this.expandButtonTemplate = null;
        this.isExpanded$ = new BehaviorSubject(false);
    }
    toggleExpanded() {
        this.isExpanded$.pipe(take(1)).subscribe((isExpanded) => {
            this.isExpanded$.next(!isExpanded);
        });
    }
}
BsNavbarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsNavbarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsNavbarComponent, selector: "bs-navbar", inputs: { autoclose: "autoclose" }, viewQueries: [{ propertyName: "nav", first: true, predicate: ["nav"], descendants: true }], ngImport: i0, template: "<nav #nav class=\"navbar navbar-expand-md position-fixed navbar-dark bg-dark\">\n    <div class=\"container-fluid\">\n        <div class=\"d-flex w-100 w-md-auto\">\n            <ng-content select=\"bs-navbar-brand\"></ng-content>\n            <div class=\"flex-end d-md-none d-flex tw\">\n                <button (click)=\"toggleExpanded()\" title=\"Expand/collapse menu\" class=\"align-self-center\" [class.navbar-toggler]=\"!expandButtonTemplate\" [class.bg-transparent]=\"expandButtonTemplate\" [class.shadow-none]=\"expandButtonTemplate\" [class.border-0]=\"expandButtonTemplate\" type=\"button\">\n                    <ng-container *ngTemplateOutlet=\"expandButtonTemplate ?? defaultExpandButton; context: { $implicit: (isExpanded$ | async) ? 'open' : 'closed' }\"></ng-container>\n                </button>\n            </div>\n        </div>\n        <ng-content></ng-content>\n    </div>\n</nav>\n\n<ng-template #defaultExpandButton>\n    <span class=\"navbar-toggler-icon\"></span>\n</ng-template>", styles: ["nav{left:0;top:0;right:0;z-index:10}@media (min-width: 768px){.mx-md-unset{margin-left:0!important;margin-right:0!important}.w-md-auto{width:auto!important}}.tw{margin:-.5rem -.6666666667rem}\n"], directives: [{ type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], pipes: { "async": i1.AsyncPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-navbar', template: "<nav #nav class=\"navbar navbar-expand-md position-fixed navbar-dark bg-dark\">\n    <div class=\"container-fluid\">\n        <div class=\"d-flex w-100 w-md-auto\">\n            <ng-content select=\"bs-navbar-brand\"></ng-content>\n            <div class=\"flex-end d-md-none d-flex tw\">\n                <button (click)=\"toggleExpanded()\" title=\"Expand/collapse menu\" class=\"align-self-center\" [class.navbar-toggler]=\"!expandButtonTemplate\" [class.bg-transparent]=\"expandButtonTemplate\" [class.shadow-none]=\"expandButtonTemplate\" [class.border-0]=\"expandButtonTemplate\" type=\"button\">\n                    <ng-container *ngTemplateOutlet=\"expandButtonTemplate ?? defaultExpandButton; context: { $implicit: (isExpanded$ | async) ? 'open' : 'closed' }\"></ng-container>\n                </button>\n            </div>\n        </div>\n        <ng-content></ng-content>\n    </div>\n</nav>\n\n<ng-template #defaultExpandButton>\n    <span class=\"navbar-toggler-icon\"></span>\n</ng-template>", styles: ["nav{left:0;top:0;right:0;z-index:10}@media (min-width: 768px){.mx-md-unset{margin-left:0!important;margin-right:0!important}.w-md-auto{width:auto!important}}.tw{margin:-.5rem -.6666666667rem}\n"] }]
        }], propDecorators: { nav: [{
                type: ViewChild,
                args: ['nav']
            }], autoclose: [{
                type: Input
            }] } });

class BsNavbarNavComponent {
    constructor(bsNavbar) {
        this.collapse$ = new BehaviorSubject(true);
        this.windowWidth$ = new BehaviorSubject(null);
        this.isResizing$ = new BehaviorSubject(false);
        this.destroyed$ = new Subject();
        this.bsNavbar = bsNavbar;
        this.showNavs$ = combineLatest([this.bsNavbar.isExpanded$, this.windowWidth$])
            .pipe(filter(([isExpanded, windowWidth]) => {
            return windowWidth !== null;
        }))
            .pipe(map(([isExpanded, windowWidth]) => {
            if (windowWidth === null) {
                throw 'windowWidth should not be null here';
            }
            else if (windowWidth >= 768) {
                return true;
            }
            else if (isExpanded) {
                return true;
            }
            else {
                return false;
            }
        }));
        this.windowWidth$
            .pipe(debounceTime(300), takeUntil(this.destroyed$))
            .subscribe(() => {
            this.isResizing$.next(false);
        });
        this.onWindowResize();
    }
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
    //#region collapse
    set collapse(value) {
        this.collapse$.next(value);
    }
    get collapse() {
        return this.collapse$.value;
    }
    //#endregion
    onWindowResize() {
        this.isResizing$.next(true);
        if (typeof window !== 'undefined') {
            this.windowWidth$.next(window.innerWidth);
        }
    }
}
BsNavbarNavComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarNavComponent, deps: [{ token: BsNavbarComponent }], target: i0.ɵɵFactoryTarget.Component });
BsNavbarNavComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsNavbarNavComponent, selector: "bs-navbar-nav", inputs: { collapse: "collapse" }, host: { listeners: { "window:resize": "onWindowResize()" } }, ngImport: i0, template: "<div class=\"navbar-collapse w-100 show\" [class.collapse]=\"collapse$ | async\" *ngIf=\"showNavs$ | async\" [@slideUpDown] [@.disabled]=\"isResizing$ | async\">\n    <ul class=\"navbar-nav mr-auto\">\n        <ng-content></ng-content>\n    </ul>\n</div>", styles: [":host{margin-right:auto}@media screen and (max-width: 767px){:host{width:100%!important}.navbar-collapse.collapse{overflow:hidden}}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], pipes: { "async": i1.AsyncPipe }, animations: [SlideUpDownAnimation] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarNavComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-navbar-nav', animations: [SlideUpDownAnimation], template: "<div class=\"navbar-collapse w-100 show\" [class.collapse]=\"collapse$ | async\" *ngIf=\"showNavs$ | async\" [@slideUpDown] [@.disabled]=\"isResizing$ | async\">\n    <ul class=\"navbar-nav mr-auto\">\n        <ng-content></ng-content>\n    </ul>\n</div>", styles: [":host{margin-right:auto}@media screen and (max-width: 767px){:host{width:100%!important}.navbar-collapse.collapse{overflow:hidden}}\n"] }]
        }], ctorParameters: function () { return [{ type: BsNavbarComponent }]; }, propDecorators: { collapse: [{
                type: Input
            }], onWindowResize: [{
                type: HostListener,
                args: ['window:resize']
            }] } });

class BsNavbarItemComponent {
    constructor(navbar, parentDropdown, element) {
        this.navbar = navbar;
        this.element = element;
        this.hasDropdown = false;
        this.anchorTag = null;
        this.parentDropdown = parentDropdown;
    }
    ngAfterContentChecked() {
        this.anchorTag = this.element.nativeElement.querySelector('li a');
        if (this.hasDropdown) {
            (this.anchorTag) && this.anchorTag.classList.add('dropdown-toggle');
            if (this.anchorTag && !this.anchorTag.getAttribute('close-init-b')) {
                this.anchorTag.setAttribute('close-init-b', '1');
                this.anchorTag.addEventListener('click', (ev) => {
                    ev.preventDefault();
                    // Normally there should be only one dropdown in this list
                    this.dropdowns.forEach((dropdown) => {
                        if (!(dropdown.isVisible = !dropdown.isVisible)) {
                            dropdown.childDropdowns.forEach((child) => {
                                child.isVisible = false;
                            });
                        }
                    });
                    return false;
                });
            }
        }
        else {
            // Close if this is a link
            if ((this.dropdowns.length === 0) && this.anchorTag && !this.anchorTag.getAttribute('close-init-a')) {
                this.anchorTag.setAttribute('close-init-a', '1');
                this.anchorTag.addEventListener('click', (ev) => {
                    let d = this.parentDropdown;
                    while (d && d.autoclose) {
                        d.isVisible = false;
                        d = d.parentDropdown;
                    }
                    if (this.navbar.autoclose) {
                        this.navbar.isExpanded$.next(false);
                    }
                });
            }
        }
    }
}
BsNavbarItemComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarItemComponent, deps: [{ token: BsNavbarComponent }, { token: BsNavbarDropdownComponent, optional: true }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
BsNavbarItemComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsNavbarItemComponent, selector: "bs-navbar-item", queries: [{ propertyName: "dropdowns", predicate: i0.forwardRef(function () { return BsNavbarDropdownComponent; }) }], ngImport: i0, template: "<li [class.nav-item]=\"parentDropdown === null\" [class.dropdown]=\"(dropdowns.length > 0) && (parentDropdown === null)\" [class.dropend]=\"(dropdowns.length > 0) && (parentDropdown !== null)\">\n    <ng-content></ng-content>\n</li>", styles: ["li.dropend ::ng-deep a.dropdown-toggle{padding-right:1.5rem}li.dropend ::ng-deep a.dropdown-toggle:after{position:absolute;right:.5rem;top:.75rem}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-navbar-item', template: "<li [class.nav-item]=\"parentDropdown === null\" [class.dropdown]=\"(dropdowns.length > 0) && (parentDropdown === null)\" [class.dropend]=\"(dropdowns.length > 0) && (parentDropdown !== null)\">\n    <ng-content></ng-content>\n</li>", styles: ["li.dropend ::ng-deep a.dropdown-toggle{padding-right:1.5rem}li.dropend ::ng-deep a.dropdown-toggle:after{position:absolute;right:.5rem;top:.75rem}\n"] }]
        }], ctorParameters: function () {
        return [{ type: BsNavbarComponent }, { type: BsNavbarDropdownComponent, decorators: [{
                        type: Optional
                    }] }, { type: i0.ElementRef }];
    }, propDecorators: { dropdowns: [{
                type: ContentChildren,
                args: [forwardRef(() => BsNavbarDropdownComponent)]
            }] } });

class BsNavbarDropdownComponent {
    constructor(parentDropdown, navbarItem) {
        this.autoclose = true;
        this.isVisible = false;
        this.parentDropdown = parentDropdown;
        this.navbarItem = navbarItem;
    }
    get elementsToExclude() {
        return [this.navbarItem.anchorTag].filter((a) => a).map((a) => a);
    }
}
BsNavbarDropdownComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarDropdownComponent, deps: [{ token: BsNavbarDropdownComponent, host: true, optional: true, skipSelf: true }, { token: forwardRef(() => BsNavbarItemComponent), host: true }], target: i0.ɵɵFactoryTarget.Component });
BsNavbarDropdownComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsNavbarDropdownComponent, selector: "bs-navbar-dropdown", inputs: { autoclose: "autoclose" }, queries: [{ propertyName: "childDropdowns", predicate: i0.forwardRef(function () { return BsNavbarDropdownComponent; }), descendants: true }], ngImport: i0, template: "<ul class=\"dropdown-menu\" [class.show]=\"isVisible\" [class.submenu]=\"!!parentDropdown\" (clickOutside)=\"isVisible = false\" [exclude]=\"elementsToExclude\" aria-labelledby=\"navbarDropdown\">\n    <ng-content></ng-content>\n</ul>", styles: ["@media (max-width: 767px){.submenu{margin-left:.5rem;margin-right:.5rem}}@media (min-width: 768px){.submenu{position:absolute;left:100%;top:-1px}}\n"], directives: [{ type: i1$2.ClickOutsideDirective, selector: "[clickOutside]", inputs: ["clickOutsideEnabled", "attachOutsideOnClick", "delayClickOutsideInit", "emitOnBlur", "exclude", "excludeBeforeClick", "clickOutsideEvents"], outputs: ["clickOutside"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarDropdownComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-navbar-dropdown', template: "<ul class=\"dropdown-menu\" [class.show]=\"isVisible\" [class.submenu]=\"!!parentDropdown\" (clickOutside)=\"isVisible = false\" [exclude]=\"elementsToExclude\" aria-labelledby=\"navbarDropdown\">\n    <ng-content></ng-content>\n</ul>", styles: ["@media (max-width: 767px){.submenu{margin-left:.5rem;margin-right:.5rem}}@media (min-width: 768px){.submenu{position:absolute;left:100%;top:-1px}}\n"] }]
        }], ctorParameters: function () {
        return [{ type: BsNavbarDropdownComponent, decorators: [{
                        type: SkipSelf
                    }, {
                        type: Host
                    }, {
                        type: Optional
                    }] }, { type: BsNavbarItemComponent, decorators: [{
                        type: Host
                    }, {
                        type: Inject,
                        args: [forwardRef(() => BsNavbarItemComponent)]
                    }] }];
    }, propDecorators: { autoclose: [{
                type: Input
            }], childDropdowns: [{
                type: ContentChildren,
                args: [forwardRef(() => BsNavbarDropdownComponent), { descendants: true }]
            }] } });

class DropdownToggleDirective {
    constructor(elementRef, bsNavbarItem, parentDropdown) {
        this.elementRef = elementRef;
        this.bsNavbarItem = bsNavbarItem;
    }
    ngAfterContentInit() {
        if (this.bsNavbarItem.dropdowns.length > 0) {
            this.bsNavbarItem.hasDropdown = true;
        }
    }
}
DropdownToggleDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: DropdownToggleDirective, deps: [{ token: i0.ElementRef }, { token: forwardRef(() => BsNavbarItemComponent) }, { token: forwardRef(() => BsNavbarDropdownComponent), optional: true }], target: i0.ɵɵFactoryTarget.Directive });
DropdownToggleDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: DropdownToggleDirective, selector: "bs-navbar-item", queries: [{ propertyName: "childDropdowns", predicate: BsNavbarDropdownComponent }], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: DropdownToggleDirective, decorators: [{
            type: Directive,
            args: [{
                    // selector: 'bs-navbar-item > a[routerLink]',
                    selector: 'bs-navbar-item',
                    queries: {
                        childDropdowns: new ContentChildren(BsNavbarDropdownComponent)
                    }
                }]
        }], ctorParameters: function () {
        return [{ type: i0.ElementRef }, { type: BsNavbarItemComponent, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => BsNavbarItemComponent)]
                    }] }, { type: BsNavbarDropdownComponent, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [forwardRef(() => BsNavbarDropdownComponent)]
                    }] }];
    } });

class NavLinkDirective {
    constructor(elementRef, parentDropdown) {
        this.elementRef = elementRef;
        if (parentDropdown == null) {
            this.elementRef.nativeElement.classList.add('nav-link');
        }
        else {
            this.elementRef.nativeElement.classList.add('dropdown-item');
        }
    }
}
NavLinkDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NavLinkDirective, deps: [{ token: i0.ElementRef }, { token: forwardRef(() => BsNavbarDropdownComponent), optional: true }], target: i0.ɵɵFactoryTarget.Directive });
NavLinkDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: NavLinkDirective, selector: "bs-navbar-item > a[routerLink]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NavLinkDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'bs-navbar-item > a[routerLink]'
                }]
        }], ctorParameters: function () {
        return [{ type: i0.ElementRef }, { type: BsNavbarDropdownComponent, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [forwardRef(() => BsNavbarDropdownComponent)]
                    }] }];
    } });

class NavbarContentDirective {
    constructor(element, platformId) {
        this.element = element;
        this.platformId = platformId;
        this.destroyed$ = new Subject();
        this.viewInit$ = new BehaviorSubject(false);
        this.navbar$ = new BehaviorSubject(null);
        this.resizeObserver = null;
        this.initialPadding = 0;
        combineLatest([this.viewInit$, this.navbar$])
            .pipe(filter(([viewInit, navbar]) => {
            return viewInit && !!navbar;
        }))
            .pipe(take(1))
            .pipe(takeUntil(this.destroyed$))
            .subscribe(([viewInit, navbar]) => {
            if (!isPlatformServer(platformId)) {
                // Initialize the ResizeObserver
                this.resizeObserver = new ResizeObserver((entries) => {
                    const height = navbar
                        ? navbar.nav.nativeElement.offsetHeight
                        : entries[0].contentRect.height;
                    this.element.nativeElement.style.paddingTop = (this.initialPadding + height) + 'px';
                });
                // Monitor the size
                const px = getComputedStyle(this.element.nativeElement).getPropertyValue('padding-top');
                const pt = parseInt(px.replace(/px$/, ''));
                this.initialPadding = isNaN(pt) ? 0 : pt;
                if (this.resizeObserver && navbar) {
                    this.resizeObserver.observe(navbar.nav.nativeElement);
                }
            }
        });
        this.destroyed$
            .pipe(filter(d => !!d))
            .subscribe(() => {
            var _a, _b;
            (_a = this.resizeObserver) === null || _a === void 0 ? void 0 : _a.unobserve((_b = this.navbar$.value) === null || _b === void 0 ? void 0 : _b.nav.nativeElement);
        });
    }
    set navbar(value) {
        this.navbar$.next(value);
    }
    ngAfterViewInit() {
        this.viewInit$.next(true);
    }
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
}
NavbarContentDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NavbarContentDirective, deps: [{ token: i0.ElementRef }, { token: PLATFORM_ID }], target: i0.ɵɵFactoryTarget.Directive });
NavbarContentDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: NavbarContentDirective, selector: "[navbarContent]", inputs: { navbar: ["navbarContent", "navbar"] }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NavbarContentDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[navbarContent]'
                }]
        }], ctorParameters: function () {
        return [{ type: i0.ElementRef }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [PLATFORM_ID]
                    }] }];
    }, propDecorators: { navbar: [{
                type: Input,
                args: ['navbarContent']
            }] } });

class BsNavbarBrandComponent {
    constructor() {
        this.routerLink = [];
        this.mxAuto = true;
    }
}
BsNavbarBrandComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarBrandComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsNavbarBrandComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsNavbarBrandComponent, selector: "bs-navbar-brand", inputs: { routerLink: "routerLink" }, host: { properties: { "class.mx-auto": "this.mxAuto" } }, ngImport: i0, template: "<a class=\"navbar-brand mx-auto mx-md-unset\" [routerLink]=\"routerLink\">\n    <ng-content></ng-content>\n</a>", styles: [""], directives: [{ type: i1$3.RouterLinkWithHref, selector: "a[routerLink],area[routerLink]", inputs: ["target", "queryParams", "fragment", "queryParamsHandling", "preserveFragment", "skipLocationChange", "replaceUrl", "state", "relativeTo", "routerLink"] }, { type: NavLinkDirective, selector: "bs-navbar-item > a[routerLink]" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarBrandComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-navbar-brand', template: "<a class=\"navbar-brand mx-auto mx-md-unset\" [routerLink]=\"routerLink\">\n    <ng-content></ng-content>\n</a>", styles: [""] }]
        }], propDecorators: { routerLink: [{
                type: Input
            }], mxAuto: [{
                type: HostBinding,
                args: ['class.mx-auto']
            }] } });

class BsExpandButtonDirective {
    constructor(navbar, templateRef) {
        navbar.expandButtonTemplate = templateRef;
    }
}
BsExpandButtonDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsExpandButtonDirective, deps: [{ token: BsNavbarComponent }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
BsExpandButtonDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsExpandButtonDirective, selector: "[bsExpandButton]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsExpandButtonDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsExpandButton]'
                }]
        }], ctorParameters: function () { return [{ type: BsNavbarComponent }, { type: i0.TemplateRef }]; } });

class BsNavbarTogglerComponent {
    constructor() {
        //#region State
        this._state = 'closed';
        this.stateChange = new EventEmitter();
        //#endregion
        this.toggleOnClick = true;
    }
    get state() {
        return this._state;
    }
    set state(value) {
        this._state = value;
        this.stateChange.emit(this._state);
    }
    toggleState(ev) {
        if (this.toggleOnClick) {
            switch (this._state) {
                case 'open':
                    this.state = 'closed';
                    break;
                default:
                    this.state = 'open';
                    break;
            }
        }
    }
}
BsNavbarTogglerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarTogglerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsNavbarTogglerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsNavbarTogglerComponent, selector: "bs-navbar-toggler", inputs: { state: "state", toggleOnClick: "toggleOnClick" }, outputs: { stateChange: "stateChange" }, host: { listeners: { "click": "toggleState($event)" } }, ngImport: i0, template: "<div class=\"navbar-toggler float-left\" [ngClass]=\"state\">\n    <div></div>\n    <div></div>\n    <div></div>\n</div>", styles: [":host{align-self:start;top:0;right:0}.navbar-toggler{padding:.75rem 1rem;border:none}.navbar-toggler>div{width:25px;height:2px;background:#BBB;margin:6px 0;transition:.4s}.navbar-toggler.open>div:nth-of-type(1){transform:rotate(-45deg) translate(-7px,5px)}.navbar-toggler.open>div:nth-of-type(2){opacity:0}.navbar-toggler.open>div:nth-of-type(3){transform:rotate(45deg) translate(-6px,-4px)}@media (min-width: 768px){.navbar-toggler.auto>div:nth-of-type(1){transform:rotate(-45deg) translate(-7px,5px)}.navbar-toggler.auto>div:nth-of-type(2){opacity:0}.navbar-toggler.auto>div:nth-of-type(3){transform:rotate(45deg) translate(-6px,-4px)}}\n"], directives: [{ type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarTogglerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-navbar-toggler', template: "<div class=\"navbar-toggler float-left\" [ngClass]=\"state\">\n    <div></div>\n    <div></div>\n    <div></div>\n</div>", styles: [":host{align-self:start;top:0;right:0}.navbar-toggler{padding:.75rem 1rem;border:none}.navbar-toggler>div{width:25px;height:2px;background:#BBB;margin:6px 0;transition:.4s}.navbar-toggler.open>div:nth-of-type(1){transform:rotate(-45deg) translate(-7px,5px)}.navbar-toggler.open>div:nth-of-type(2){opacity:0}.navbar-toggler.open>div:nth-of-type(3){transform:rotate(45deg) translate(-6px,-4px)}@media (min-width: 768px){.navbar-toggler.auto>div:nth-of-type(1){transform:rotate(-45deg) translate(-7px,5px)}.navbar-toggler.auto>div:nth-of-type(2){opacity:0}.navbar-toggler.auto>div:nth-of-type(3){transform:rotate(45deg) translate(-6px,-4px)}}\n"] }]
        }], propDecorators: { stateChange: [{
                type: Output
            }], state: [{
                type: Input
            }], toggleOnClick: [{
                type: Input
            }], toggleState: [{
                type: HostListener,
                args: ['click', ['$event']]
            }] } });

class BsNavbarModule {
}
BsNavbarModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsNavbarModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarModule, declarations: [BsNavbarComponent,
        BsNavbarNavComponent,
        BsNavbarDropdownComponent,
        BsNavbarItemComponent,
        DropdownToggleDirective,
        NavLinkDirective,
        NavbarContentDirective,
        BsNavbarBrandComponent,
        BsExpandButtonDirective,
        BsNavbarTogglerComponent], imports: [CommonModule,
        RouterModule,
        ClickOutsideModule], exports: [BsNavbarComponent,
        BsNavbarNavComponent,
        BsNavbarDropdownComponent,
        BsNavbarItemComponent,
        DropdownToggleDirective,
        NavLinkDirective,
        NavbarContentDirective,
        BsNavbarBrandComponent,
        BsExpandButtonDirective,
        BsNavbarTogglerComponent] });
BsNavbarModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarModule, imports: [[
            CommonModule,
            RouterModule,
            ClickOutsideModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsNavbarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsNavbarComponent,
                        BsNavbarNavComponent,
                        BsNavbarDropdownComponent,
                        BsNavbarItemComponent,
                        DropdownToggleDirective,
                        NavLinkDirective,
                        NavbarContentDirective,
                        BsNavbarBrandComponent,
                        BsExpandButtonDirective,
                        BsNavbarTogglerComponent
                    ],
                    imports: [
                        CommonModule,
                        RouterModule,
                        ClickOutsideModule
                    ],
                    exports: [
                        BsNavbarComponent,
                        BsNavbarNavComponent,
                        BsNavbarDropdownComponent,
                        BsNavbarItemComponent,
                        DropdownToggleDirective,
                        NavLinkDirective,
                        NavbarContentDirective,
                        BsNavbarBrandComponent,
                        BsExpandButtonDirective,
                        BsNavbarTogglerComponent
                    ]
                }]
        }] });

class BsOffcanvasHeaderComponent {
    constructor() { }
    ngOnInit() {
    }
}
BsOffcanvasHeaderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsOffcanvasHeaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsOffcanvasHeaderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsOffcanvasHeaderComponent, selector: "bs-offcanvas-header", ngImport: i0, template: "<div class=\"offcanvas-header\">\n    <ng-content></ng-content>\n</div>\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsOffcanvasHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-offcanvas-header', template: "<div class=\"offcanvas-header\">\n    <ng-content></ng-content>\n</div>\n", styles: [""] }]
        }], ctorParameters: function () { return []; } });

class BsOffcanvasBodyComponent {
    constructor() { }
    ngOnInit() {
    }
}
BsOffcanvasBodyComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsOffcanvasBodyComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsOffcanvasBodyComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsOffcanvasBodyComponent, selector: "bs-offcanvas-body", ngImport: i0, template: "<div class=\"offcanvas-body small\">\n    <ng-content></ng-content>\n</div>", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsOffcanvasBodyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-offcanvas-body', template: "<div class=\"offcanvas-body small\">\n    <ng-content></ng-content>\n</div>", styles: [""] }]
        }], ctorParameters: function () { return []; } });

const OFFCANVAS_CONTENT = new InjectionToken('OffcanvasContent');

class BsOffcanvasComponent {
    constructor(content) {
        this.size = null;
        this.displayBlock = true;
        this.positionAbsolute = true;
        this.width100 = true;
        this.instance = null;
        this.show$ = new BehaviorSubject(false);
        this.position$ = new BehaviorSubject('bottom');
        this.content = content;
        this.offcanvasClass$ = this.position$
            .pipe(map((pos) => `offcanvas-${pos}`));
        this.offcanvasHeight100$ = this.position$
            .pipe(map((pos) => {
            switch (this.position) {
                case 'top':
                case 'bottom':
                    return false;
                default:
                    return true;
            }
        }));
    }
    //#region Position
    set position(value) {
        this.position$.next(value);
    }
    get position() {
        return this.position$.value;
    }
}
BsOffcanvasComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsOffcanvasComponent, deps: [{ token: OFFCANVAS_CONTENT }], target: i0.ɵɵFactoryTarget.Component });
BsOffcanvasComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsOffcanvasComponent, selector: "bs-offcanvas", inputs: { size: "size" }, host: { properties: { "class.d-block": "this.displayBlock", "class.position-absolute": "this.positionAbsolute", "class.w-100": "this.width100" } }, ngImport: i0, template: "<div class=\"offcanvas overflow-hidden\" [class]=\"offcanvasClass$ | async\"\n     [class.show]=\"show$ | async\"\n     [class.h-100]=\"offcanvasHeight100$ | async\"\n     [style.height.px]=\"size\"\n     [class.oc-max-width]=\"['start', 'end'].includes(position)\"\n     [class.oc-max-height]=\"['top', 'bottom'].includes(position)\">\n    <ng-container *ngTemplateOutlet=\"content; context: { $implicit: this }\" ></ng-container>\n</div>", styles: [".offcanvas.oc-max-width{max-width:calc(100% - 40px)}.offcanvas.oc-max-height{max-height:calc(100% - 40px)}.offcanvas{visibility:unset}.offcanvas.offcanvas-bottom,.offcanvas.offcanvas-top{height:auto}.offcanvas.offcanvas-top{position:initial}\n"], directives: [{ type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], pipes: { "async": i1.AsyncPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsOffcanvasComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-offcanvas', template: "<div class=\"offcanvas overflow-hidden\" [class]=\"offcanvasClass$ | async\"\n     [class.show]=\"show$ | async\"\n     [class.h-100]=\"offcanvasHeight100$ | async\"\n     [style.height.px]=\"size\"\n     [class.oc-max-width]=\"['start', 'end'].includes(position)\"\n     [class.oc-max-height]=\"['top', 'bottom'].includes(position)\">\n    <ng-container *ngTemplateOutlet=\"content; context: { $implicit: this }\" ></ng-container>\n</div>", styles: [".offcanvas.oc-max-width{max-width:calc(100% - 40px)}.offcanvas.oc-max-height{max-height:calc(100% - 40px)}.offcanvas{visibility:unset}.offcanvas.offcanvas-bottom,.offcanvas.offcanvas-top{height:auto}.offcanvas.offcanvas-top{position:initial}\n"] }]
        }], ctorParameters: function () {
        return [{ type: i0.TemplateRef, decorators: [{
                        type: Inject,
                        args: [OFFCANVAS_CONTENT]
                    }] }];
    }, propDecorators: { size: [{
                type: Input
            }], displayBlock: [{
                type: HostBinding,
                args: ['class.d-block']
            }], positionAbsolute: [{
                type: HostBinding,
                args: ['class.position-absolute']
            }], width100: [{
                type: HostBinding,
                args: ['class.w-100']
            }] } });

class BsOffcanvasCloseDirective {
    constructor(offcanvasService) {
        this.offcanvasService = offcanvasService;
    }
    onClick() {
        this.offcanvasService.hide(this.bsOffcanvasClose);
    }
}
BsOffcanvasCloseDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsOffcanvasCloseDirective, deps: [{ token: BsOffcanvasService }], target: i0.ɵɵFactoryTarget.Directive });
BsOffcanvasCloseDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsOffcanvasCloseDirective, selector: "[bsOffcanvasClose]", inputs: { bsOffcanvasClose: "bsOffcanvasClose" }, host: { listeners: { "click": "onClick()" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsOffcanvasCloseDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsOffcanvasClose]'
                }]
        }], ctorParameters: function () { return [{ type: BsOffcanvasService }]; }, propDecorators: { bsOffcanvasClose: [{
                type: Input
            }], onClick: [{
                type: HostListener,
                args: ['click']
            }] } });

class BsOffcanvasModule {
}
BsOffcanvasModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsOffcanvasModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsOffcanvasModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsOffcanvasModule, declarations: [BsOffcanvasComponent,
        BsOffcanvasHeaderComponent,
        BsOffcanvasBodyComponent,
        BsOffcanvasCloseDirective], imports: [CommonModule,
        OverlayModule], exports: [BsOffcanvasComponent,
        BsOffcanvasHeaderComponent,
        BsOffcanvasBodyComponent,
        BsOffcanvasCloseDirective] });
BsOffcanvasModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsOffcanvasModule, imports: [[
            CommonModule,
            OverlayModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsOffcanvasModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsOffcanvasComponent,
                        BsOffcanvasHeaderComponent,
                        BsOffcanvasBodyComponent,
                        BsOffcanvasCloseDirective
                    ],
                    imports: [
                        CommonModule,
                        OverlayModule
                    ],
                    exports: [
                        BsOffcanvasComponent,
                        BsOffcanvasHeaderComponent,
                        BsOffcanvasBodyComponent,
                        BsOffcanvasCloseDirective
                    ]
                }]
        }] });

class BsOffcanvasService {
    constructor(overlay, parentInjector) {
        this.overlay = overlay;
        this.parentInjector = parentInjector;
    }
    show(template, position, hasBackdrop = false, backdropClick = null) {
        const injector = Injector.create({
            providers: [{ provide: OFFCANVAS_CONTENT, useValue: template }],
            parent: this.parentInjector
        });
        const portal = new ComponentPortal(BsOffcanvasComponent, null, injector);
        const positioning = this.overlay.position().global();
        const config = {
            scrollStrategy: this.overlay.scrollStrategies.reposition(),
            positionStrategy: positioning,
            hasBackdrop,
        };
        switch (position) {
            case 'bottom':
                positioning.centerHorizontally().bottom('0');
                config.width = '100%';
                break;
            case 'top':
                positioning.centerHorizontally().top('0');
                config.width = '100%';
                break;
            case 'start':
                positioning.centerVertically().left('0');
                config.height = '100%';
                break;
            case 'end':
                positioning.centerVertically().right('0');
                config.height = '100%';
                break;
            default:
                throw 'Invalid value for position';
        }
        const overlayRef = this.overlay.create(config);
        const componentInstance = overlayRef.attach(portal);
        componentInstance.instance.position = position;
        setTimeout(() => componentInstance.instance.show$.next(true));
        componentInstance.instance['instance'] = {
            component: componentInstance,
            overlay: overlayRef
        };
        if (hasBackdrop && backdropClick) {
            overlayRef.backdropClick().subscribe(() => backdropClick(componentInstance.instance));
        }
        return componentInstance.instance;
    }
    hide(offcanvas) {
        offcanvas.show$.next(false);
        setTimeout(() => { var _a; return (_a = offcanvas['instance']) === null || _a === void 0 ? void 0 : _a.overlay.dispose(); }, 300);
    }
}
BsOffcanvasService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsOffcanvasService, deps: [{ token: i1$1.Overlay }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Injectable });
BsOffcanvasService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsOffcanvasService, providedIn: BsOffcanvasModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsOffcanvasService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: BsOffcanvasModule
                }]
        }], ctorParameters: function () { return [{ type: i1$1.Overlay }, { type: i0.Injector }]; } });

class BsRatingComponent {
    constructor() {
        this.destroyed$ = new Subject();
        this.maximum$ = new BehaviorSubject(5);
        this.value$ = new BehaviorSubject(3);
        this.previewValue$ = new BehaviorSubject(null);
        //#endregion
        //#region Value
        this.valueChange = new EventEmitter();
        this.starsChange = new EventEmitter();
        this.stars$ = combineLatest([this.maximum$, this.previewValue$, this.value$])
            .pipe(map(([maximum, previewValue, value]) => {
            const v = previewValue !== null && previewValue !== void 0 ? previewValue : value;
            return [
                ...[...Array(v).keys()].map(i => true),
                ...[...Array(maximum - v).keys()].map(i => false)
            ];
        }));
        combineLatest([this.previewValue$, this.value$])
            .pipe(takeUntil(this.destroyed$))
            .subscribe(([previewValue, value]) => {
            const v = previewValue !== null && previewValue !== void 0 ? previewValue : value;
            this.starsChange.emit(v);
        });
    }
    //#region Maximum
    set maximum(value) {
        this.maximum$.next(value);
    }
    get value() {
        return this.value$.value;
    }
    set value(value) {
        this.value$.next(value);
        this.valueChange.emit(value);
    }
    //#endregion
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
    hoverValue(index) {
        this.previewValue$.next(index + 1);
    }
    selectValue(index) {
        this.value = index + 1;
    }
    onMouseLeave() {
        this.previewValue$.next(null);
    }
}
BsRatingComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsRatingComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsRatingComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsRatingComponent, selector: "bs-rating", inputs: { maximum: "maximum", value: "value" }, outputs: { valueChange: "valueChange", starsChange: "starsChange" }, host: { listeners: { "mouseleave": "onMouseLeave()" } }, ngImport: i0, template: "<span class=\"cursor-pointer\" *ngFor=\"let star of (stars$ | async), let i = index\" (mouseenter)=\"hoverValue(i)\" (click)=\"selectValue(i)\">\n    {{ star ? '&#9733;' : '&#9734;' }}\n</span>", styles: [""], directives: [{ type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], pipes: { "async": i1.AsyncPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsRatingComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-rating', template: "<span class=\"cursor-pointer\" *ngFor=\"let star of (stars$ | async), let i = index\" (mouseenter)=\"hoverValue(i)\" (click)=\"selectValue(i)\">\n    {{ star ? '&#9733;' : '&#9734;' }}\n</span>", styles: [""] }]
        }], ctorParameters: function () { return []; }, propDecorators: { maximum: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], starsChange: [{
                type: Output
            }], value: [{
                type: Input
            }], onMouseLeave: [{
                type: HostListener,
                args: ['mouseleave']
            }] } });

class BsRatingModule {
}
BsRatingModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsRatingModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsRatingModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsRatingModule, declarations: [BsRatingComponent], imports: [CommonModule], exports: [BsRatingComponent] });
BsRatingModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsRatingModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsRatingModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsRatingComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsRatingComponent
                    ]
                }]
        }] });

class BsScrollspyDirective {
    constructor(element) {
        this.element = element;
    }
}
BsScrollspyDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsScrollspyDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
BsScrollspyDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsScrollspyDirective, selector: "[bsScrollspy]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsScrollspyDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsScrollspy]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; } });

class BsScrollOffsetService {
    constructor(routerConfig) {
        this.routerConfig = routerConfig;
    }
    getScrollOffset() {
        if (!this.routerConfig.scrollOffset) {
            return [0, 0];
        }
        else if (Array.isArray(this.routerConfig.scrollOffset)) {
            return this.routerConfig.scrollOffset;
        }
        else {
            return this.routerConfig.scrollOffset();
        }
    }
}
BsScrollOffsetService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsScrollOffsetService, deps: [{ token: ROUTER_CONFIGURATION }], target: i0.ɵɵFactoryTarget.Injectable });
BsScrollOffsetService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsScrollOffsetService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsScrollOffsetService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [ROUTER_CONFIGURATION]
                    }] }];
    } });

class BsScrollspyComponent {
    constructor(scrollOffsetService, document, zone) {
        this.scrollOffsetService = scrollOffsetService;
        this.zone = zone;
        this.destroyed$ = new Subject();
        this.viewInit$ = new BehaviorSubject(false);
        this.contentInit$ = new BehaviorSubject(false);
        this.activeDirective = null;
        this.doc = document;
        combineLatest([this.viewInit$, this.contentInit$])
            .pipe(filter(([viewInit, contentInit]) => viewInit && contentInit), take(1))
            .pipe(takeUntil(this.destroyed$))
            .subscribe(() => {
            // this.setActiveDirective();
            this.scrollToCurrentInSpy();
        });
    }
    ngAfterViewInit() {
        this.viewInit$.next(true);
    }
    ngAfterContentInit() {
        this.contentInit$.next(true);
    }
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
    onWindowScroll() {
        this.setActiveDirective();
        this.scrollToCurrentInSpy();
    }
    setActiveDirective() {
        var _a;
        const offsetY = this.scrollOffsetService.getScrollOffset()[1];
        const dirs = this.directives.filter((d) => d.element.nativeElement.getBoundingClientRect().y < offsetY);
        if (this.directives.length === 0) {
            this.activeDirective = null;
        }
        else if (dirs.length === 0) {
            this.activeDirective = (_a = this.directives.get(0)) !== null && _a !== void 0 ? _a : null;
        }
        else {
            this.activeDirective = dirs[dirs.length - 1];
        }
    }
    scrollToCurrentInSpy() {
        if ((typeof window !== 'undefined') && (window.innerWidth >= 768)) {
            if (this.activeDirective) {
                const index = this.directives.toArray().findIndex((v, i) => v === this.activeDirective);
                const anchor = this.anchors.get(index);
                if (anchor && anchor.nativeElement.parentElement) {
                    anchor.nativeElement.scrollIntoView({ block: 'nearest', inline: 'nearest' });
                }
            }
        }
    }
    scrollToHeader(directive) {
        if (typeof window !== 'undefined') {
            const header = directive.element.nativeElement;
            const offsetY = this.scrollOffsetService.getScrollOffset()[1];
            const y = header.getBoundingClientRect().top + window.scrollY - offsetY + 1;
            window.scrollTo({ top: y, behavior: 'smooth' });
        }
    }
}
BsScrollspyComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsScrollspyComponent, deps: [{ token: BsScrollOffsetService }, { token: DOCUMENT }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
BsScrollspyComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsScrollspyComponent, selector: "bs-scrollspy", host: { listeners: { "window:scroll": "onWindowScroll($event)" } }, queries: [{ propertyName: "directives", predicate: BsScrollspyDirective, descendants: true }], viewQueries: [{ propertyName: "anchors", predicate: ["anchor"], descendants: true }], ngImport: i0, template: "<div class=\"spy\">\n    <ul class=\"text-muted\">\n        <li *ngFor=\"let dir of directives; let i = index\">\n            <span [attr.data-index]=\"i\" class=\"cursor-pointer\" [ngClass]=\"'nav' + dir.element.nativeElement.tagName\" [class.fw-bold]=\"activeDirective?.element === dir.element\" (click)=\"scrollToHeader(dir)\" [title]=\"dir.element.nativeElement.textContent\" #anchor>\n                {{ dir.element.nativeElement.textContent }}\n            </span>\n        </li>\n    </ul>\n</div>\n<div class=\"content\">\n    <ng-content></ng-content>\n</div>", styles: [":host{display:block}.spy>ul{list-style-type:none;padding-left:0}.spy>ul>li:hover{color:rgba(var(--bs-dark-rgb),var(--bs-text-opacity))!important}.spy>ul>li{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}@media (min-width: 768px){:host{display:grid;grid-template-areas:\"content toc\";grid-template-columns:auto 200px;grid-template-rows:auto;grid-gap:inherit;gap:inherit;grid-area:main}.spy{position:sticky;top:5rem;right:0;z-index:2;height:calc(100vh - 7rem);overflow-y:auto;grid-area:toc}.spy>ul{padding-left:2rem}}.navH2{margin-left:20px}.navH3{margin-left:40px}.navH4{margin-left:60px}\n"], directives: [{ type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsScrollspyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-scrollspy', template: "<div class=\"spy\">\n    <ul class=\"text-muted\">\n        <li *ngFor=\"let dir of directives; let i = index\">\n            <span [attr.data-index]=\"i\" class=\"cursor-pointer\" [ngClass]=\"'nav' + dir.element.nativeElement.tagName\" [class.fw-bold]=\"activeDirective?.element === dir.element\" (click)=\"scrollToHeader(dir)\" [title]=\"dir.element.nativeElement.textContent\" #anchor>\n                {{ dir.element.nativeElement.textContent }}\n            </span>\n        </li>\n    </ul>\n</div>\n<div class=\"content\">\n    <ng-content></ng-content>\n</div>", styles: [":host{display:block}.spy>ul{list-style-type:none;padding-left:0}.spy>ul>li:hover{color:rgba(var(--bs-dark-rgb),var(--bs-text-opacity))!important}.spy>ul>li{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}@media (min-width: 768px){:host{display:grid;grid-template-areas:\"content toc\";grid-template-columns:auto 200px;grid-template-rows:auto;grid-gap:inherit;gap:inherit;grid-area:main}.spy{position:sticky;top:5rem;right:0;z-index:2;height:calc(100vh - 7rem);overflow-y:auto;grid-area:toc}.spy>ul{padding-left:2rem}}.navH2{margin-left:20px}.navH3{margin-left:40px}.navH4{margin-left:60px}\n"] }]
        }], ctorParameters: function () {
        return [{ type: BsScrollOffsetService }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [DOCUMENT]
                    }] }, { type: i0.NgZone }];
    }, propDecorators: { directives: [{
                type: ContentChildren,
                args: [BsScrollspyDirective, { descendants: true }]
            }], anchors: [{
                type: ViewChildren,
                args: ['anchor']
            }], onWindowScroll: [{
                type: HostListener,
                args: ['window:scroll', ['$event']]
            }] } });

class BsScrollspyModule {
}
BsScrollspyModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsScrollspyModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsScrollspyModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsScrollspyModule, declarations: [BsScrollspyComponent,
        BsScrollspyDirective], imports: [CommonModule], exports: [BsScrollspyComponent,
        BsScrollspyDirective] });
BsScrollspyModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsScrollspyModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsScrollspyModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsScrollspyComponent,
                        BsScrollspyDirective
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsScrollspyComponent,
                        BsScrollspyDirective
                    ]
                }]
        }] });

class BsInListPipe {
    transform(items, parameter) {
        return items.some(item => item.id === parameter);
    }
}
BsInListPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsInListPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
BsInListPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsInListPipe, name: "inList" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsInListPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'inList'
                }]
        }] });

class BsSelect2Component {
    constructor() {
        this.isOpen = false;
        this.suggestions$ = new BehaviorSubject([]);
        this.isLoading$ = new BehaviorSubject(false);
        this.hostWidth$ = new BehaviorSubject(200);
        this.searchterm = '';
        this.suggestions = [];
        this.provideSuggestions = new EventEmitter();
        this.selectedItems = [];
        this.isFocused = false;
        this.charWidth = 10;
        this.searchWidth = 20;
    }
    ngAfterViewInit() {
        this.onResize();
    }
    onProvideSuggestions(value) {
        this.searchWidth = this.charWidth * (this.searchterm.length + 2);
        if (value === '') {
            this.isOpen = false;
            this.suggestions$.next([]);
        }
        else {
            this.isLoading$.next(true);
            this.isOpen = true;
            this.provideSuggestions.emit(value);
        }
    }
    onSuggestionClicked(suggestion) {
        this.searchterm = '';
        this.isOpen = false;
        const existing = this.selectedItems.find((value, index) => value.id === suggestion.id);
        if (existing === undefined) {
            this.selectedItems.push(suggestion);
        }
        else {
            this.selectedItems.splice(this.selectedItems.indexOf(existing), 1);
        }
        this.searchBox.nativeElement.focus();
    }
    onRemoveItem(item, event) {
        event.stopPropagation();
        this.selectedItems.splice(this.selectedItems.indexOf(item), 1);
        this.focus();
    }
    onResize() {
        if (typeof window !== 'undefined') {
            this.hostWidth$.next(this.itemsBox.nativeElement.offsetWidth);
        }
    }
    focus() {
        this.searchBox.nativeElement.focus();
    }
}
BsSelect2Component.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSelect2Component, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsSelect2Component.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsSelect2Component, selector: "bs-select2", inputs: { searchterm: "searchterm", suggestions: "suggestions", selectedItems: "selectedItems" }, outputs: { provideSuggestions: "provideSuggestions" }, host: { listeners: { "window:resize": "onResize()", "click": "focus()" }, properties: { "class.focus": "this.isFocused" } }, viewQueries: [{ propertyName: "defaultItemTemplate", first: true, predicate: ["defaultItemTemplate"], descendants: true, static: true }, { propertyName: "searchBox", first: true, predicate: ["searchBox"], descendants: true }, { propertyName: "itemsBox", first: true, predicate: ["itemsBox"], descendants: true }], ngImport: i0, template: "<div bsDropdown [(isOpen)]=\"isOpen\" [hasBackdrop]=\"false\" [closeOnClickOutside]=\"true\" #itemsBox class=\"items-box text-wrap\">\n    <ng-container *ngFor=\"let item of selectedItems\">\n        <ng-container *ngTemplateOutlet=\"itemTemplate ?? defaultItemTemplate; context: { item: item, select2: this }\"></ng-container>\n    </ng-container>\n\n    <input type=\"text\" autocomplete=\"off\"\n        [(ngModel)]=\"searchterm\"\n        (ngModelChange)=\"onProvideSuggestions($event)\"\n        (focus)=\"isFocused=true\"\n        (blur)=\"isFocused=false\"\n        [style.width.px]=\"searchWidth\"\n        #searchBox />\n    <div *bsDropdownMenu>\n        <ul class=\"dropdown-menu d-block position-static p-0\" [style.width.px]=\"hostWidth$ | async\">\n            <li *ngFor=\"let suggestion of suggestions\" (click)=\"onSuggestionClicked(suggestion)\" [class.selected]=\"selectedItems | inList:suggestion.id\">{{ suggestion.text }}</li>\n        </ul>\n    </div>\n</div>\n\n<ng-template #defaultItemTemplate let-item=\"item\" let-select2=\"select2\">\n    <span class=\"select2-item\">\n        <span (click)=\"select2.onRemoveItem(item,$event)\">\u00D7</span>\n        {{ item.text }}\n    </span>\n</ng-template>\n", styles: [".items-box{display:block;position:relative;width:100%;min-height:38px;padding:0 5px 3px;cursor:text;border:1px solid #ccc}.items-box .select2-item{display:inline-block;background-color:#e4e4e4;color:#1a1a1a;border:1px solid #aaa;border-radius:4px;margin-top:5px;margin-right:5px;padding:0 5px;cursor:default;user-select:none;-webkit-user-select:none}.items-box .select2-item>span{cursor:pointer;color:#999}.items-box .select2-item>span:hover{color:#333}.items-box input{border:none;outline:0;margin:5px 0 2px;background:none}:host{display:block;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out}:host.focus{color:#495057;background-color:#fff;border-color:#80bdff!important;outline:0;box-shadow:0 0 0 .2rem #007bff40}ul{max-height:200px;overflow-y:auto}ul>li{padding:10px;cursor:pointer}ul>li.selected{background:#ddd}ul>li:hover{color:#fff;background-color:#5897fb}\n"], directives: [{ type: BsDropdownDirective, selector: "[bsDropdown]", inputs: ["hasBackdrop", "sameWidth", "closeOnClickOutside", "sameDropdownWidth", "isOpen"], outputs: ["isOpenChange"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i3$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i3$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i3$1.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { type: BsDropdownMenuDirective, selector: "[bsDropdownMenu]" }], pipes: { "async": i1.AsyncPipe, "inList": BsInListPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSelect2Component, decorators: [{
            type: Component,
            args: [{ selector: 'bs-select2', template: "<div bsDropdown [(isOpen)]=\"isOpen\" [hasBackdrop]=\"false\" [closeOnClickOutside]=\"true\" #itemsBox class=\"items-box text-wrap\">\n    <ng-container *ngFor=\"let item of selectedItems\">\n        <ng-container *ngTemplateOutlet=\"itemTemplate ?? defaultItemTemplate; context: { item: item, select2: this }\"></ng-container>\n    </ng-container>\n\n    <input type=\"text\" autocomplete=\"off\"\n        [(ngModel)]=\"searchterm\"\n        (ngModelChange)=\"onProvideSuggestions($event)\"\n        (focus)=\"isFocused=true\"\n        (blur)=\"isFocused=false\"\n        [style.width.px]=\"searchWidth\"\n        #searchBox />\n    <div *bsDropdownMenu>\n        <ul class=\"dropdown-menu d-block position-static p-0\" [style.width.px]=\"hostWidth$ | async\">\n            <li *ngFor=\"let suggestion of suggestions\" (click)=\"onSuggestionClicked(suggestion)\" [class.selected]=\"selectedItems | inList:suggestion.id\">{{ suggestion.text }}</li>\n        </ul>\n    </div>\n</div>\n\n<ng-template #defaultItemTemplate let-item=\"item\" let-select2=\"select2\">\n    <span class=\"select2-item\">\n        <span (click)=\"select2.onRemoveItem(item,$event)\">\u00D7</span>\n        {{ item.text }}\n    </span>\n</ng-template>\n", styles: [".items-box{display:block;position:relative;width:100%;min-height:38px;padding:0 5px 3px;cursor:text;border:1px solid #ccc}.items-box .select2-item{display:inline-block;background-color:#e4e4e4;color:#1a1a1a;border:1px solid #aaa;border-radius:4px;margin-top:5px;margin-right:5px;padding:0 5px;cursor:default;user-select:none;-webkit-user-select:none}.items-box .select2-item>span{cursor:pointer;color:#999}.items-box .select2-item>span:hover{color:#333}.items-box input{border:none;outline:0;margin:5px 0 2px;background:none}:host{display:block;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out}:host.focus{color:#495057;background-color:#fff;border-color:#80bdff!important;outline:0;box-shadow:0 0 0 .2rem #007bff40}ul{max-height:200px;overflow-y:auto}ul>li{padding:10px;cursor:pointer}ul>li.selected{background:#ddd}ul>li:hover{color:#fff;background-color:#5897fb}\n"] }]
        }], propDecorators: { defaultItemTemplate: [{
                type: ViewChild,
                args: ['defaultItemTemplate', { static: true }]
            }], searchBox: [{
                type: ViewChild,
                args: ['searchBox']
            }], itemsBox: [{
                type: ViewChild,
                args: ['itemsBox']
            }], searchterm: [{
                type: Input
            }], suggestions: [{
                type: Input
            }], provideSuggestions: [{
                type: Output
            }], selectedItems: [{
                type: Input
            }], isFocused: [{
                type: HostBinding,
                args: ['class.focus']
            }], onResize: [{
                type: HostListener,
                args: ['window:resize']
            }], focus: [{
                type: HostListener,
                args: ['click']
            }] } });

class BsItemTemplateDirective {
    constructor(select2component, templateRef) {
        this.select2component = select2component;
        this.select2component.itemTemplate = templateRef;
    }
}
BsItemTemplateDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsItemTemplateDirective, deps: [{ token: BsSelect2Component }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
BsItemTemplateDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsItemTemplateDirective, selector: "[bsItemTemplate]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsItemTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsItemTemplate]'
                }]
        }], ctorParameters: function () { return [{ type: BsSelect2Component }, { type: i0.TemplateRef }]; } });

class BsInListModule {
}
BsInListModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsInListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsInListModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsInListModule, declarations: [BsInListPipe], imports: [CommonModule], exports: [BsInListPipe] });
BsInListModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsInListModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsInListModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsInListPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsInListPipe
                    ]
                }]
        }] });

class BsSelect2Module {
}
BsSelect2Module.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSelect2Module, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsSelect2Module.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSelect2Module, declarations: [BsSelect2Component,
        BsItemTemplateDirective], imports: [CommonModule,
        FormsModule,
        BsDropdownModule,
        BsInListModule], exports: [BsSelect2Component,
        BsItemTemplateDirective] });
BsSelect2Module.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSelect2Module, imports: [[
            CommonModule,
            FormsModule,
            BsDropdownModule,
            BsInListModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsSelect2Module, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsSelect2Component,
                        BsItemTemplateDirective
                    ],
                    imports: [
                        CommonModule,
                        FormsModule,
                        BsDropdownModule,
                        BsInListModule
                    ],
                    exports: [
                        BsSelect2Component,
                        BsItemTemplateDirective
                    ]
                }]
        }] });

class BsTabPageComponent {
    constructor(tabControl) {
        this.disabled = false;
        this.tabControl = tabControl;
    }
}
BsTabPageComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTabPageComponent, deps: [{ token: BsTabControlComponent }], target: i0.ɵɵFactoryTarget.Component });
BsTabPageComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsTabPageComponent, selector: "bs-tab-page", inputs: { disabled: "disabled" }, queries: [{ propertyName: "headerTemplate", first: true, predicate: TemplateRef, descendants: true }], ngImport: i0, template: "<ng-content *ngIf=\"tabControl.activeTab === this\"></ng-content>", styles: [""], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTabPageComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-tab-page', template: "<ng-content *ngIf=\"tabControl.activeTab === this\"></ng-content>", styles: [""] }]
        }], ctorParameters: function () { return [{ type: BsTabControlComponent }]; }, propDecorators: { disabled: [{
                type: Input
            }], headerTemplate: [{
                type: ContentChild,
                args: [TemplateRef]
            }] } });

class BsTabControlComponent {
    constructor() {
        this.border = true;
        this.activeTab = null;
    }
    setActiveTab(tab) {
        if (!tab.disabled) {
            this.activeTab = tab;
        }
        return false;
    }
}
BsTabControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTabControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsTabControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsTabControlComponent, selector: "bs-tab-control", inputs: { border: "border" }, queries: [{ propertyName: "tabPages", predicate: BsTabPageComponent }], ngImport: i0, template: "<ul class=\"nav nav-tabs\">\n  <ng-container *ngFor=\"let tab of tabPages\">\n    <li class=\"nav-item\" (click)=\"setActiveTab(tab)\" *ngIf=\"!!tab.headerTemplate\">\n      <a class=\"nav-link\" [class.active]=\"activeTab === tab\" [class.disabled]=\"tab.disabled\" [attr.aria-current]=\"activeTab === tab ? 'page' : null\" [attr.aria-disabled]=\"tab.disabled\" href=\"\">\n        <ng-container [ngTemplateOutlet]=\"tab.headerTemplate\"></ng-container>\n      </a>\n    </li>\n  </ng-container>\n</ul>\n<div class=\"tab-content\" [class.border]=\"border && activeTab\">\n  <ng-content></ng-content>\n</div>", styles: [".tab-content{margin-top:-1px}\n"], directives: [{ type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTabControlComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-tab-control', template: "<ul class=\"nav nav-tabs\">\n  <ng-container *ngFor=\"let tab of tabPages\">\n    <li class=\"nav-item\" (click)=\"setActiveTab(tab)\" *ngIf=\"!!tab.headerTemplate\">\n      <a class=\"nav-link\" [class.active]=\"activeTab === tab\" [class.disabled]=\"tab.disabled\" [attr.aria-current]=\"activeTab === tab ? 'page' : null\" [attr.aria-disabled]=\"tab.disabled\" href=\"\">\n        <ng-container [ngTemplateOutlet]=\"tab.headerTemplate\"></ng-container>\n      </a>\n    </li>\n  </ng-container>\n</ul>\n<div class=\"tab-content\" [class.border]=\"border && activeTab\">\n  <ng-content></ng-content>\n</div>", styles: [".tab-content{margin-top:-1px}\n"] }]
        }], propDecorators: { tabPages: [{
                type: ContentChildren,
                args: [BsTabPageComponent]
            }], border: [{
                type: Input
            }] } });

class BsTabControlModule {
}
BsTabControlModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTabControlModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsTabControlModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTabControlModule, declarations: [BsTabControlComponent,
        BsTabPageComponent], imports: [CommonModule], exports: [BsTabControlComponent,
        BsTabPageComponent] });
BsTabControlModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTabControlModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTabControlModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsTabControlComponent,
                        BsTabPageComponent,
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsTabControlComponent,
                        BsTabPageComponent,
                    ]
                }]
        }] });

class EnhancedPasteDirective {
    constructor(element, model) {
        this.element = element;
        this.model = model;
        this.numberOverflow = new EventEmitter();
    }
    onPaste(event) {
        // Prevent the default paste event
        event.preventDefault();
        // Get data from clipboard
        const data = event.clipboardData || window.clipboardData;
        const contents = data.getData('text');
        // Get min and max from input
        const min = parseFloat(this.element.nativeElement.min);
        const max = parseFloat(this.element.nativeElement.max);
        const filtered = this.filterInput(contents, min, max);
        if (filtered) {
            this.numberOverflow.emit(filtered);
            if (filtered.boundaryValue) {
                // Update NgModel
                this.model.control.setValue(filtered === null || filtered === void 0 ? void 0 : filtered.boundaryValue, { emitEvent: false, onlySelf: true });
            }
        }
    }
    filterInput(value, min, max) {
        const val = parseInt(value);
        if (isNaN(val)) {
            return { boundary: 'invalid' };
        }
        else if (val > max) {
            return { boundary: 'max', inputValue: val, boundaryValue: max };
        }
        else if (val < min) {
            return { boundary: 'min', inputValue: val, boundaryValue: min };
        }
        else {
            return null;
        }
    }
}
EnhancedPasteDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: EnhancedPasteDirective, deps: [{ token: i0.ElementRef }, { token: i3$1.NgModel }], target: i0.ɵɵFactoryTarget.Directive });
EnhancedPasteDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: EnhancedPasteDirective, selector: "input[type=\"number\"][bsEnhancedPaste]", outputs: { numberOverflow: "numberOverflow" }, host: { listeners: { "paste": "onPaste($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: EnhancedPasteDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'input[type="number"][bsEnhancedPaste]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i3$1.NgModel }]; }, propDecorators: { numberOverflow: [{
                type: Output
            }], onPaste: [{
                type: HostListener,
                args: ['paste', ['$event']]
            }] } });

class BsTimepickerComponent {
    constructor(ref, zone, renderer) {
        this.ref = ref;
        this.zone = zone;
        this.renderer = renderer;
        this.isOpen = false;
        this.presetTimestamps = [];
        this.isFocused = false;
        //#region SelectedTime
        this._selectedTime = new Date();
        this.selectedTimeChange = new EventEmitter();
        const today = new Date();
        today.setHours(0);
        today.setMinutes(0);
        today.setSeconds(0);
        const interval = 900;
        this.presetTimestamps = Array.from(Array(24 * 60 * 60 / interval).keys())
            .map(i => {
            const clone = new Date(today);
            clone.setTime(clone.getTime() + i * interval * 1000);
            return clone;
        });
    }
    selectAll(box) {
        box.select();
        // box.setSelectionRange(0, box.value.length);
        this.isFocused = true;
    }
    setNumber(event, max, nextInput) {
        event.preventDefault();
        const input = event.target;
        const val = parseInt(input.value);
        if (isNaN(val)) {
            input.value = '00';
        }
        else {
            const result = Math.min(max, Math.abs(val));
            input.value = result.toString().padStart(2, '0');
            if (nextInput) {
                // const maxAllowedNumberOfDigits = input.max.length;
                if (result * 10 > parseInt(input.max)) {
                    nextInput.focus();
                }
            }
        }
    }
    setTime(time) {
        this.selectedTime = time;
        this.isOpen = false;
    }
    get selectedTime() {
        return this._selectedTime;
    }
    set selectedTime(value) {
        // this.hours = value.getHours();
        // this.minutes = value.getMinutes();
        this._selectedTime = value;
        this.selectedTimeChange.emit(this._selectedTime);
    }
    //#endregion
    //#region Hours
    // private _hours = 0;
    get hours() {
        // return this._hours;
        return this.selectedTime.getHours();
    }
    set hours(value) {
        // this._hours = value;
        const clone = new Date(this.selectedTime);
        clone.setHours(value);
        this.selectedTime = clone;
    }
    // hours = 0;
    //#endregion
    //#region Minutes
    // private _minutes = 0;
    get minutes() {
        // return this._minutes;
        return this.selectedTime.getMinutes();
    }
    set minutes(value) {
        // this._minutes = value;
        // this.selectedTime.setMinutes(value);
        const clone = new Date(this.selectedTime);
        clone.setMinutes(value);
        this.selectedTime = clone;
    }
    //#endregion
    timesEqual(time1, time2) {
        return (time1.getHours() === time2.getHours()) && (time1.getMinutes() === time2.getMinutes());
    }
}
BsTimepickerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTimepickerComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.NgZone }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Component });
BsTimepickerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsTimepickerComponent, selector: "bs-timepicker", inputs: { selectedTime: "selectedTime" }, outputs: { selectedTimeChange: "selectedTimeChange" }, ngImport: i0, template: "<div bsDropdown [(isOpen)]=\"isOpen\" [closeOnClickOutside]=\"true\" [sameDropdownWidth]=\"true\">\n    <span class=\"input-group\">\n        <span class=\"form-control d-flex\" [class.focus]=\"isFocused\">\n            <div class=\"flex-grow-1\">\n                <input type=\"number\" [min]=\"0\" [max]=\"23\" (input)=\"setNumber($event, 23, minuteBox)\" bsEnhancedPaste [ngModel]=\"hours | number: '2.0'\" (ngModelChange)=\"hours = $event\" (focus)=\"selectAll(hourBox)\" (blur)=\"isFocused = false\" #hourBox class=\"w-100 border-0 bg-transparent text-end\">\n            </div>\n            <span class=\"px-1\">:</span>\n            <div class=\"flex-grow-1\">\n                <input type=\"number\" [min]=\"0\" [max]=\"59\" (input)=\"setNumber($event, 59, null)\" bsEnhancedPaste [ngModel]=\"minutes | number: '2.0'\" (ngModelChange)=\"minutes = $event\"  (focus)=\"selectAll(minuteBox)\" (blur)=\"isFocused = false\" #minuteBox class=\"w-100 border-0 bg-transparent\">\n            </div>\n        </span>\n        <button class=\"btn btn-secondary\" (click)=\"isOpen = !isOpen\">\n            <i class=\"bi bi-clock\"></i>\n        </button>\n    </span>\n    <ul class=\"list-group\" *bsDropdownMenu>\n        <li class=\"list-group-item list-group-item-action\" [class.active]=\"timesEqual(selectedTime, timestamp)\" *ngFor=\"let timestamp of presetTimestamps\" (click)=\"setTime(timestamp)\">\n            {{ timestamp | date: 'HH:mm' }}\n        </li>\n    </ul>\n</div>", styles: [":host{display:inline-block}input::-webkit-outer-spin-button,input::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}input[type=number]{-moz-appearance:textfield;outline:0px!important}.form-control{transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out}.form-control.focus{color:#495057;background-color:#fff;border-color:#80bdff!important;outline:0;box-shadow:0 0 0 .2rem #007bff40}.list-group{max-height:250px;overflow-y:auto}.list-group .list-group-item-action{cursor:pointer}\n"], directives: [{ type: BsDropdownDirective, selector: "[bsDropdown]", inputs: ["hasBackdrop", "sameWidth", "closeOnClickOutside", "sameDropdownWidth", "isOpen"], outputs: ["isOpenChange"] }, { type: EnhancedPasteDirective, selector: "input[type=\"number\"][bsEnhancedPaste]", outputs: ["numberOverflow"] }, { type: i3$1.MinValidator, selector: "input[type=number][min][formControlName],input[type=number][min][formControl],input[type=number][min][ngModel]", inputs: ["min"] }, { type: i3$1.MaxValidator, selector: "input[type=number][max][formControlName],input[type=number][max][formControl],input[type=number][max][ngModel]", inputs: ["max"] }, { type: i3$1.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { type: i3$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i3$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i3$1.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { type: BsDropdownMenuDirective, selector: "[bsDropdownMenu]" }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], pipes: { "number": i1.DecimalPipe, "date": i1.DatePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTimepickerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-timepicker', template: "<div bsDropdown [(isOpen)]=\"isOpen\" [closeOnClickOutside]=\"true\" [sameDropdownWidth]=\"true\">\n    <span class=\"input-group\">\n        <span class=\"form-control d-flex\" [class.focus]=\"isFocused\">\n            <div class=\"flex-grow-1\">\n                <input type=\"number\" [min]=\"0\" [max]=\"23\" (input)=\"setNumber($event, 23, minuteBox)\" bsEnhancedPaste [ngModel]=\"hours | number: '2.0'\" (ngModelChange)=\"hours = $event\" (focus)=\"selectAll(hourBox)\" (blur)=\"isFocused = false\" #hourBox class=\"w-100 border-0 bg-transparent text-end\">\n            </div>\n            <span class=\"px-1\">:</span>\n            <div class=\"flex-grow-1\">\n                <input type=\"number\" [min]=\"0\" [max]=\"59\" (input)=\"setNumber($event, 59, null)\" bsEnhancedPaste [ngModel]=\"minutes | number: '2.0'\" (ngModelChange)=\"minutes = $event\"  (focus)=\"selectAll(minuteBox)\" (blur)=\"isFocused = false\" #minuteBox class=\"w-100 border-0 bg-transparent\">\n            </div>\n        </span>\n        <button class=\"btn btn-secondary\" (click)=\"isOpen = !isOpen\">\n            <i class=\"bi bi-clock\"></i>\n        </button>\n    </span>\n    <ul class=\"list-group\" *bsDropdownMenu>\n        <li class=\"list-group-item list-group-item-action\" [class.active]=\"timesEqual(selectedTime, timestamp)\" *ngFor=\"let timestamp of presetTimestamps\" (click)=\"setTime(timestamp)\">\n            {{ timestamp | date: 'HH:mm' }}\n        </li>\n    </ul>\n</div>", styles: [":host{display:inline-block}input::-webkit-outer-spin-button,input::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}input[type=number]{-moz-appearance:textfield;outline:0px!important}.form-control{transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out}.form-control.focus{color:#495057;background-color:#fff;border-color:#80bdff!important;outline:0;box-shadow:0 0 0 .2rem #007bff40}.list-group{max-height:250px;overflow-y:auto}.list-group .list-group-item-action{cursor:pointer}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.NgZone }, { type: i0.Renderer2 }]; }, propDecorators: { selectedTimeChange: [{
                type: Output
            }], selectedTime: [{
                type: Input
            }] } });

class EnhancedPasteModule {
}
EnhancedPasteModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: EnhancedPasteModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
EnhancedPasteModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: EnhancedPasteModule, declarations: [EnhancedPasteDirective], imports: [CommonModule], exports: [EnhancedPasteDirective] });
EnhancedPasteModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: EnhancedPasteModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: EnhancedPasteModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        EnhancedPasteDirective
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        EnhancedPasteDirective
                    ]
                }]
        }] });

class BsTimepickerModule {
}
BsTimepickerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTimepickerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsTimepickerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTimepickerModule, declarations: [BsTimepickerComponent], imports: [CommonModule,
        FormsModule,
        EnhancedPasteModule,
        BsDropdownModule], exports: [BsTimepickerComponent] });
BsTimepickerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTimepickerModule, imports: [[
            CommonModule,
            FormsModule,
            EnhancedPasteModule,
            BsDropdownModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTimepickerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsTimepickerComponent
                    ],
                    imports: [
                        CommonModule,
                        FormsModule,
                        EnhancedPasteModule,
                        BsDropdownModule
                    ],
                    exports: [
                        BsTimepickerComponent
                    ]
                }]
        }] });

class BsToggleButtonComponent {
    constructor() {
        this.disableAnimations = true;
        //#region isToggled
        this._isToggled = false;
        this.change = new EventEmitter();
        this.isToggledChange = new EventEmitter();
        //#endregion
        //#region disabled
        this.disabled = false;
    }
    get isToggled() {
        return this._isToggled;
    }
    set isToggled(value) {
        this._isToggled = value;
        this.isToggledChange.emit(this._isToggled);
    }
    //#endregion
    onChange(event) {
        const val = event.target.checked;
        this.isToggled = val;
        this.change.emit(val);
    }
    ngAfterViewInit() {
        this.disableAnimations = false;
    }
}
BsToggleButtonComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsToggleButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsToggleButtonComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsToggleButtonComponent, selector: "bs-toggle-button", inputs: { isToggled: "isToggled", disabled: "disabled" }, outputs: { change: "change", isToggledChange: "isToggledChange" }, ngImport: i0, template: "<label class=\"form-check form-switch\">\n    <input class=\"form-check-input\" type=\"checkbox\" [checked]=\"isToggled\" (change)=\"onChange($event)\" [disabled]=\"disabled\">\n    <span class=\"form-check-label\">\n        <ng-content></ng-content>\n    </span>\n</label>", styles: [""], animations: [ColorTransitionAnimation] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsToggleButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-toggle-button', animations: [ColorTransitionAnimation], template: "<label class=\"form-check form-switch\">\n    <input class=\"form-check-input\" type=\"checkbox\" [checked]=\"isToggled\" (change)=\"onChange($event)\" [disabled]=\"disabled\">\n    <span class=\"form-check-label\">\n        <ng-content></ng-content>\n    </span>\n</label>", styles: [""] }]
        }], propDecorators: { change: [{
                type: Output
            }], isToggledChange: [{
                type: Output
            }], isToggled: [{
                type: Input
            }], disabled: [{
                type: Input
            }] } });

class BsToggleButtonModule {
}
BsToggleButtonModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsToggleButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsToggleButtonModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsToggleButtonModule, declarations: [BsToggleButtonComponent], imports: [CommonModule], exports: [BsToggleButtonComponent] });
BsToggleButtonModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsToggleButtonModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsToggleButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsToggleButtonComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsToggleButtonComponent
                    ]
                }]
        }] });

const TOOLTIP_CONTENT = new InjectionToken('TooltipContent');

class BsTooltipComponent {
    constructor(content) {
        this.positions = Position;
        this.position = Position.bottom;
        this.template = content;
    }
}
BsTooltipComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTooltipComponent, deps: [{ token: TOOLTIP_CONTENT }], target: i0.ɵɵFactoryTarget.Component });
BsTooltipComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsTooltipComponent, selector: "bs-tooltip", inputs: { position: "position" }, ngImport: i0, template: "<div [@fadeInOut] class=\"tooltip position-relative show\"\n    [class.bs-tooltip-bottom]=\"position === positions.bottom\"\n    [class.bs-tooltip-top]=\"position === positions.top\"\n    [class.bs-tooltip-start]=\"position === positions.left\"\n    [class.bs-tooltip-end]=\"position === positions.right\">\n    <div class=\"tooltip-arrow\"></div>\n    <div class=\"tooltip-inner\">\n        <ng-container *ngTemplateOutlet=\"template\"></ng-container>\n    </div>\n</div>\n", styles: [".tooltip.bs-tooltip-bottom .tooltip-arrow,.tooltip.bs-tooltip-top .tooltip-arrow{left:50%;transform:translate(-50%)}.tooltip.bs-tooltip-start .tooltip-arrow,.tooltip.bs-tooltip-end .tooltip-arrow{top:50%;transform:translateY(-50%)}\n"], directives: [{ type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], animations: [FadeInOutAnimation] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTooltipComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-tooltip', animations: [FadeInOutAnimation], template: "<div [@fadeInOut] class=\"tooltip position-relative show\"\n    [class.bs-tooltip-bottom]=\"position === positions.bottom\"\n    [class.bs-tooltip-top]=\"position === positions.top\"\n    [class.bs-tooltip-start]=\"position === positions.left\"\n    [class.bs-tooltip-end]=\"position === positions.right\">\n    <div class=\"tooltip-arrow\"></div>\n    <div class=\"tooltip-inner\">\n        <ng-container *ngTemplateOutlet=\"template\"></ng-container>\n    </div>\n</div>\n", styles: [".tooltip.bs-tooltip-bottom .tooltip-arrow,.tooltip.bs-tooltip-top .tooltip-arrow{left:50%;transform:translate(-50%)}.tooltip.bs-tooltip-start .tooltip-arrow,.tooltip.bs-tooltip-end .tooltip-arrow{top:50%;transform:translateY(-50%)}\n"] }]
        }], ctorParameters: function () {
        return [{ type: i0.TemplateRef, decorators: [{
                        type: Inject,
                        args: [TOOLTIP_CONTENT]
                    }] }];
    }, propDecorators: { position: [{
                type: Input
            }] } });

class BsTooltipDirective {
    constructor(overlay, templateRef, componentFactoryResolver, parentInjector, parent) {
        this.overlay = overlay;
        this.templateRef = templateRef;
        this.parentInjector = parentInjector;
        this.parent = parent;
        this.bsTooltip = Position.bottom;
        this.overlayRef = null;
        this.injector = Injector.create({
            providers: [{ provide: TOOLTIP_CONTENT, useValue: this.templateRef }],
            parent: this.parentInjector
        });
        this.portal = new ComponentPortal(BsTooltipComponent, null, this.injector, componentFactoryResolver);
        parent.nativeElement.onmouseenter = () => {
            this.showTooltip();
        };
        parent.nativeElement.onmouseleave = () => {
            this.hideTooltip();
        };
    }
    onBlur() {
        this.hideTooltip();
    }
    showTooltip() {
        const positions = [];
        switch (this.bsTooltip) {
            case Position.bottom:
                {
                    positions.push({
                        originX: "center",
                        originY: "bottom",
                        overlayX: "center",
                        overlayY: "top"
                    });
                }
                break;
            case Position.top:
                {
                    positions.push({
                        originX: "center",
                        originY: "top",
                        overlayX: "center",
                        overlayY: "bottom"
                    });
                }
                break;
            case Position.left:
                {
                    positions.push({
                        originX: "start",
                        originY: "center",
                        overlayX: "end",
                        overlayY: "center",
                    });
                }
                break;
            case Position.right:
                {
                    positions.push({
                        originX: "end",
                        originY: "center",
                        overlayX: "start",
                        overlayY: "center"
                    });
                }
                break;
        }
        this.overlayRef = this.overlay.create({
            scrollStrategy: this.overlay.scrollStrategies.reposition(),
            positionStrategy: this.overlay.position()
                .flexibleConnectedTo(this.parent)
                .withPositions(positions),
        });
        const component = this.overlayRef.attach(this.portal);
        component.instance.position = this.bsTooltip;
    }
    hideTooltip() {
        if (this.overlayRef) {
            this.overlayRef.detach();
            this.overlayRef.dispose();
            this.overlayRef = null;
        }
    }
}
BsTooltipDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTooltipDirective, deps: [{ token: i1$1.Overlay }, { token: i0.TemplateRef }, { token: i0.ComponentFactoryResolver }, { token: i0.Injector }, { token: i0.ElementRef, host: true, skipSelf: true }], target: i0.ɵɵFactoryTarget.Directive });
BsTooltipDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: BsTooltipDirective, selector: "*[bsTooltip]", inputs: { bsTooltip: "bsTooltip" }, host: { listeners: { "window:blur": "onBlur()" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTooltipDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '*[bsTooltip]'
                }]
        }], ctorParameters: function () {
        return [{ type: i1$1.Overlay }, { type: i0.TemplateRef }, { type: i0.ComponentFactoryResolver }, { type: i0.Injector }, { type: i0.ElementRef, decorators: [{
                        type: Host
                    }, {
                        type: SkipSelf
                    }] }];
    }, propDecorators: { bsTooltip: [{
                type: Input
            }], onBlur: [{
                type: HostListener,
                args: ['window:blur']
            }] } });

class BsTooltipModule {
}
BsTooltipModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTooltipModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsTooltipModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTooltipModule, declarations: [BsTooltipDirective,
        BsTooltipComponent], imports: [CommonModule,
        OverlayModule], exports: [BsTooltipDirective] });
BsTooltipModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTooltipModule, imports: [[
            CommonModule,
            OverlayModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTooltipModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsTooltipDirective,
                        BsTooltipComponent
                    ],
                    imports: [
                        CommonModule,
                        OverlayModule
                    ],
                    exports: [
                        BsTooltipDirective
                    ]
                }]
        }] });

class BsTypeaheadComponent {
    constructor() {
        this.isOpen = false;
        this.suggestions$ = new BehaviorSubject([]);
        this.isLoading$ = new BehaviorSubject(false);
        this.hostWidth$ = new BehaviorSubject(200);
        this.destroyed$ = new Subject();
        this.searchterm = '';
        this.isLoadingText = 'Loading...';
        this.noSuggestionsText = 'No suggestions found';
        this.provideSuggestions = new EventEmitter();
        this.suggestionSelected = new EventEmitter();
        this.searchtermChange = new EventEmitter();
        this.submitted = new EventEmitter();
        this.showNoSuggestions$ = this.suggestions$
            .pipe(map(suggestions => suggestions.length === 0));
    }
    ngAfterViewInit() {
        this.onResize();
    }
    onProvideSuggestions(value) {
        this.searchtermChange.emit(value);
        if (value === '') {
            this.isOpen = false;
            this.suggestions$.next([]);
        }
        else {
            this.isLoading$.next(true);
            this.isOpen = true;
            this.provideSuggestions.emit(value);
        }
    }
    set suggestions(value) {
        this.isLoading$.next(false);
        this.suggestions$.next(value);
    }
    suggestionClicked(suggestion) {
        this.searchterm = suggestion.text;
        this.searchtermChange.emit(this.searchterm);
        this.isOpen = false;
        this.suggestionSelected.emit(suggestion);
    }
    onSubmit() {
        this.isOpen = false;
        this.submitted.emit(this.searchterm);
    }
    focus() {
        this.textbox.nativeElement.focus();
    }
    onResize() {
        if (typeof window !== 'undefined') {
            this.hostWidth$.next(this.textbox.nativeElement.offsetWidth);
        }
    }
}
BsTypeaheadComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTypeaheadComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsTypeaheadComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: BsTypeaheadComponent, selector: "bs-typeahead", inputs: { searchterm: "searchterm", isLoadingText: "isLoadingText", noSuggestionsText: "noSuggestionsText", suggestions: "suggestions" }, outputs: { provideSuggestions: "provideSuggestions", suggestionSelected: "suggestionSelected", searchtermChange: "searchtermChange", submitted: "submitted" }, host: { listeners: { "window:resize": "onResize()" } }, viewQueries: [{ propertyName: "textbox", first: true, predicate: ["textbox"], descendants: true }], ngImport: i0, template: "<div bsDropdown [(isOpen)]=\"isOpen\" [hasBackdrop]=\"false\" [closeOnClickOutside]=\"true\">\n    <input type=\"text\" class=\"form-control\" #textbox [(ngModel)]=\"searchterm\" (ngModelChange)=\"onProvideSuggestions($event)\" (keyup.enter)=\"onSubmit()\" />\n    <div *bsDropdownMenu>\n        <ul class=\"dropdown-menu d-block position-static\" [style.width.px]=\"hostWidth$ | async\">\n            <bs-progress *ngIf=\"isLoading$ | async\" [height]=\"2\" [isIndeterminate]=\"true\"></bs-progress>\n            <li *ngIf=\"isLoading$ | async\">\n                <a class=\"dropdown-item disabled\">{{ isLoadingText }}</a>\n            </li>\n            <ng-container *ngIf=\"(isLoading$ | async) === false\">\n                <li *ngIf=\"showNoSuggestions$ | async\">\n                    <a class=\"dropdown-item disabled\">{{ noSuggestionsText }}</a>\n                </li>\n                <li *ngFor=\"let suggestion of (suggestions$ | async)\" (click)=\"suggestionClicked(suggestion)\">\n                    <a class=\"dropdown-item cursor-pointer\">{{ suggestion.text }}</a>\n                </li>\n            </ng-container>\n        </ul>\n    </div>\n</div>", styles: ["bs-progress{margin-top:-8px;margin-bottom:6px}\n"], components: [{ type: BsProgressComponent, selector: "bs-progress", inputs: ["height", "isIndeterminate"] }], directives: [{ type: BsDropdownDirective, selector: "[bsDropdown]", inputs: ["hasBackdrop", "sameWidth", "closeOnClickOutside", "sameDropdownWidth", "isOpen"], outputs: ["isOpenChange"] }, { type: i3$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i3$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i3$1.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { type: BsDropdownMenuDirective, selector: "[bsDropdownMenu]" }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], pipes: { "async": i1.AsyncPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTypeaheadComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-typeahead', template: "<div bsDropdown [(isOpen)]=\"isOpen\" [hasBackdrop]=\"false\" [closeOnClickOutside]=\"true\">\n    <input type=\"text\" class=\"form-control\" #textbox [(ngModel)]=\"searchterm\" (ngModelChange)=\"onProvideSuggestions($event)\" (keyup.enter)=\"onSubmit()\" />\n    <div *bsDropdownMenu>\n        <ul class=\"dropdown-menu d-block position-static\" [style.width.px]=\"hostWidth$ | async\">\n            <bs-progress *ngIf=\"isLoading$ | async\" [height]=\"2\" [isIndeterminate]=\"true\"></bs-progress>\n            <li *ngIf=\"isLoading$ | async\">\n                <a class=\"dropdown-item disabled\">{{ isLoadingText }}</a>\n            </li>\n            <ng-container *ngIf=\"(isLoading$ | async) === false\">\n                <li *ngIf=\"showNoSuggestions$ | async\">\n                    <a class=\"dropdown-item disabled\">{{ noSuggestionsText }}</a>\n                </li>\n                <li *ngFor=\"let suggestion of (suggestions$ | async)\" (click)=\"suggestionClicked(suggestion)\">\n                    <a class=\"dropdown-item cursor-pointer\">{{ suggestion.text }}</a>\n                </li>\n            </ng-container>\n        </ul>\n    </div>\n</div>", styles: ["bs-progress{margin-top:-8px;margin-bottom:6px}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { textbox: [{
                type: ViewChild,
                args: ['textbox']
            }], searchterm: [{
                type: Input
            }], isLoadingText: [{
                type: Input
            }], noSuggestionsText: [{
                type: Input
            }], provideSuggestions: [{
                type: Output
            }], suggestionSelected: [{
                type: Output
            }], searchtermChange: [{
                type: Output
            }], submitted: [{
                type: Output
            }], suggestions: [{
                type: Input
            }], onResize: [{
                type: HostListener,
                args: ['window:resize']
            }] } });

class BsTypeaheadModule {
}
BsTypeaheadModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTypeaheadModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsTypeaheadModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTypeaheadModule, declarations: [BsTypeaheadComponent], imports: [CommonModule,
        FormsModule,
        BsDropdownModule,
        BsProgressBarModule], exports: [BsTypeaheadComponent] });
BsTypeaheadModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTypeaheadModule, imports: [[
            CommonModule,
            FormsModule,
            BsDropdownModule,
            BsProgressBarModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsTypeaheadModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsTypeaheadComponent
                    ],
                    imports: [
                        CommonModule,
                        FormsModule,
                        BsDropdownModule,
                        BsProgressBarModule
                    ],
                    exports: [
                        BsTypeaheadComponent
                    ]
                }]
        }] });

class BsFontColorPipe {
    transform(color_hex) {
        if (color_hex === undefined || color_hex === null || color_hex.length < 7 || typeof (color_hex) !== 'string') {
            return '#FFFFFF';
        }
        const R_HEX = color_hex.substr(1, 2);
        const G_HEX = color_hex.substr(3, 2);
        const B_HEX = color_hex.substr(5, 2);
        const R_DEC = parseInt(R_HEX, 16);
        const G_DEC = parseInt(G_HEX, 16);
        const B_DEC = parseInt(B_HEX, 16);
        const CONTRAST_HEX = R_DEC * 0.299 + G_DEC * 0.587 + B_DEC * 0.114 > 186 ? '#000000' : '#FFFFFF';
        return CONTRAST_HEX;
    }
}
BsFontColorPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFontColorPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
BsFontColorPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFontColorPipe, name: "bsFontColor" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFontColorPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'bsFontColor'
                }]
        }] });

class BsFontColorPipeModule {
}
BsFontColorPipeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFontColorPipeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsFontColorPipeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFontColorPipeModule, declarations: [BsFontColorPipe], imports: [CommonModule], exports: [BsFontColorPipe] });
BsFontColorPipeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFontColorPipeModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: BsFontColorPipeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsFontColorPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsFontColorPipe
                    ]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsAccordionComponent, BsAccordionModule, BsAccordionTabComponent, BsAccordionTabHeaderComponent, BsAlertCloseComponent, BsAlertComponent, BsAlertModule, BsButtonTemplateDirective, BsCalendarComponent, BsCalendarModule, BsCardComponent, BsCardHeaderComponent, BsCardModule, BsCarouselComponent, BsCarouselImageDirective, BsCarouselModule, BsCodeSnippetComponent, BsCodeSnippetModule, BsContextMenuDirective, BsContextMenuModule, BsCopyDirective, BsCopyModule, BsDatatableColumnDirective, BsDatatableComponent, BsDatatableModule, BsDatepickerComponent, BsDatepickerModule, BsDropdownDirective, BsDropdownMenuDirective, BsDropdownModule, BsDropdownToggleDirective, BsExpandButtonDirective, BsFileUploadComponent, BsFileUploadModule, BsFileUploadTemplateDirective, BsFontColorPipe, BsFontColorPipeModule, BsFooterTemplateDirective, BsForDirective, BsForModule, BsFormatBytesModule, BsFormatBytesPipe, BsHeaderTemplateDirective, BsItemTemplateDirective, BsListGroupComponent, BsListGroupItemComponent, BsListGroupModule, BsModalBodyDirective, BsModalComponent, BsModalContentComponent, BsModalFooterDirective, BsModalHeaderDirective, BsModalModule, BsModalService, BsMultiselectComponent, BsMultiselectModule, BsNavbarBrandComponent, BsNavbarComponent, BsNavbarDropdownComponent, BsNavbarItemComponent, BsNavbarModule, BsNavbarNavComponent, BsNavbarTogglerComponent, BsOffcanvasBodyComponent, BsOffcanvasCloseDirective, BsOffcanvasComponent, BsOffcanvasHeaderComponent, BsOffcanvasModule, BsOffcanvasService, BsPaginationComponent, BsPaginationModule, BsProgressBarComponent, BsProgressBarModule, BsProgressComponent, BsRatingComponent, BsRatingModule, BsRowTemplateDirective, BsSchedulerComponent, BsSchedulerModule, BsScrollspyComponent, BsScrollspyDirective, BsScrollspyModule, BsSelect2Component, BsSelect2Module, BsSnackbarCloseDirective, BsSnackbarComponent, BsSnackbarModule, BsSnackbarService, BsTabControlComponent, BsTabControlModule, BsTabPageComponent, BsTimepickerComponent, BsTimepickerModule, BsToggleButtonComponent, BsToggleButtonModule, BsTooltipDirective, BsTooltipModule, BsTypeaheadComponent, BsTypeaheadModule, Color, DatatableSettings, DropdownToggleDirective, ESchedulerMode, NavLinkDirective, NavbarContentDirective, Position, ResourceGroupPresenterComponent, availableScales };
//# sourceMappingURL=mintplayer-ng-bootstrap.mjs.map
